((typeof self !== 'undefined' ? self : this)["webpackJsonpsystem_management"] = (typeof self !== 'undefined' ? self : this)["webpackJsonpsystem_management"] || []).push([[14],{

/***/ "0eb6":
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var $ = __webpack_require__("23e7");
var getBuiltIn = __webpack_require__("d066");
var getBuiltInNodeModule = __webpack_require__("2a07");
var fails = __webpack_require__("d039");
var create = __webpack_require__("7c73");
var createPropertyDescriptor = __webpack_require__("5c6c");
var defineProperty = __webpack_require__("9bf2").f;
var defineBuiltIn = __webpack_require__("cb2d");
var defineBuiltInAccessor = __webpack_require__("edd0");
var hasOwn = __webpack_require__("1a2d");
var anInstance = __webpack_require__("19aa");
var anObject = __webpack_require__("825a");
var errorToString = __webpack_require__("aa1f");
var normalizeStringArgument = __webpack_require__("e391");
var DOMExceptionConstants = __webpack_require__("cf98");
var clearErrorStack = __webpack_require__("0d26");
var InternalStateModule = __webpack_require__("69f3");
var DESCRIPTORS = __webpack_require__("83ab");
var IS_PURE = __webpack_require__("c430");

var DOM_EXCEPTION = 'DOMException';
var DATA_CLONE_ERR = 'DATA_CLONE_ERR';
var Error = getBuiltIn('Error');
// NodeJS < 17.0 does not expose `DOMException` to global
var NativeDOMException = getBuiltIn(DOM_EXCEPTION) || (function () {
  try {
    // NodeJS < 15.0 does not expose `MessageChannel` to global
    var MessageChannel = getBuiltIn('MessageChannel') || getBuiltInNodeModule('worker_threads').MessageChannel;
    // eslint-disable-next-line es/no-weak-map, unicorn/require-post-message-target-origin -- safe
    new MessageChannel().port1.postMessage(new WeakMap());
  } catch (error) {
    if (error.name === DATA_CLONE_ERR && error.code === 25) return error.constructor;
  }
})();
var NativeDOMExceptionPrototype = NativeDOMException && NativeDOMException.prototype;
var ErrorPrototype = Error.prototype;
var setInternalState = InternalStateModule.set;
var getInternalState = InternalStateModule.getterFor(DOM_EXCEPTION);
var HAS_STACK = 'stack' in new Error(DOM_EXCEPTION);

var codeFor = function (name) {
  return hasOwn(DOMExceptionConstants, name) && DOMExceptionConstants[name].m ? DOMExceptionConstants[name].c : 0;
};

var $DOMException = function DOMException() {
  anInstance(this, DOMExceptionPrototype);
  var argumentsLength = arguments.length;
  var message = normalizeStringArgument(argumentsLength < 1 ? undefined : arguments[0]);
  var name = normalizeStringArgument(argumentsLength < 2 ? undefined : arguments[1], 'Error');
  var code = codeFor(name);
  setInternalState(this, {
    type: DOM_EXCEPTION,
    name: name,
    message: message,
    code: code
  });
  if (!DESCRIPTORS) {
    this.name = name;
    this.message = message;
    this.code = code;
  }
  if (HAS_STACK) {
    var error = new Error(message);
    error.name = DOM_EXCEPTION;
    defineProperty(this, 'stack', createPropertyDescriptor(1, clearErrorStack(error.stack, 1)));
  }
};

var DOMExceptionPrototype = $DOMException.prototype = create(ErrorPrototype);

var createGetterDescriptor = function (get) {
  return { enumerable: true, configurable: true, get: get };
};

var getterFor = function (key) {
  return createGetterDescriptor(function () {
    return getInternalState(this)[key];
  });
};

if (DESCRIPTORS) {
  // `DOMException.prototype.code` getter
  defineBuiltInAccessor(DOMExceptionPrototype, 'code', getterFor('code'));
  // `DOMException.prototype.message` getter
  defineBuiltInAccessor(DOMExceptionPrototype, 'message', getterFor('message'));
  // `DOMException.prototype.name` getter
  defineBuiltInAccessor(DOMExceptionPrototype, 'name', getterFor('name'));
}

defineProperty(DOMExceptionPrototype, 'constructor', createPropertyDescriptor(1, $DOMException));

// FF36- DOMException is a function, but can't be constructed
var INCORRECT_CONSTRUCTOR = fails(function () {
  return !(new NativeDOMException() instanceof Error);
});

// Safari 10.1 / Chrome 32- / IE8- DOMException.prototype.toString bugs
var INCORRECT_TO_STRING = INCORRECT_CONSTRUCTOR || fails(function () {
  return ErrorPrototype.toString !== errorToString || String(new NativeDOMException(1, 2)) !== '2: 1';
});

// Deno 1.6.3- DOMException.prototype.code just missed
var INCORRECT_CODE = INCORRECT_CONSTRUCTOR || fails(function () {
  return new NativeDOMException(1, 'DataCloneError').code !== 25;
});

// Deno 1.6.3- DOMException constants just missed
var MISSED_CONSTANTS = INCORRECT_CONSTRUCTOR
  || NativeDOMException[DATA_CLONE_ERR] !== 25
  || NativeDOMExceptionPrototype[DATA_CLONE_ERR] !== 25;

var FORCED_CONSTRUCTOR = IS_PURE ? INCORRECT_TO_STRING || INCORRECT_CODE || MISSED_CONSTANTS : INCORRECT_CONSTRUCTOR;

// `DOMException` constructor
// https://webidl.spec.whatwg.org/#idl-DOMException
$({ global: true, constructor: true, forced: FORCED_CONSTRUCTOR }, {
  DOMException: FORCED_CONSTRUCTOR ? $DOMException : NativeDOMException
});

var PolyfilledDOMException = getBuiltIn(DOM_EXCEPTION);
var PolyfilledDOMExceptionPrototype = PolyfilledDOMException.prototype;

if (INCORRECT_TO_STRING && (IS_PURE || NativeDOMException === PolyfilledDOMException)) {
  defineBuiltIn(PolyfilledDOMExceptionPrototype, 'toString', errorToString);
}

if (INCORRECT_CODE && DESCRIPTORS && NativeDOMException === PolyfilledDOMException) {
  defineBuiltInAccessor(PolyfilledDOMExceptionPrototype, 'code', createGetterDescriptor(function () {
    return codeFor(anObject(this).name);
  }));
}

// `DOMException` constants
for (var key in DOMExceptionConstants) if (hasOwn(DOMExceptionConstants, key)) {
  var constant = DOMExceptionConstants[key];
  var constantName = constant.s;
  var descriptor = createPropertyDescriptor(6, constant.c);
  if (!hasOwn(PolyfilledDOMException, constantName)) {
    defineProperty(PolyfilledDOMException, constantName, descriptor);
  }
  if (!hasOwn(PolyfilledDOMExceptionPrototype, constantName)) {
    defineProperty(PolyfilledDOMExceptionPrototype, constantName, descriptor);
  }
}


/***/ }),

/***/ "1276":
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var call = __webpack_require__("c65b");
var uncurryThis = __webpack_require__("e330");
var fixRegExpWellKnownSymbolLogic = __webpack_require__("d784");
var anObject = __webpack_require__("825a");
var isNullOrUndefined = __webpack_require__("7234");
var requireObjectCoercible = __webpack_require__("1d80");
var speciesConstructor = __webpack_require__("4840");
var advanceStringIndex = __webpack_require__("8aa5");
var toLength = __webpack_require__("50c4");
var toString = __webpack_require__("577e");
var getMethod = __webpack_require__("dc4a");
var regExpExec = __webpack_require__("14c3");
var stickyHelpers = __webpack_require__("9f7f");
var fails = __webpack_require__("d039");

var UNSUPPORTED_Y = stickyHelpers.UNSUPPORTED_Y;
var MAX_UINT32 = 0xFFFFFFFF;
var min = Math.min;
var push = uncurryThis([].push);
var stringSlice = uncurryThis(''.slice);

// Chrome 51 has a buggy "split" implementation when RegExp#exec !== nativeExec
// Weex JS has frozen built-in prototypes, so use try / catch wrapper
var SPLIT_WORKS_WITH_OVERWRITTEN_EXEC = !fails(function () {
  // eslint-disable-next-line regexp/no-empty-group -- required for testing
  var re = /(?:)/;
  var originalExec = re.exec;
  re.exec = function () { return originalExec.apply(this, arguments); };
  var result = 'ab'.split(re);
  return result.length !== 2 || result[0] !== 'a' || result[1] !== 'b';
});

var BUGGY = 'abbc'.split(/(b)*/)[1] === 'c' ||
  // eslint-disable-next-line regexp/no-empty-group -- required for testing
  'test'.split(/(?:)/, -1).length !== 4 ||
  'ab'.split(/(?:ab)*/).length !== 2 ||
  '.'.split(/(.?)(.?)/).length !== 4 ||
  // eslint-disable-next-line regexp/no-empty-capturing-group, regexp/no-empty-group -- required for testing
  '.'.split(/()()/).length > 1 ||
  ''.split(/.?/).length;

// @@split logic
fixRegExpWellKnownSymbolLogic('split', function (SPLIT, nativeSplit, maybeCallNative) {
  var internalSplit = '0'.split(undefined, 0).length ? function (separator, limit) {
    return separator === undefined && limit === 0 ? [] : call(nativeSplit, this, separator, limit);
  } : nativeSplit;

  return [
    // `String.prototype.split` method
    // https://tc39.es/ecma262/#sec-string.prototype.split
    function split(separator, limit) {
      var O = requireObjectCoercible(this);
      var splitter = isNullOrUndefined(separator) ? undefined : getMethod(separator, SPLIT);
      return splitter
        ? call(splitter, separator, O, limit)
        : call(internalSplit, toString(O), separator, limit);
    },
    // `RegExp.prototype[@@split]` method
    // https://tc39.es/ecma262/#sec-regexp.prototype-@@split
    //
    // NOTE: This cannot be properly polyfilled in engines that don't support
    // the 'y' flag.
    function (string, limit) {
      var rx = anObject(this);
      var S = toString(string);

      if (!BUGGY) {
        var res = maybeCallNative(internalSplit, rx, S, limit, internalSplit !== nativeSplit);
        if (res.done) return res.value;
      }

      var C = speciesConstructor(rx, RegExp);
      var unicodeMatching = rx.unicode;
      var flags = (rx.ignoreCase ? 'i' : '') +
                  (rx.multiline ? 'm' : '') +
                  (rx.unicode ? 'u' : '') +
                  (UNSUPPORTED_Y ? 'g' : 'y');
      // ^(? + rx + ) is needed, in combination with some S slicing, to
      // simulate the 'y' flag.
      var splitter = new C(UNSUPPORTED_Y ? '^(?:' + rx.source + ')' : rx, flags);
      var lim = limit === undefined ? MAX_UINT32 : limit >>> 0;
      if (lim === 0) return [];
      if (S.length === 0) return regExpExec(splitter, S) === null ? [S] : [];
      var p = 0;
      var q = 0;
      var A = [];
      while (q < S.length) {
        splitter.lastIndex = UNSUPPORTED_Y ? 0 : q;
        var z = regExpExec(splitter, UNSUPPORTED_Y ? stringSlice(S, q) : S);
        var e;
        if (
          z === null ||
          (e = min(toLength(splitter.lastIndex + (UNSUPPORTED_Y ? q : 0)), S.length)) === p
        ) {
          q = advanceStringIndex(S, q, unicodeMatching);
        } else {
          push(A, stringSlice(S, p, q));
          if (A.length === lim) return A;
          for (var i = 1; i <= z.length - 1; i++) {
            push(A, z[i]);
            if (A.length === lim) return A;
          }
          q = p = e;
        }
      }
      push(A, stringSlice(S, p));
      return A;
    }
  ];
}, BUGGY || !SPLIT_WORKS_WITH_OVERWRITTEN_EXEC, UNSUPPORTED_Y);


/***/ }),

/***/ "2a07":
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var globalThis = __webpack_require__("cfe9");
var IS_NODE = __webpack_require__("9adc");

module.exports = function (name) {
  if (IS_NODE) {
    try {
      return globalThis.process.getBuiltinModule(name);
    } catch (error) { /* empty */ }
    try {
      // eslint-disable-next-line no-new-func -- safe
      return Function('return require("' + name + '")')();
    } catch (error) { /* empty */ }
  }
};


/***/ }),

/***/ "2c3e":
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var DESCRIPTORS = __webpack_require__("83ab");
var MISSED_STICKY = __webpack_require__("9f7f").MISSED_STICKY;
var classof = __webpack_require__("c6b6");
var defineBuiltInAccessor = __webpack_require__("edd0");
var getInternalState = __webpack_require__("69f3").get;

var RegExpPrototype = RegExp.prototype;
var $TypeError = TypeError;

// `RegExp.prototype.sticky` getter
// https://tc39.es/ecma262/#sec-get-regexp.prototype.sticky
if (DESCRIPTORS && MISSED_STICKY) {
  defineBuiltInAccessor(RegExpPrototype, 'sticky', {
    configurable: true,
    get: function sticky() {
      if (this === RegExpPrototype) return;
      // We can't use InternalStateModule.getterFor because
      // we don't add metadata for regexps created by a literal.
      if (classof(this) === 'RegExp') {
        return !!getInternalState(this).sticky;
      }
      throw new $TypeError('Incompatible receiver, RegExp required');
    }
  });
}


/***/ }),

/***/ "313d":
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var $ = __webpack_require__("23e7");
var globalThis = __webpack_require__("cfe9");
var getBuiltIn = __webpack_require__("d066");
var uncurryThis = __webpack_require__("e330");
var call = __webpack_require__("c65b");
var fails = __webpack_require__("d039");
var toString = __webpack_require__("577e");
var validateArgumentsLength = __webpack_require__("d6d6");
var i2c = __webpack_require__("b917").i2c;

var $btoa = getBuiltIn('btoa');
var charAt = uncurryThis(''.charAt);
var charCodeAt = uncurryThis(''.charCodeAt);

var BASIC = !!$btoa && !fails(function () {
  return $btoa('hi') !== 'aGk=';
});

var NO_ARG_RECEIVING_CHECK = BASIC && !fails(function () {
  $btoa();
});

var WRONG_ARG_CONVERSION = BASIC && fails(function () {
  return $btoa(null) !== 'bnVsbA==';
});

var WRONG_ARITY = BASIC && $btoa.length !== 1;

// `btoa` method
// https://html.spec.whatwg.org/multipage/webappapis.html#dom-btoa
$({ global: true, bind: true, enumerable: true, forced: !BASIC || NO_ARG_RECEIVING_CHECK || WRONG_ARG_CONVERSION || WRONG_ARITY }, {
  btoa: function btoa(data) {
    validateArgumentsLength(arguments.length, 1);
    // `webpack` dev server bug on IE global methods - use call(fn, global, ...)
    if (BASIC) return call($btoa, globalThis, toString(data));
    var string = toString(data);
    var output = '';
    var position = 0;
    var map = i2c;
    var block, charCode;
    while (charAt(string, position) || (map = '=', position % 1)) {
      charCode = charCodeAt(string, position += 3 / 4);
      if (charCode > 0xFF) {
        throw new (getBuiltIn('DOMException'))('The string contains characters outside of the Latin1 range', 'InvalidCharacterError');
      }
      block = block << 8 | charCode;
      output += charAt(map, 63 & block >> 8 - position % 1 * 8);
    } return output;
  }
});


/***/ }),

/***/ "3262":
/***/ (function(module, exports, __webpack_require__) {

var _typeof = __webpack_require__("7037").default;
__webpack_require__("d9e2");
__webpack_require__("a15b");
__webpack_require__("14d9");
__webpack_require__("fb6a");
__webpack_require__("b0c0");
__webpack_require__("e9c4");
__webpack_require__("b64b");
__webpack_require__("d3b7");
__webpack_require__("ac1f");
__webpack_require__("00b4");
__webpack_require__("25f0");
__webpack_require__("5319");
__webpack_require__("1276");
__webpack_require__("498a");
__webpack_require__("313d");
__webpack_require__("159b");
__webpack_require__("0eb6");
__webpack_require__("b7ef");
__webpack_require__("8bd4");
__webpack_require__("c73d");
/**
 * Root reference for iframes.
 */

var root;
if (typeof window !== 'undefined') {
  // Browser window
  root = window;
} else if (typeof self !== 'undefined') {
  // Web Worker
  root = self;
} else {
  // Other environments
  console.warn("Using browser-only version of superagent in non-browser environment");
  root = this;
}
var Emitter = __webpack_require__("7297");
var RequestBase = __webpack_require__("34b2");
var isObject = __webpack_require__("b6b6");
var ResponseBase = __webpack_require__("8cd3");
var shouldRetry = __webpack_require__("e0c9");

/**
 * Noop.
 */

function noop() {}
;

/**
 * Expose `request`.
 */

var request = exports = module.exports = function (method, url) {
  // callback
  if ('function' == typeof url) {
    return new exports.Request('GET', method).end(url);
  }

  // url first
  if (1 == arguments.length) {
    return new exports.Request('GET', method);
  }
  return new exports.Request(method, url);
};
exports.Request = Request;

/**
 * Determine XHR.
 */

request.getXHR = function () {
  if (root.XMLHttpRequest && (!root.location || 'file:' != root.location.protocol || !root.ActiveXObject)) {
    return new XMLHttpRequest();
  } else {
    try {
      return new ActiveXObject('Microsoft.XMLHTTP');
    } catch (e) {}
    try {
      return new ActiveXObject('Msxml2.XMLHTTP.6.0');
    } catch (e) {}
    try {
      return new ActiveXObject('Msxml2.XMLHTTP.3.0');
    } catch (e) {}
    try {
      return new ActiveXObject('Msxml2.XMLHTTP');
    } catch (e) {}
  }
  throw Error("Browser-only version of superagent could not find XHR");
};

/**
 * Removes leading and trailing whitespace, added to support IE.
 *
 * @param {String} s
 * @return {String}
 * @api private
 */

var trim = ''.trim ? function (s) {
  return s.trim();
} : function (s) {
  return s.replace(/(^\s*|\s*$)/g, '');
};

/**
 * Serialize the given `obj`.
 *
 * @param {Object} obj
 * @return {String}
 * @api private
 */

function serialize(obj) {
  if (!isObject(obj)) return obj;
  var pairs = [];
  for (var key in obj) {
    pushEncodedKeyValuePair(pairs, key, obj[key]);
  }
  return pairs.join('&');
}

/**
 * Helps 'serialize' with serializing arrays.
 * Mutates the pairs array.
 *
 * @param {Array} pairs
 * @param {String} key
 * @param {Mixed} val
 */

function pushEncodedKeyValuePair(pairs, key, val) {
  if (val != null) {
    if (Array.isArray(val)) {
      val.forEach(function (v) {
        pushEncodedKeyValuePair(pairs, key, v);
      });
    } else if (isObject(val)) {
      for (var subkey in val) {
        pushEncodedKeyValuePair(pairs, key + '[' + subkey + ']', val[subkey]);
      }
    } else {
      pairs.push(encodeURIComponent(key) + '=' + encodeURIComponent(val));
    }
  } else if (val === null) {
    pairs.push(encodeURIComponent(key));
  }
}

/**
 * Expose serialization method.
 */

request.serializeObject = serialize;

/**
 * Parse the given x-www-form-urlencoded `str`.
 *
 * @param {String} str
 * @return {Object}
 * @api private
 */

function parseString(str) {
  var obj = {};
  var pairs = str.split('&');
  var pair;
  var pos;
  for (var i = 0, len = pairs.length; i < len; ++i) {
    pair = pairs[i];
    pos = pair.indexOf('=');
    if (pos == -1) {
      obj[decodeURIComponent(pair)] = '';
    } else {
      obj[decodeURIComponent(pair.slice(0, pos))] = decodeURIComponent(pair.slice(pos + 1));
    }
  }
  return obj;
}

/**
 * Expose parser.
 */

request.parseString = parseString;

/**
 * Default MIME type map.
 *
 *     superagent.types.xml = 'application/xml';
 *
 */

request.types = {
  html: 'text/html',
  json: 'application/json',
  xml: 'text/xml',
  urlencoded: 'application/x-www-form-urlencoded',
  'form': 'application/x-www-form-urlencoded',
  'form-data': 'application/x-www-form-urlencoded'
};

/**
 * Default serialization map.
 *
 *     superagent.serialize['application/xml'] = function(obj){
 *       return 'generated xml here';
 *     };
 *
 */

request.serialize = {
  'application/x-www-form-urlencoded': serialize,
  'application/json': JSON.stringify
};

/**
 * Default parsers.
 *
 *     superagent.parse['application/xml'] = function(str){
 *       return { object parsed from str };
 *     };
 *
 */

request.parse = {
  'application/x-www-form-urlencoded': parseString,
  'application/json': JSON.parse
};

/**
 * Parse the given header `str` into
 * an object containing the mapped fields.
 *
 * @param {String} str
 * @return {Object}
 * @api private
 */

function parseHeader(str) {
  var lines = str.split(/\r?\n/);
  var fields = {};
  var index;
  var line;
  var field;
  var val;
  for (var i = 0, len = lines.length; i < len; ++i) {
    line = lines[i];
    index = line.indexOf(':');
    if (index === -1) {
      // could be empty line, just skip it
      continue;
    }
    field = line.slice(0, index).toLowerCase();
    val = trim(line.slice(index + 1));
    fields[field] = val;
  }
  return fields;
}

/**
 * Check if `mime` is json or has +json structured syntax suffix.
 *
 * @param {String} mime
 * @return {Boolean}
 * @api private
 */

function isJSON(mime) {
  return /[\/+]json\b/.test(mime);
}

/**
 * Initialize a new `Response` with the given `xhr`.
 *
 *  - set flags (.ok, .error, etc)
 *  - parse header
 *
 * Examples:
 *
 *  Aliasing `superagent` as `request` is nice:
 *
 *      request = superagent;
 *
 *  We can use the promise-like API, or pass callbacks:
 *
 *      request.get('/').end(function(res){});
 *      request.get('/', function(res){});
 *
 *  Sending data can be chained:
 *
 *      request
 *        .post('/user')
 *        .send({ name: 'tj' })
 *        .end(function(res){});
 *
 *  Or passed to `.send()`:
 *
 *      request
 *        .post('/user')
 *        .send({ name: 'tj' }, function(res){});
 *
 *  Or passed to `.post()`:
 *
 *      request
 *        .post('/user', { name: 'tj' })
 *        .end(function(res){});
 *
 * Or further reduced to a single call for simple cases:
 *
 *      request
 *        .post('/user', { name: 'tj' }, function(res){});
 *
 * @param {XMLHTTPRequest} xhr
 * @param {Object} options
 * @api private
 */

function Response(req) {
  this.req = req;
  this.xhr = this.req.xhr;
  // responseText is accessible only if responseType is '' or 'text' and on older browsers
  this.text = this.req.method != 'HEAD' && (this.xhr.responseType === '' || this.xhr.responseType === 'text') || typeof this.xhr.responseType === 'undefined' ? this.xhr.responseText : null;
  this.statusText = this.req.xhr.statusText;
  var status = this.xhr.status;
  // handle IE9 bug: http://stackoverflow.com/questions/10046972/msie-returns-status-code-of-1223-for-ajax-request
  if (status === 1223) {
    status = 204;
  }
  this._setStatusProperties(status);
  this.header = this.headers = parseHeader(this.xhr.getAllResponseHeaders());
  // getAllResponseHeaders sometimes falsely returns "" for CORS requests, but
  // getResponseHeader still works. so we get content-type even if getting
  // other headers fails.
  this.header['content-type'] = this.xhr.getResponseHeader('content-type');
  this._setHeaderProperties(this.header);
  if (null === this.text && req._responseType) {
    this.body = this.xhr.response;
  } else {
    this.body = this.req.method != 'HEAD' ? this._parseBody(this.text ? this.text : this.xhr.response) : null;
  }
}
ResponseBase(Response.prototype);

/**
 * Parse the given body `str`.
 *
 * Used for auto-parsing of bodies. Parsers
 * are defined on the `superagent.parse` object.
 *
 * @param {String} str
 * @return {Mixed}
 * @api private
 */

Response.prototype._parseBody = function (str) {
  var parse = request.parse[this.type];
  if (this.req._parser) {
    return this.req._parser(this, str);
  }
  if (!parse && isJSON(this.type)) {
    parse = request.parse['application/json'];
  }
  return parse && str && (str.length || str instanceof Object) ? parse(str) : null;
};

/**
 * Return an `Error` representative of this response.
 *
 * @return {Error}
 * @api public
 */

Response.prototype.toError = function () {
  var req = this.req;
  var method = req.method;
  var url = req.url;
  var msg = 'cannot ' + method + ' ' + url + ' (' + this.status + ')';
  var err = new Error(msg);
  err.status = this.status;
  err.method = method;
  err.url = url;
  return err;
};

/**
 * Expose `Response`.
 */

request.Response = Response;

/**
 * Initialize a new `Request` with the given `method` and `url`.
 *
 * @param {String} method
 * @param {String} url
 * @api public
 */

function Request(method, url) {
  var self = this;
  this._query = this._query || [];
  this.method = method;
  this.url = url;
  this.header = {}; // preserves header name case
  this._header = {}; // coerces header names to lowercase
  this.on('end', function () {
    var err = null;
    var res = null;
    try {
      res = new Response(self);
    } catch (e) {
      err = new Error('Parser is unable to parse the response');
      err.parse = true;
      err.original = e;
      // issue #675: return the raw response if the response parsing fails
      if (self.xhr) {
        // ie9 doesn't have 'response' property
        err.rawResponse = typeof self.xhr.responseType == 'undefined' ? self.xhr.responseText : self.xhr.response;
        // issue #876: return the http status code if the response parsing fails
        err.status = self.xhr.status ? self.xhr.status : null;
        err.statusCode = err.status; // backwards-compat only
      } else {
        err.rawResponse = null;
        err.status = null;
      }
      return self.callback(err);
    }
    self.emit('response', res);
    var new_err;
    try {
      if (!self._isResponseOK(res)) {
        new_err = new Error(res.statusText || 'Unsuccessful HTTP response');
      }
    } catch (custom_err) {
      new_err = custom_err; // ok() callback can throw
    }

    // #1000 don't catch errors from the callback to avoid double calling it
    if (new_err) {
      new_err.original = err;
      new_err.response = res;
      new_err.status = res.status;
      self.callback(new_err, res);
    } else {
      self.callback(null, res);
    }
  });
}

/**
 * Mixin `Emitter` and `RequestBase`.
 */

Emitter(Request.prototype);
RequestBase(Request.prototype);

/**
 * Set Content-Type to `type`, mapping values from `request.types`.
 *
 * Examples:
 *
 *      superagent.types.xml = 'application/xml';
 *
 *      request.post('/')
 *        .type('xml')
 *        .send(xmlstring)
 *        .end(callback);
 *
 *      request.post('/')
 *        .type('application/xml')
 *        .send(xmlstring)
 *        .end(callback);
 *
 * @param {String} type
 * @return {Request} for chaining
 * @api public
 */

Request.prototype.type = function (type) {
  this.set('Content-Type', request.types[type] || type);
  return this;
};

/**
 * Set Accept to `type`, mapping values from `request.types`.
 *
 * Examples:
 *
 *      superagent.types.json = 'application/json';
 *
 *      request.get('/agent')
 *        .accept('json')
 *        .end(callback);
 *
 *      request.get('/agent')
 *        .accept('application/json')
 *        .end(callback);
 *
 * @param {String} accept
 * @return {Request} for chaining
 * @api public
 */

Request.prototype.accept = function (type) {
  this.set('Accept', request.types[type] || type);
  return this;
};

/**
 * Set Authorization field value with `user` and `pass`.
 *
 * @param {String} user
 * @param {String} [pass] optional in case of using 'bearer' as type
 * @param {Object} options with 'type' property 'auto', 'basic' or 'bearer' (default 'basic')
 * @return {Request} for chaining
 * @api public
 */

Request.prototype.auth = function (user, pass, options) {
  if (_typeof(pass) === 'object' && pass !== null) {
    // pass is optional and can substitute for options
    options = pass;
  }
  if (!options) {
    options = {
      type: 'function' === typeof btoa ? 'basic' : 'auto'
    };
  }
  switch (options.type) {
    case 'basic':
      this.set('Authorization', 'Basic ' + btoa(user + ':' + pass));
      break;
    case 'auto':
      this.username = user;
      this.password = pass;
      break;
    case 'bearer':
      // usage would be .auth(accessToken, { type: 'bearer' })
      this.set('Authorization', 'Bearer ' + user);
      break;
  }
  return this;
};

/**
 * Add query-string `val`.
 *
 * Examples:
 *
 *   request.get('/shoes')
 *     .query('size=10')
 *     .query({ color: 'blue' })
 *
 * @param {Object|String} val
 * @return {Request} for chaining
 * @api public
 */

Request.prototype.query = function (val) {
  if ('string' != typeof val) val = serialize(val);
  if (val) this._query.push(val);
  return this;
};

/**
 * Queue the given `file` as an attachment to the specified `field`,
 * with optional `options` (or filename).
 *
 * ``` js
 * request.post('/upload')
 *   .attach('content', new Blob(['<a id="a"><b id="b">hey!</b></a>'], { type: "text/html"}))
 *   .end(callback);
 * ```
 *
 * @param {String} field
 * @param {Blob|File} file
 * @param {String|Object} options
 * @return {Request} for chaining
 * @api public
 */

Request.prototype.attach = function (field, file, options) {
  if (file) {
    if (this._data) {
      throw Error("superagent can't mix .send() and .attach()");
    }
    this._getFormData().append(field, file, options || file.name);
  }
  return this;
};
Request.prototype._getFormData = function () {
  if (!this._formData) {
    this._formData = new root.FormData();
  }
  return this._formData;
};

/**
 * Invoke the callback with `err` and `res`
 * and handle arity check.
 *
 * @param {Error} err
 * @param {Response} res
 * @api private
 */

Request.prototype.callback = function (err, res) {
  // console.log(this._retries, this._maxRetries)
  if (this._maxRetries && this._retries++ < this._maxRetries && shouldRetry(err, res)) {
    return this._retry();
  }
  var fn = this._callback;
  this.clearTimeout();
  if (err) {
    if (this._maxRetries) err.retries = this._retries - 1;
    this.emit('error', err);
  }
  fn(err, res);
};

/**
 * Invoke callback with x-domain error.
 *
 * @api private
 */

Request.prototype.crossDomainError = function () {
  var err = new Error('Request has been terminated\nPossible causes: the network is offline, Origin is not allowed by Access-Control-Allow-Origin, the page is being unloaded, etc.');
  err.crossDomain = true;
  err.status = this.status;
  err.method = this.method;
  err.url = this.url;
  this.callback(err);
};

// This only warns, because the request is still likely to work
Request.prototype.buffer = Request.prototype.ca = Request.prototype.agent = function () {
  console.warn("This is not supported in browser version of superagent");
  return this;
};

// This throws, because it can't send/receive data as expected
Request.prototype.pipe = Request.prototype.write = function () {
  throw Error("Streaming is not supported in browser version of superagent");
};

/**
 * Check if `obj` is a host object,
 * we don't want to serialize these :)
 *
 * @param {Object} obj
 * @return {Boolean}
 * @api private
 */
Request.prototype._isHost = function _isHost(obj) {
  // Native objects stringify to [object File], [object Blob], [object FormData], etc.
  return obj && 'object' === _typeof(obj) && !Array.isArray(obj) && Object.prototype.toString.call(obj) !== '[object Object]';
};

/**
 * Initiate request, invoking callback `fn(res)`
 * with an instanceof `Response`.
 *
 * @param {Function} fn
 * @return {Request} for chaining
 * @api public
 */

Request.prototype.end = function (fn) {
  if (this._endCalled) {
    console.warn("Warning: .end() was called twice. This is not supported in superagent");
  }
  this._endCalled = true;

  // store callback
  this._callback = fn || noop;

  // querystring
  this._finalizeQueryString();
  return this._end();
};
Request.prototype._end = function () {
  var self = this;
  var xhr = this.xhr = request.getXHR();
  var data = this._formData || this._data;
  this._setTimeouts();

  // state change
  xhr.onreadystatechange = function () {
    var readyState = xhr.readyState;
    if (readyState >= 2 && self._responseTimeoutTimer) {
      clearTimeout(self._responseTimeoutTimer);
    }
    if (4 != readyState) {
      return;
    }

    // In IE9, reads to any property (e.g. status) off of an aborted XHR will
    // result in the error "Could not complete the operation due to error c00c023f"
    var status;
    try {
      status = xhr.status;
    } catch (e) {
      status = 0;
    }
    if (!status) {
      if (self.timedout || self._aborted) return;
      return self.crossDomainError();
    }
    self.emit('end');
  };

  // progress
  var handleProgress = function handleProgress(direction, e) {
    if (e.total > 0) {
      e.percent = e.loaded / e.total * 100;
    }
    e.direction = direction;
    self.emit('progress', e);
  };
  if (this.hasListeners('progress')) {
    try {
      xhr.onprogress = handleProgress.bind(null, 'download');
      if (xhr.upload) {
        xhr.upload.onprogress = handleProgress.bind(null, 'upload');
      }
    } catch (e) {
      // Accessing xhr.upload fails in IE from a web worker, so just pretend it doesn't exist.
      // Reported here:
      // https://connect.microsoft.com/IE/feedback/details/837245/xmlhttprequest-upload-throws-invalid-argument-when-used-from-web-worker-context
    }
  }

  // initiate request
  try {
    if (this.username && this.password) {
      xhr.open(this.method, this.url, true, this.username, this.password);
    } else {
      xhr.open(this.method, this.url, true);
    }
  } catch (err) {
    // see #1149
    return this.callback(err);
  }

  // CORS
  if (this._withCredentials) xhr.withCredentials = true;

  // body
  if (!this._formData && 'GET' != this.method && 'HEAD' != this.method && 'string' != typeof data && !this._isHost(data)) {
    // serialize stuff
    var contentType = this._header['content-type'];
    var serialize = this._serializer || request.serialize[contentType ? contentType.split(';')[0] : ''];
    if (!serialize && isJSON(contentType)) {
      serialize = request.serialize['application/json'];
    }
    if (serialize) data = serialize(data);
  }

  // set header fields
  for (var field in this.header) {
    if (null == this.header[field]) continue;
    if (this.header.hasOwnProperty(field)) xhr.setRequestHeader(field, this.header[field]);
  }
  if (this._responseType) {
    xhr.responseType = this._responseType;
  }

  // send stuff
  this.emit('request', this);

  // IE11 xhr.send(undefined) sends 'undefined' string as POST payload (instead of nothing)
  // We need null here if data is undefined
  xhr.send(typeof data !== 'undefined' ? data : null);
  return this;
};

/**
 * GET `url` with optional callback `fn(res)`.
 *
 * @param {String} url
 * @param {Mixed|Function} [data] or fn
 * @param {Function} [fn]
 * @return {Request}
 * @api public
 */

request.get = function (url, data, fn) {
  var req = request('GET', url);
  if ('function' == typeof data) fn = data, data = null;
  if (data) req.query(data);
  if (fn) req.end(fn);
  return req;
};

/**
 * HEAD `url` with optional callback `fn(res)`.
 *
 * @param {String} url
 * @param {Mixed|Function} [data] or fn
 * @param {Function} [fn]
 * @return {Request}
 * @api public
 */

request.head = function (url, data, fn) {
  var req = request('HEAD', url);
  if ('function' == typeof data) fn = data, data = null;
  if (data) req.query(data);
  if (fn) req.end(fn);
  return req;
};

/**
 * OPTIONS query to `url` with optional callback `fn(res)`.
 *
 * @param {String} url
 * @param {Mixed|Function} [data] or fn
 * @param {Function} [fn]
 * @return {Request}
 * @api public
 */

request.options = function (url, data, fn) {
  var req = request('OPTIONS', url);
  if ('function' == typeof data) fn = data, data = null;
  if (data) req.send(data);
  if (fn) req.end(fn);
  return req;
};

/**
 * DELETE `url` with optional `data` and callback `fn(res)`.
 *
 * @param {String} url
 * @param {Mixed} [data]
 * @param {Function} [fn]
 * @return {Request}
 * @api public
 */

function del(url, data, fn) {
  var req = request('DELETE', url);
  if ('function' == typeof data) fn = data, data = null;
  if (data) req.send(data);
  if (fn) req.end(fn);
  return req;
}
;
request['del'] = del;
request['delete'] = del;

/**
 * PATCH `url` with optional `data` and callback `fn(res)`.
 *
 * @param {String} url
 * @param {Mixed} [data]
 * @param {Function} [fn]
 * @return {Request}
 * @api public
 */

request.patch = function (url, data, fn) {
  var req = request('PATCH', url);
  if ('function' == typeof data) fn = data, data = null;
  if (data) req.send(data);
  if (fn) req.end(fn);
  return req;
};

/**
 * POST `url` with optional `data` and callback `fn(res)`.
 *
 * @param {String} url
 * @param {Mixed} [data]
 * @param {Function} [fn]
 * @return {Request}
 * @api public
 */

request.post = function (url, data, fn) {
  var req = request('POST', url);
  if ('function' == typeof data) fn = data, data = null;
  if (data) req.send(data);
  if (fn) req.end(fn);
  return req;
};

/**
 * PUT `url` with optional `data` and callback `fn(res)`.
 *
 * @param {String} url
 * @param {Mixed|Function} [data] or fn
 * @param {Function} [fn]
 * @return {Request}
 * @api public
 */

request.put = function (url, data, fn) {
  var req = request('PUT', url);
  if ('function' == typeof data) fn = data, data = null;
  if (data) req.send(data);
  if (fn) req.end(fn);
  return req;
};

/***/ }),

/***/ "3361":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/**
 * Return the mime type for the given `str`.
 *
 * @param {String} str
 * @return {String}
 * @api private
 */
__webpack_require__("fb6a");
__webpack_require__("d3b7");
__webpack_require__("ac1f");
__webpack_require__("1276");
exports.type = function (str) {
  return str.split(/ *; */).shift();
};

/**
 * Return header field parameters.
 *
 * @param {String} str
 * @return {Object}
 * @api private
 */

exports.params = function (str) {
  return str.split(/ *; */).reduce(function (obj, str) {
    var parts = str.split(/ *= */);
    var key = parts.shift();
    var val = parts.shift();
    if (key && val) obj[key] = val;
    return obj;
  }, {});
};

/**
 * Parse Link header fields.
 *
 * @param {String} str
 * @return {Object}
 * @api private
 */

exports.parseLinks = function (str) {
  return str.split(/ *, */).reduce(function (obj, str) {
    var parts = str.split(/ *; */);
    var url = parts[0].slice(1, -1);
    var rel = parts[1].split(/ *= */)[1].slice(1, -1);
    obj[rel] = url;
    return obj;
  }, {});
};

/**
 * Strip content related fields from `header`.
 *
 * @param {Object} header
 * @return {Object} header
 * @api private
 */

exports.cleanHeader = function (header, shouldStripCookie) {
  delete header['content-type'];
  delete header['content-length'];
  delete header['transfer-encoding'];
  delete header['host'];
  if (shouldStripCookie) {
    delete header['cookie'];
  }
  return header;
};

/***/ }),

/***/ "34b2":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/**
 * Module of mixed-in functions shared between node and client code
 */
var _typeof = __webpack_require__("7037").default;
__webpack_require__("d9e2");
__webpack_require__("a15b");
__webpack_require__("4e82");
__webpack_require__("d3b7");
__webpack_require__("e6cf");
var isObject = __webpack_require__("b6b6");

/**
 * Expose `RequestBase`.
 */

module.exports = RequestBase;

/**
 * Initialize a new `RequestBase`.
 *
 * @api public
 */

function RequestBase(obj) {
  if (obj) return mixin(obj);
}

/**
 * Mixin the prototype properties.
 *
 * @param {Object} obj
 * @return {Object}
 * @api private
 */

function mixin(obj) {
  for (var key in RequestBase.prototype) {
    obj[key] = RequestBase.prototype[key];
  }
  return obj;
}

/**
 * Clear previous timeout.
 *
 * @return {Request} for chaining
 * @api public
 */

RequestBase.prototype.clearTimeout = function _clearTimeout() {
  clearTimeout(this._timer);
  clearTimeout(this._responseTimeoutTimer);
  delete this._timer;
  delete this._responseTimeoutTimer;
  return this;
};

/**
 * Override default response body parser
 *
 * This function will be called to convert incoming data into request.body
 *
 * @param {Function}
 * @api public
 */

RequestBase.prototype.parse = function parse(fn) {
  this._parser = fn;
  return this;
};

/**
 * Set format of binary response body.
 * In browser valid formats are 'blob' and 'arraybuffer',
 * which return Blob and ArrayBuffer, respectively.
 *
 * In Node all values result in Buffer.
 *
 * Examples:
 *
 *      req.get('/')
 *        .responseType('blob')
 *        .end(callback);
 *
 * @param {String} val
 * @return {Request} for chaining
 * @api public
 */

RequestBase.prototype.responseType = function (val) {
  this._responseType = val;
  return this;
};

/**
 * Override default request body serializer
 *
 * This function will be called to convert data set via .send or .attach into payload to send
 *
 * @param {Function}
 * @api public
 */

RequestBase.prototype.serialize = function serialize(fn) {
  this._serializer = fn;
  return this;
};

/**
 * Set timeouts.
 *
 * - response timeout is time between sending request and receiving the first byte of the response. Includes DNS and connection time.
 * - deadline is the time from start of the request to receiving response body in full. If the deadline is too short large files may not load at all on slow connections.
 *
 * Value of 0 or false means no timeout.
 *
 * @param {Number|Object} ms or {response, deadline}
 * @return {Request} for chaining
 * @api public
 */

RequestBase.prototype.timeout = function timeout(options) {
  if (!options || 'object' !== _typeof(options)) {
    this._timeout = options;
    this._responseTimeout = 0;
    return this;
  }
  for (var option in options) {
    switch (option) {
      case 'deadline':
        this._timeout = options.deadline;
        break;
      case 'response':
        this._responseTimeout = options.response;
        break;
      default:
        console.warn("Unknown timeout option", option);
    }
  }
  return this;
};

/**
 * Set number of retry attempts on error.
 *
 * Failed requests will be retried 'count' times if timeout or err.code >= 500.
 *
 * @param {Number} count
 * @return {Request} for chaining
 * @api public
 */

RequestBase.prototype.retry = function retry(count) {
  // Default to 1 if no count passed or true
  if (arguments.length === 0 || count === true) count = 1;
  if (count <= 0) count = 0;
  this._maxRetries = count;
  this._retries = 0;
  return this;
};

/**
 * Retry request
 *
 * @return {Request} for chaining
 * @api private
 */

RequestBase.prototype._retry = function () {
  this.clearTimeout();

  // node
  if (this.req) {
    this.req = null;
    this.req = this.request();
  }
  this._aborted = false;
  this.timedout = false;
  return this._end();
};

/**
 * Promise support
 *
 * @param {Function} resolve
 * @param {Function} [reject]
 * @return {Request}
 */

RequestBase.prototype.then = function then(resolve, reject) {
  if (!this._fullfilledPromise) {
    var self = this;
    if (this._endCalled) {
      console.warn("Warning: superagent request was sent twice, because both .end() and .then() were called. Never call .end() if you use promises");
    }
    this._fullfilledPromise = new Promise(function (innerResolve, innerReject) {
      self.end(function (err, res) {
        if (err) innerReject(err);else innerResolve(res);
      });
    });
  }
  return this._fullfilledPromise.then(resolve, reject);
};
RequestBase.prototype.catch = function (cb) {
  return this.then(undefined, cb);
};

/**
 * Allow for extension
 */

RequestBase.prototype.use = function use(fn) {
  fn(this);
  return this;
};
RequestBase.prototype.ok = function (cb) {
  if ('function' !== typeof cb) throw Error("Callback required");
  this._okCallback = cb;
  return this;
};
RequestBase.prototype._isResponseOK = function (res) {
  if (!res) {
    return false;
  }
  if (this._okCallback) {
    return this._okCallback(res);
  }
  return res.status >= 200 && res.status < 300;
};

/**
 * Get request header `field`.
 * Case-insensitive.
 *
 * @param {String} field
 * @return {String}
 * @api public
 */

RequestBase.prototype.get = function (field) {
  return this._header[field.toLowerCase()];
};

/**
 * Get case-insensitive header `field` value.
 * This is a deprecated internal API. Use `.get(field)` instead.
 *
 * (getHeader is no longer used internally by the superagent code base)
 *
 * @param {String} field
 * @return {String}
 * @api private
 * @deprecated
 */

RequestBase.prototype.getHeader = RequestBase.prototype.get;

/**
 * Set header `field` to `val`, or multiple fields with one object.
 * Case-insensitive.
 *
 * Examples:
 *
 *      req.get('/')
 *        .set('Accept', 'application/json')
 *        .set('X-API-Key', 'foobar')
 *        .end(callback);
 *
 *      req.get('/')
 *        .set({ Accept: 'application/json', 'X-API-Key': 'foobar' })
 *        .end(callback);
 *
 * @param {String|Object} field
 * @param {String} val
 * @return {Request} for chaining
 * @api public
 */

RequestBase.prototype.set = function (field, val) {
  if (isObject(field)) {
    for (var key in field) {
      this.set(key, field[key]);
    }
    return this;
  }
  this._header[field.toLowerCase()] = val;
  this.header[field] = val;
  return this;
};

/**
 * Remove header `field`.
 * Case-insensitive.
 *
 * Example:
 *
 *      req.get('/')
 *        .unset('User-Agent')
 *        .end(callback);
 *
 * @param {String} field
 */
RequestBase.prototype.unset = function (field) {
  delete this._header[field.toLowerCase()];
  delete this.header[field];
  return this;
};

/**
 * Write the field `name` and `val`, or multiple fields with one object
 * for "multipart/form-data" request bodies.
 *
 * ``` js
 * request.post('/upload')
 *   .field('foo', 'bar')
 *   .end(callback);
 *
 * request.post('/upload')
 *   .field({ foo: 'bar', baz: 'qux' })
 *   .end(callback);
 * ```
 *
 * @param {String|Object} name
 * @param {String|Blob|File|Buffer|fs.ReadStream} val
 * @return {Request} for chaining
 * @api public
 */
RequestBase.prototype.field = function (name, val) {
  // name should be either a string or an object.
  if (null === name || undefined === name) {
    throw new Error('.field(name, val) name can not be empty');
  }
  if (this._data) {
    console.error(".field() can't be used if .send() is used. Please use only .send() or only .field() & .attach()");
  }
  if (isObject(name)) {
    for (var key in name) {
      this.field(key, name[key]);
    }
    return this;
  }
  if (Array.isArray(val)) {
    for (var i in val) {
      this.field(name, val[i]);
    }
    return this;
  }

  // val should be defined now
  if (null === val || undefined === val) {
    throw new Error('.field(name, val) val can not be empty');
  }
  if ('boolean' === typeof val) {
    val = '' + val;
  }
  this._getFormData().append(name, val);
  return this;
};

/**
 * Abort the request, and clear potential timeout.
 *
 * @return {Request}
 * @api public
 */
RequestBase.prototype.abort = function () {
  if (this._aborted) {
    return this;
  }
  this._aborted = true;
  this.xhr && this.xhr.abort(); // browser
  this.req && this.req.abort(); // node
  this.clearTimeout();
  this.emit('abort');
  return this;
};

/**
 * Enable transmission of cookies with x-domain requests.
 *
 * Note that for this to work the origin must not be
 * using "Access-Control-Allow-Origin" with a wildcard,
 * and also must set "Access-Control-Allow-Credentials"
 * to "true".
 *
 * @api public
 */

RequestBase.prototype.withCredentials = function (on) {
  // This is browser-only functionality. Node side is no-op.
  if (on == undefined) on = true;
  this._withCredentials = on;
  return this;
};

/**
 * Set the max redirects to `n`. Does noting in browser XHR implementation.
 *
 * @param {Number} n
 * @return {Request} for chaining
 * @api public
 */

RequestBase.prototype.redirects = function (n) {
  this._maxRedirects = n;
  return this;
};

/**
 * Maximum size of buffered response body, in bytes. Counts uncompressed size.
 * Default 200MB.
 *
 * @param {Number} n
 * @return {Request} for chaining
 */
RequestBase.prototype.maxResponseSize = function (n) {
  if ('number' !== typeof n) {
    throw TypeError("Invalid argument");
  }
  this._maxResponseSize = n;
  return this;
};

/**
 * Convert to a plain javascript object (not JSON string) of scalar properties.
 * Note as this method is designed to return a useful non-this value,
 * it cannot be chained.
 *
 * @return {Object} describing method, url, and data of this request
 * @api public
 */

RequestBase.prototype.toJSON = function () {
  return {
    method: this.method,
    url: this.url,
    data: this._data,
    headers: this._header
  };
};

/**
 * Send `data` as the request body, defaulting the `.type()` to "json" when
 * an object is given.
 *
 * Examples:
 *
 *       // manual json
 *       request.post('/user')
 *         .type('json')
 *         .send('{"name":"tj"}')
 *         .end(callback)
 *
 *       // auto json
 *       request.post('/user')
 *         .send({ name: 'tj' })
 *         .end(callback)
 *
 *       // manual x-www-form-urlencoded
 *       request.post('/user')
 *         .type('form')
 *         .send('name=tj')
 *         .end(callback)
 *
 *       // auto x-www-form-urlencoded
 *       request.post('/user')
 *         .type('form')
 *         .send({ name: 'tj' })
 *         .end(callback)
 *
 *       // defaults to x-www-form-urlencoded
 *      request.post('/user')
 *        .send('name=tobi')
 *        .send('species=ferret')
 *        .end(callback)
 *
 * @param {String|Object} data
 * @return {Request} for chaining
 * @api public
 */

RequestBase.prototype.send = function (data) {
  var isObj = isObject(data);
  var type = this._header['content-type'];
  if (this._formData) {
    console.error(".send() can't be used if .attach() or .field() is used. Please use only .send() or only .field() & .attach()");
  }
  if (isObj && !this._data) {
    if (Array.isArray(data)) {
      this._data = [];
    } else if (!this._isHost(data)) {
      this._data = {};
    }
  } else if (data && this._data && this._isHost(this._data)) {
    throw Error("Can't merge these send calls");
  }

  // merge
  if (isObj && isObject(this._data)) {
    for (var key in data) {
      this._data[key] = data[key];
    }
  } else if ('string' == typeof data) {
    // default to x-www-form-urlencoded
    if (!type) this.type('form');
    type = this._header['content-type'];
    if ('application/x-www-form-urlencoded' == type) {
      this._data = this._data ? this._data + '&' + data : data;
    } else {
      this._data = (this._data || '') + data;
    }
  } else {
    this._data = data;
  }
  if (!isObj || this._isHost(data)) {
    return this;
  }

  // default to json
  if (!type) this.type('json');
  return this;
};

/**
 * Sort `querystring` by the sort function
 *
 *
 * Examples:
 *
 *       // default order
 *       request.get('/user')
 *         .query('name=Nick')
 *         .query('search=Manny')
 *         .sortQuery()
 *         .end(callback)
 *
 *       // customized sort function
 *       request.get('/user')
 *         .query('name=Nick')
 *         .query('search=Manny')
 *         .sortQuery(function(a, b){
 *           return a.length - b.length;
 *         })
 *         .end(callback)
 *
 *
 * @param {Function} sort
 * @return {Request} for chaining
 * @api public
 */

RequestBase.prototype.sortQuery = function (sort) {
  // _sort default to true but otherwise can be a function or boolean
  this._sort = typeof sort === 'undefined' ? true : sort;
  return this;
};

/**
 * Compose querystring to append to req.url
 *
 * @api private
 */
RequestBase.prototype._finalizeQueryString = function () {
  var query = this._query.join('&');
  if (query) {
    this.url += (this.url.indexOf('?') >= 0 ? '&' : '?') + query;
  }
  this._query.length = 0; // Makes the call idempotent

  if (this._sort) {
    var index = this.url.indexOf('?');
    if (index >= 0) {
      var queryArr = this.url.substring(index + 1).split('&');
      if ('function' === typeof this._sort) {
        queryArr.sort(this._sort);
      } else {
        queryArr.sort();
      }
      this.url = this.url.substring(0, index) + '?' + queryArr.join('&');
    }
  }
};

// For backwards compat only
RequestBase.prototype._appendQueryString = function () {
  console.trace("Unsupported");
};

/**
 * Invoke callback with timeout error.
 *
 * @api private
 */

RequestBase.prototype._timeoutError = function (reason, timeout, errno) {
  if (this._aborted) {
    return;
  }
  var err = new Error(reason + timeout + 'ms exceeded');
  err.timeout = timeout;
  err.code = 'ECONNABORTED';
  err.errno = errno;
  this.timedout = true;
  this.abort();
  this.callback(err);
};
RequestBase.prototype._setTimeouts = function () {
  var self = this;

  // deadline
  if (this._timeout && !this._timer) {
    this._timer = setTimeout(function () {
      self._timeoutError('Timeout of ', self._timeout, 'ETIME');
    }, this._timeout);
  }
  // response timeout
  if (this._responseTimeout && !this._responseTimeoutTimer) {
    this._responseTimeoutTimer = setTimeout(function () {
      self._timeoutError('Response timeout of ', self._responseTimeout, 'ETIMEDOUT');
    }, this._responseTimeout);
  }
};

/***/ }),

/***/ "44e7":
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var isObject = __webpack_require__("861d");
var classof = __webpack_require__("c6b6");
var wellKnownSymbol = __webpack_require__("b622");

var MATCH = wellKnownSymbol('match');

// `IsRegExp` abstract operation
// https://tc39.es/ecma262/#sec-isregexp
module.exports = function (it) {
  var isRegExp;
  return isObject(it) && ((isRegExp = it[MATCH]) !== undefined ? !!isRegExp : classof(it) === 'RegExp');
};


/***/ }),

/***/ "498a":
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var $ = __webpack_require__("23e7");
var $trim = __webpack_require__("58a8").trim;
var forcedStringTrimMethod = __webpack_require__("c8d2");

// `String.prototype.trim` method
// https://tc39.es/ecma262/#sec-string.prototype.trim
$({ target: 'String', proto: true, forced: forcedStringTrimMethod('trim') }, {
  trim: function trim() {
    return $trim(this);
  }
});


/***/ }),

/***/ "4d63":
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var DESCRIPTORS = __webpack_require__("83ab");
var globalThis = __webpack_require__("cfe9");
var uncurryThis = __webpack_require__("e330");
var isForced = __webpack_require__("94ca");
var inheritIfRequired = __webpack_require__("7156");
var createNonEnumerableProperty = __webpack_require__("9112");
var create = __webpack_require__("7c73");
var getOwnPropertyNames = __webpack_require__("241c").f;
var isPrototypeOf = __webpack_require__("3a9b");
var isRegExp = __webpack_require__("44e7");
var toString = __webpack_require__("577e");
var getRegExpFlags = __webpack_require__("90d8");
var stickyHelpers = __webpack_require__("9f7f");
var proxyAccessor = __webpack_require__("aeb0");
var defineBuiltIn = __webpack_require__("cb2d");
var fails = __webpack_require__("d039");
var hasOwn = __webpack_require__("1a2d");
var enforceInternalState = __webpack_require__("69f3").enforce;
var setSpecies = __webpack_require__("2626");
var wellKnownSymbol = __webpack_require__("b622");
var UNSUPPORTED_DOT_ALL = __webpack_require__("fce3");
var UNSUPPORTED_NCG = __webpack_require__("107c");

var MATCH = wellKnownSymbol('match');
var NativeRegExp = globalThis.RegExp;
var RegExpPrototype = NativeRegExp.prototype;
var SyntaxError = globalThis.SyntaxError;
var exec = uncurryThis(RegExpPrototype.exec);
var charAt = uncurryThis(''.charAt);
var replace = uncurryThis(''.replace);
var stringIndexOf = uncurryThis(''.indexOf);
var stringSlice = uncurryThis(''.slice);
// TODO: Use only proper RegExpIdentifierName
var IS_NCG = /^\?<[^\s\d!#%&*+<=>@^][^\s!#%&*+<=>@^]*>/;
var re1 = /a/g;
var re2 = /a/g;

// "new" should create a new object, old webkit bug
var CORRECT_NEW = new NativeRegExp(re1) !== re1;

var MISSED_STICKY = stickyHelpers.MISSED_STICKY;
var UNSUPPORTED_Y = stickyHelpers.UNSUPPORTED_Y;

var BASE_FORCED = DESCRIPTORS &&
  (!CORRECT_NEW || MISSED_STICKY || UNSUPPORTED_DOT_ALL || UNSUPPORTED_NCG || fails(function () {
    re2[MATCH] = false;
    // RegExp constructor can alter flags and IsRegExp works correct with @@match
    // eslint-disable-next-line sonar/inconsistent-function-call -- required for testing
    return NativeRegExp(re1) !== re1 || NativeRegExp(re2) === re2 || String(NativeRegExp(re1, 'i')) !== '/a/i';
  }));

var handleDotAll = function (string) {
  var length = string.length;
  var index = 0;
  var result = '';
  var brackets = false;
  var chr;
  for (; index <= length; index++) {
    chr = charAt(string, index);
    if (chr === '\\') {
      result += chr + charAt(string, ++index);
      continue;
    }
    if (!brackets && chr === '.') {
      result += '[\\s\\S]';
    } else {
      if (chr === '[') {
        brackets = true;
      } else if (chr === ']') {
        brackets = false;
      } result += chr;
    }
  } return result;
};

var handleNCG = function (string) {
  var length = string.length;
  var index = 0;
  var result = '';
  var named = [];
  var names = create(null);
  var brackets = false;
  var ncg = false;
  var groupid = 0;
  var groupname = '';
  var chr;
  for (; index <= length; index++) {
    chr = charAt(string, index);
    if (chr === '\\') {
      chr += charAt(string, ++index);
    } else if (chr === ']') {
      brackets = false;
    } else if (!brackets) switch (true) {
      case chr === '[':
        brackets = true;
        break;
      case chr === '(':
        result += chr;
        // ignore non-capturing groups
        if (stringSlice(string, index + 1, index + 3) === '?:') {
          continue;
        }
        if (exec(IS_NCG, stringSlice(string, index + 1))) {
          index += 2;
          ncg = true;
        }
        groupid++;
        continue;
      case chr === '>' && ncg:
        if (groupname === '' || hasOwn(names, groupname)) {
          throw new SyntaxError('Invalid capture group name');
        }
        names[groupname] = true;
        named[named.length] = [groupname, groupid];
        ncg = false;
        groupname = '';
        continue;
    }
    if (ncg) groupname += chr;
    else result += chr;
  } return [result, named];
};

// `RegExp` constructor
// https://tc39.es/ecma262/#sec-regexp-constructor
if (isForced('RegExp', BASE_FORCED)) {
  var RegExpWrapper = function RegExp(pattern, flags) {
    var thisIsRegExp = isPrototypeOf(RegExpPrototype, this);
    var patternIsRegExp = isRegExp(pattern);
    var flagsAreUndefined = flags === undefined;
    var groups = [];
    var rawPattern = pattern;
    var rawFlags, dotAll, sticky, handled, result, state;

    if (!thisIsRegExp && patternIsRegExp && flagsAreUndefined && pattern.constructor === RegExpWrapper) {
      return pattern;
    }

    if (patternIsRegExp || isPrototypeOf(RegExpPrototype, pattern)) {
      pattern = pattern.source;
      if (flagsAreUndefined) flags = getRegExpFlags(rawPattern);
    }

    pattern = pattern === undefined ? '' : toString(pattern);
    flags = flags === undefined ? '' : toString(flags);
    rawPattern = pattern;

    if (UNSUPPORTED_DOT_ALL && 'dotAll' in re1) {
      dotAll = !!flags && stringIndexOf(flags, 's') > -1;
      if (dotAll) flags = replace(flags, /s/g, '');
    }

    rawFlags = flags;

    if (MISSED_STICKY && 'sticky' in re1) {
      sticky = !!flags && stringIndexOf(flags, 'y') > -1;
      if (sticky && UNSUPPORTED_Y) flags = replace(flags, /y/g, '');
    }

    if (UNSUPPORTED_NCG) {
      handled = handleNCG(pattern);
      pattern = handled[0];
      groups = handled[1];
    }

    result = inheritIfRequired(NativeRegExp(pattern, flags), thisIsRegExp ? this : RegExpPrototype, RegExpWrapper);

    if (dotAll || sticky || groups.length) {
      state = enforceInternalState(result);
      if (dotAll) {
        state.dotAll = true;
        state.raw = RegExpWrapper(handleDotAll(pattern), rawFlags);
      }
      if (sticky) state.sticky = true;
      if (groups.length) state.groups = groups;
    }

    if (pattern !== rawPattern) try {
      // fails in old engines, but we have no alternatives for unsupported regex syntax
      createNonEnumerableProperty(result, 'source', rawPattern === '' ? '(?:)' : rawPattern);
    } catch (error) { /* empty */ }

    return result;
  };

  for (var keys = getOwnPropertyNames(NativeRegExp), index = 0; keys.length > index;) {
    proxyAccessor(RegExpWrapper, NativeRegExp, keys[index++]);
  }

  RegExpPrototype.constructor = RegExpWrapper;
  RegExpWrapper.prototype = RegExpPrototype;
  defineBuiltIn(globalThis, 'RegExp', RegExpWrapper, { constructor: true });
}

// https://tc39.es/ecma262/#sec-get-regexp-@@species
setSpecies('RegExp');


/***/ }),

/***/ "5530":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";

// EXPORTS
__webpack_require__.d(__webpack_exports__, "a", function() { return /* binding */ _objectSpread2; });

// EXTERNAL MODULE: ./node_modules/core-js/modules/es.symbol.js
var es_symbol = __webpack_require__("a4d3");

// EXTERNAL MODULE: ./node_modules/core-js/modules/es.array.filter.js
var es_array_filter = __webpack_require__("4de4");

// EXTERNAL MODULE: ./node_modules/core-js/modules/es.array.push.js
var es_array_push = __webpack_require__("14d9");

// EXTERNAL MODULE: ./node_modules/core-js/modules/es.object.get-own-property-descriptor.js
var es_object_get_own_property_descriptor = __webpack_require__("e439");

// EXTERNAL MODULE: ./node_modules/core-js/modules/es.object.get-own-property-descriptors.js
var es_object_get_own_property_descriptors = __webpack_require__("dbb4");

// EXTERNAL MODULE: ./node_modules/core-js/modules/es.object.keys.js
var es_object_keys = __webpack_require__("b64b");

// EXTERNAL MODULE: ./node_modules/core-js/modules/es.object.to-string.js
var es_object_to_string = __webpack_require__("d3b7");

// EXTERNAL MODULE: ./node_modules/core-js/modules/web.dom-collections.for-each.js
var web_dom_collections_for_each = __webpack_require__("159b");

// EXTERNAL MODULE: ./node_modules/@babel/runtime/helpers/esm/typeof.js
var esm_typeof = __webpack_require__("53ca");

// EXTERNAL MODULE: ./node_modules/core-js/modules/es.symbol.to-primitive.js
var es_symbol_to_primitive = __webpack_require__("8172");

// EXTERNAL MODULE: ./node_modules/core-js/modules/es.error.cause.js
var es_error_cause = __webpack_require__("d9e2");

// EXTERNAL MODULE: ./node_modules/core-js/modules/es.date.to-primitive.js
var es_date_to_primitive = __webpack_require__("efec");

// EXTERNAL MODULE: ./node_modules/core-js/modules/es.number.constructor.js
var es_number_constructor = __webpack_require__("a9e3");

// CONCATENATED MODULE: ./node_modules/@babel/runtime/helpers/esm/toPrimitive.js





function toPrimitive(t, r) {
  if ("object" != Object(esm_typeof["a" /* default */])(t) || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r || "default");
    if ("object" != Object(esm_typeof["a" /* default */])(i)) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}

// CONCATENATED MODULE: ./node_modules/@babel/runtime/helpers/esm/toPropertyKey.js


function toPropertyKey(t) {
  var i = toPrimitive(t, "string");
  return "symbol" == Object(esm_typeof["a" /* default */])(i) ? i : i + "";
}

// CONCATENATED MODULE: ./node_modules/@babel/runtime/helpers/esm/defineProperty.js

function _defineProperty(e, r, t) {
  return (r = toPropertyKey(r)) in e ? Object.defineProperty(e, r, {
    value: t,
    enumerable: !0,
    configurable: !0,
    writable: !0
  }) : e[r] = t, e;
}

// CONCATENATED MODULE: ./node_modules/@babel/runtime/helpers/esm/objectSpread2.js









function ownKeys(e, r) {
  var t = Object.keys(e);
  if (Object.getOwnPropertySymbols) {
    var o = Object.getOwnPropertySymbols(e);
    r && (o = o.filter(function (r) {
      return Object.getOwnPropertyDescriptor(e, r).enumerable;
    })), t.push.apply(t, o);
  }
  return t;
}
function _objectSpread2(e) {
  for (var r = 1; r < arguments.length; r++) {
    var t = null != arguments[r] ? arguments[r] : {};
    r % 2 ? ownKeys(Object(t), !0).forEach(function (r) {
      _defineProperty(e, r, t[r]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) {
      Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r));
    });
  }
  return e;
}


/***/ }),

/***/ "8bd4":
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var getBuiltIn = __webpack_require__("d066");
var setToStringTag = __webpack_require__("d44e");

var DOM_EXCEPTION = 'DOMException';

// `DOMException.prototype[@@toStringTag]` property
setToStringTag(getBuiltIn(DOM_EXCEPTION), DOM_EXCEPTION);


/***/ }),

/***/ "8cd3":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/**
 * Module dependencies.
 */
__webpack_require__("9911");
var utils = __webpack_require__("3361");

/**
 * Expose `ResponseBase`.
 */

module.exports = ResponseBase;

/**
 * Initialize a new `ResponseBase`.
 *
 * @api public
 */

function ResponseBase(obj) {
  if (obj) return mixin(obj);
}

/**
 * Mixin the prototype properties.
 *
 * @param {Object} obj
 * @return {Object}
 * @api private
 */

function mixin(obj) {
  for (var key in ResponseBase.prototype) {
    obj[key] = ResponseBase.prototype[key];
  }
  return obj;
}

/**
 * Get case-insensitive `field` value.
 *
 * @param {String} field
 * @return {String}
 * @api public
 */

ResponseBase.prototype.get = function (field) {
  return this.header[field.toLowerCase()];
};

/**
 * Set header related properties:
 *
 *   - `.type` the content type without params
 *
 * A response of "Content-Type: text/plain; charset=utf-8"
 * will provide you with a `.type` of "text/plain".
 *
 * @param {Object} header
 * @api private
 */

ResponseBase.prototype._setHeaderProperties = function (header) {
  // TODO: moar!
  // TODO: make this a util

  // content-type
  var ct = header['content-type'] || '';
  this.type = utils.type(ct);

  // params
  var params = utils.params(ct);
  for (var key in params) this[key] = params[key];
  this.links = {};

  // links
  try {
    if (header.link) {
      this.links = utils.parseLinks(header.link);
    }
  } catch (err) {
    // ignore
  }
};

/**
 * Set flags such as `.ok` based on `status`.
 *
 * For example a 2xx response will give you a `.ok` of __true__
 * whereas 5xx will be __false__ and `.error` will be __true__. The
 * `.clientError` and `.serverError` are also available to be more
 * specific, and `.statusType` is the class of error ranging from 1..5
 * sometimes useful for mapping respond colors etc.
 *
 * "sugar" properties are also defined for common cases. Currently providing:
 *
 *   - .noContent
 *   - .badRequest
 *   - .unauthorized
 *   - .notAcceptable
 *   - .notFound
 *
 * @param {Number} status
 * @api private
 */

ResponseBase.prototype._setStatusProperties = function (status) {
  var type = status / 100 | 0;

  // status / class
  this.status = this.statusCode = status;
  this.statusType = type;

  // basics
  this.info = 1 == type;
  this.ok = 2 == type;
  this.redirect = 3 == type;
  this.clientError = 4 == type;
  this.serverError = 5 == type;
  this.error = 4 == type || 5 == type ? this.toError() : false;

  // sugar
  this.accepted = 202 == status;
  this.noContent = 204 == status;
  this.badRequest = 400 == status;
  this.unauthorized = 401 == status;
  this.notAcceptable = 406 == status;
  this.forbidden = 403 == status;
  this.notFound = 404 == status;
};

/***/ }),

/***/ "93f7":
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(Buffer, module) {var __WEBPACK_AMD_DEFINE_FACTORY__, __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;var _classCallCheck = __webpack_require__("970b").default;
var _createClass = __webpack_require__("5bc3").default;
var _typeof = __webpack_require__("7037").default;
__webpack_require__("a4d3");
__webpack_require__("e01a");
__webpack_require__("944a");
__webpack_require__("d9e2");
__webpack_require__("4de4");
__webpack_require__("caad");
__webpack_require__("a15b");
__webpack_require__("d81d");
__webpack_require__("b0c0");
__webpack_require__("6c57");
__webpack_require__("0c47");
__webpack_require__("23dc");
__webpack_require__("b64b");
__webpack_require__("d3b7");
__webpack_require__("e6cf");
__webpack_require__("ac1f");
__webpack_require__("25f0");
__webpack_require__("466d");
__webpack_require__("5319");
__webpack_require__("159b");
__webpack_require__("c73d");
(function (a, N) {
  ( false ? undefined : _typeof(exports)) == "object" && ( false ? undefined : _typeof(module)) < "u" ? N(exports, __webpack_require__("db82")) :  true ? !(__WEBPACK_AMD_DEFINE_ARRAY__ = [exports, __webpack_require__("db82")], __WEBPACK_AMD_DEFINE_FACTORY__ = (N),
				__WEBPACK_AMD_DEFINE_RESULT__ = (typeof __WEBPACK_AMD_DEFINE_FACTORY__ === 'function' ?
				(__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__)) : __WEBPACK_AMD_DEFINE_FACTORY__),
				__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__)) : (undefined);
})(this, function (a, N) {
  "use strict";

  var _e = Object.defineProperty;
  var Ve = function Ve(a, N, n) {
    return N in a ? _e(a, N, {
      enumerable: !0,
      configurable: !0,
      writable: !0,
      value: n
    }) : a[N] = n;
  };
  var D = function D(a, N, n) {
    return Ve(a, _typeof(N) != "symbol" ? N + "" : N, n), n;
  };
  var C = /*#__PURE__*/function () {
    function C() {
      _classCallCheck(this, C);
      this.basePath = "/".replace(/\/+$/, ""), this.authentications = {
        oauth2: {
          type: "oauth2"
        }
      }, this.defaultHeaders = {}, this.timeout = 6e4, this.cache = !0, this.enableCookies = !1, (typeof window === "undefined" ? "undefined" : _typeof(window)) > "u" && (this.agent = new N.agent()), this.requestAgent = null;
    }
    return _createClass(C, [{
      key: "paramToString",
      value: function paramToString(e) {
        return e == null || e == null ? "" : e instanceof Date ? e.toJSON() : e.toString();
      }
    }, {
      key: "buildUrl",
      value: function buildUrl(e, t) {
        var _this = this;
        e.match(/^\//) || (e = "/" + e);
        var i = this.basePath + e;
        return i = i.replace(/\{([\w-]+)\}/g, function (r, o) {
          var s;
          return t.hasOwnProperty(o) ? s = _this.paramToString(t[o]) : s = r, encodeURIComponent(s);
        }), i;
      }
    }, {
      key: "isJsonMime",
      value: function isJsonMime(e) {
        return !!(e != null && e.match(/^application\/json(;.*)?$/i));
      }
    }, {
      key: "jsonPreferredMime",
      value: function jsonPreferredMime(e) {
        for (var t = 0; t < e.length; t++) if (this.isJsonMime(e[t])) return e[t];
        return e[0];
      }
    }, {
      key: "isFileParam",
      value: function isFileParam(e) {
        if (true) {
          var t;
          try {
            t = __webpack_require__(13);
          } catch (_unused) {}
          if (t && t.ReadStream && e instanceof t.ReadStream) return !0;
        }
        return typeof Buffer == "function" && e instanceof Buffer || typeof Blob == "function" && e instanceof Blob || typeof File == "function" && e instanceof File;
      }
    }, {
      key: "normalizeParams",
      value: function normalizeParams(e) {
        var t = {};
        for (var i in e) if (e.hasOwnProperty(i) && e[i] != null && e[i] != null) {
          var r = e[i];
          this.isFileParam(r) || Array.isArray(r) ? t[i] = r : t[i] = this.paramToString(r);
        }
        return t;
      }
    }, {
      key: "buildCollectionParam",
      value: function buildCollectionParam(e, t) {
        if (e == null) return null;
        switch (t) {
          case "csv":
            return e.map(this.paramToString).join(",");
          case "ssv":
            return e.map(this.paramToString).join(" ");
          case "tsv":
            return e.map(this.paramToString).join("	");
          case "pipes":
            return e.map(this.paramToString).join("|");
          case "multi":
            return e.map(this.paramToString);
          default:
            throw new Error("Unknown collection format: " + t);
        }
      }
    }, {
      key: "applyAuthToRequest",
      value: function applyAuthToRequest(e, t) {
        var _this2 = this;
        t.forEach(function (i) {
          var r = _this2.authentications[i];
          switch (r.type) {
            case "basic":
              (r.username || r.password) && e.auth(r.username || "", r.password || "");
              break;
            case "apiKey":
              if (r.apiKey) {
                var o = {};
                r.apiKeyPrefix ? o[r.name] = r.apiKeyPrefix + " " + r.apiKey : o[r.name] = r.apiKey, r.in === "header" ? e.set(o) : e.query(o);
              }
              break;
            case "oauth2":
              r.accessToken && e.set({
                Authorization: "Bearer " + r.accessToken
              });
              break;
            default:
              throw new Error("Unknown authentication type: " + r.type);
          }
        });
      }
    }, {
      key: "deserialize",
      value: function deserialize(e, t) {
        if (e == null || e.status == 204) return null;
        var i = e.body;
        if ((i == null || _typeof(i) == "object" && _typeof(i.length) > "u" && !Object.keys(i).length) && (i = e.text), t == null && ["easc3"].includes("auth-server")) return {
          data: i
        };
        var r = C.convertToType(i.data, t);
        return {
          code: i.code,
          data: r
        };
      }
    }, {
      key: "callApi",
      value: function callApi(e, t, i, r, o, s, p, c, l, y, S) {
        var _this3 = this;
        var we = this.buildUrl(e, i),
          I = N(t, we);
        this.applyAuthToRequest(I, c), t.toUpperCase() === "GET" && this.cache === !1 && (r._ = new Date().getTime()), I.query(this.normalizeParams(r)), I.set(this.defaultHeaders).set(this.normalizeParams(o)), this.requestAgent && I.agent(this.requestAgent), I.timeout(this.timeout);
        var he = this.jsonPreferredMime(l);
        if (he ? he != "multipart/form-data" && I.type(he) : I.header["Content-Type"] || I.type("application/json"), he === "application/x-www-form-urlencoded") I.send(C.stringify(this.normalizeParams(s)));else if (he == "multipart/form-data") {
          var Te = this.normalizeParams(s);
          for (var ae in Te) Te.hasOwnProperty(ae) && (this.isFileParam(Te[ae]) ? I.attach(ae, Te[ae]) : I.field(ae, Te[ae]));
        } else p && I.send(p);
        var Ue = this.jsonPreferredMime(y);
        return Ue && I.accept(Ue), S === "Blob" ? I.responseType("blob") : S === "String" && I.responseType("string"), this.enableCookies && ((typeof window === "undefined" ? "undefined" : _typeof(window)) > "u" ? this.agent.attachCookies(I) : I.withCredentials()), new Promise(function (Ge, Re) {
          I.end(function (We, Pe) {
            if (We) Re(We);else try {
              var Fe = _this3.deserialize(Pe, S);
              _this3.enableCookies && (typeof window === "undefined" ? "undefined" : _typeof(window)) > "u" && _this3.agent.saveCookies(Pe), Ge({
                data: Fe,
                response: Pe
              });
            } catch (ze) {
              Re(ze);
            }
          });
        });
      }
    }], [{
      key: "parseDate",
      value: function parseDate(e) {
        return new Date(e);
      }
    }, {
      key: "convertToType",
      value: function convertToType(e, t) {
        if (e == null) return e;
        switch (t) {
          case "Boolean":
            return !!e;
          case "Integer":
            return parseInt(e, 10);
          case "Number":
            return parseFloat(e);
          case "String":
            return String(e);
          case "Date":
            return C.parseDate(String(e));
          case "Blob":
            return e;
          default:
            if (t === Object) return e;
            if (typeof t == "function") return t.constructFromObject(e);
            if (Array.isArray(t)) {
              var i = t[0];
              return e.map(function (y) {
                return C.convertToType(y, i);
              });
            } else if (_typeof(t) == "object") {
              var r, o;
              for (var s in t) if (t.hasOwnProperty(s)) {
                r = s, o = t[s];
                break;
              }
              var p = {};
              for (var s in e) if (e.hasOwnProperty(s)) {
                var c = C.convertToType(s, r),
                  l = C.convertToType(e[s], o);
                p[c] = l;
              }
              return p;
            } else return e;
        }
      }
    }, {
      key: "constructFromObject",
      value: function constructFromObject(e, t, i) {
        if (Array.isArray(e)) for (var r = 0; r < e.length; r++) e.hasOwnProperty(r) && (t[r] = C.convertToType(e[r], i));else for (var o in e) e.hasOwnProperty(o) && (t[o] = C.convertToType(e[o], i));
      }
    }, {
      key: "GetInstance",
      value: function GetInstance(e, t) {
        return Wiz ? Wiz.GetApiClientInstance(e, t) : new C();
      }
    }, {
      key: "stringifyPrimitive",
      value: function stringifyPrimitive(e) {
        switch (_typeof(e)) {
          case "string":
            return e;
          case "boolean":
            return e ? "true" : "false";
          case "number":
            return isFinite(e) ? e : "";
          default:
            return "";
        }
      }
    }, {
      key: "stringify",
      value: function stringify(e, t, i, r) {
        return t = t || "&", i = i || "=", e === null && (e = void 0), _typeof(e) == "object" ? Object.keys(e).map(function (o) {
          var s = encodeURIComponent(C.stringifyPrimitive(o)) + i;
          return Array.isArray(e[o]) ? e[o].map(function (p) {
            return s + encodeURIComponent(C.stringifyPrimitive(p));
          }).join(t) : s + encodeURIComponent(C.stringifyPrimitive(e[o]));
        }).filter(Boolean).join(t) : r ? encodeURIComponent(C.stringifyPrimitive(r)) + i + encodeURIComponent(C.stringifyPrimitive(e)) : "";
      }
    }]);
  }();
  D(C, "CollectionFormatEnum", {
    CSV: ",",
    SSV: " ",
    TSV: "	",
    PIPES: "|",
    MULTI: "multi"
  });
  var n = C;
  var ge = {
    _1: 1,
    _2: 2,
    _3: 3,
    _4: 4,
    _5: 5,
    constructFromObject: function constructFromObject(O) {
      return O;
    }
  };
  var j = /*#__PURE__*/function () {
    function j() {
      _classCallCheck(this, j);
    }
    return _createClass(j, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new j(), e.hasOwnProperty("description") && (t.description = n.convertToType(e.description, "String")), e.hasOwnProperty("result") && (t.result = ge.constructFromObject(e.result))), t;
      }
    }]);
  }();
  j.prototype.description = void 0, j.prototype.result = void 0;
  var z = /*#__PURE__*/function () {
    function z() {
      _classCallCheck(this, z);
    }
    return _createClass(z, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new z(), e.hasOwnProperty("key") && (t.key = n.convertToType(e.key, "String")), e.hasOwnProperty("value") && (t.value = n.convertToType(e.value, "String"))), t;
      }
    }]);
  }();
  z.prototype.key = void 0, z.prototype.value = void 0;
  var g = /*#__PURE__*/function () {
    function g() {
      _classCallCheck(this, g);
    }
    return _createClass(g, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new g(), e.hasOwnProperty("creationTime") && (t.creationTime = n.convertToType(e.creationTime, "Date")), e.hasOwnProperty("creatorId") && (t.creatorId = n.convertToType(e.creatorId, "String")), e.hasOwnProperty("deleterId") && (t.deleterId = n.convertToType(e.deleterId, "String")), e.hasOwnProperty("deletionTime") && (t.deletionTime = n.convertToType(e.deletionTime, "Date")), e.hasOwnProperty("description") && (t.description = n.convertToType(e.description, "String")), e.hasOwnProperty("displayName") && (t.displayName = n.convertToType(e.displayName, "String")), e.hasOwnProperty("emphasize") && (t.emphasize = n.convertToType(e.emphasize, "Boolean")), e.hasOwnProperty("enabled") && (t.enabled = n.convertToType(e.enabled, "Boolean")), e.hasOwnProperty("id") && (t.id = n.convertToType(e.id, "String")), e.hasOwnProperty("isDeleted") && (t.isDeleted = n.convertToType(e.isDeleted, "Boolean")), e.hasOwnProperty("lastModificationTime") && (t.lastModificationTime = n.convertToType(e.lastModificationTime, "Date")), e.hasOwnProperty("lastModifierId") && (t.lastModifierId = n.convertToType(e.lastModifierId, "String")), e.hasOwnProperty("name") && (t.name = n.convertToType(e.name, "String")), e.hasOwnProperty("properties") && (t.properties = n.convertToType(e.properties, [z])), e.hasOwnProperty("required") && (t.required = n.convertToType(e.required, "Boolean")), e.hasOwnProperty("showInDiscoveryDocument") && (t.showInDiscoveryDocument = n.convertToType(e.showInDiscoveryDocument, "Boolean")), e.hasOwnProperty("userClaims") && (t.userClaims = n.convertToType(e.userClaims, ["String"]))), t;
      }
    }]);
  }();
  g.prototype.creationTime = void 0, g.prototype.creatorId = void 0, g.prototype.deleterId = void 0, g.prototype.deletionTime = void 0, g.prototype.description = void 0, g.prototype.displayName = void 0, g.prototype.emphasize = void 0, g.prototype.enabled = void 0, g.prototype.id = void 0, g.prototype.isDeleted = void 0, g.prototype.lastModificationTime = void 0, g.prototype.lastModifierId = void 0, g.prototype.name = void 0, g.prototype.properties = void 0, g.prototype.required = void 0, g.prototype.showInDiscoveryDocument = void 0, g.prototype.userClaims = void 0;
  var B = /*#__PURE__*/function () {
    function B() {
      _classCallCheck(this, B);
    }
    return _createClass(B, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new B(), e.hasOwnProperty("executionDuration") && (t.executionDuration = n.convertToType(e.executionDuration, "Number")), e.hasOwnProperty("executionTime") && (t.executionTime = n.convertToType(e.executionTime, "Date")), e.hasOwnProperty("extraProperties") && (t.extraProperties = n.convertToType(e.extraProperties, {
          String: Object
        })), e.hasOwnProperty("id") && (t.id = n.convertToType(e.id, "String")), e.hasOwnProperty("methodName") && (t.methodName = n.convertToType(e.methodName, "String")), e.hasOwnProperty("parameters") && (t.parameters = n.convertToType(e.parameters, "String")), e.hasOwnProperty("serviceName") && (t.serviceName = n.convertToType(e.serviceName, "String"))), t;
      }
    }]);
  }();
  B.prototype.executionDuration = void 0, B.prototype.executionTime = void 0, B.prototype.extraProperties = void 0, B.prototype.id = void 0, B.prototype.methodName = void 0, B.prototype.parameters = void 0, B.prototype.serviceName = void 0;
  var ve = {
    _0: 0,
    _1: 1,
    _2: 2,
    constructFromObject: function constructFromObject(O) {
      return O;
    }
  };
  var _ = /*#__PURE__*/function () {
    function _() {
      _classCallCheck(this, _);
    }
    return _createClass(_, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new _(), e.hasOwnProperty("id") && (t.id = n.convertToType(e.id, "String")), e.hasOwnProperty("newValue") && (t.newValue = n.convertToType(e.newValue, "String")), e.hasOwnProperty("originalValue") && (t.originalValue = n.convertToType(e.originalValue, "String")), e.hasOwnProperty("propertyName") && (t.propertyName = n.convertToType(e.propertyName, "String")), e.hasOwnProperty("propertyTypeFullName") && (t.propertyTypeFullName = n.convertToType(e.propertyTypeFullName, "String"))), t;
      }
    }]);
  }();
  _.prototype.id = void 0, _.prototype.newValue = void 0, _.prototype.originalValue = void 0, _.prototype.propertyName = void 0, _.prototype.propertyTypeFullName = void 0;
  var x = /*#__PURE__*/function () {
    function x() {
      _classCallCheck(this, x);
    }
    return _createClass(x, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new x(), e.hasOwnProperty("changeTime") && (t.changeTime = n.convertToType(e.changeTime, "Date")), e.hasOwnProperty("changeType") && (t.changeType = ve.constructFromObject(e.changeType)), e.hasOwnProperty("entityId") && (t.entityId = n.convertToType(e.entityId, "String")), e.hasOwnProperty("entityTenantId") && (t.entityTenantId = n.convertToType(e.entityTenantId, "String")), e.hasOwnProperty("entityTypeFullName") && (t.entityTypeFullName = n.convertToType(e.entityTypeFullName, "String")), e.hasOwnProperty("extraProperties") && (t.extraProperties = n.convertToType(e.extraProperties, {
          String: Object
        })), e.hasOwnProperty("id") && (t.id = n.convertToType(e.id, "String")), e.hasOwnProperty("propertyChanges") && (t.propertyChanges = n.convertToType(e.propertyChanges, [_]))), t;
      }
    }]);
  }();
  x.prototype.changeTime = void 0, x.prototype.changeType = void 0, x.prototype.entityId = void 0, x.prototype.entityTenantId = void 0, x.prototype.entityTypeFullName = void 0, x.prototype.extraProperties = void 0, x.prototype.id = void 0, x.prototype.propertyChanges = void 0;
  var m = /*#__PURE__*/function () {
    function m() {
      _classCallCheck(this, m);
    }
    return _createClass(m, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new m(), e.hasOwnProperty("actions") && (t.actions = n.convertToType(e.actions, [B])), e.hasOwnProperty("applicationName") && (t.applicationName = n.convertToType(e.applicationName, "String")), e.hasOwnProperty("browserInfo") && (t.browserInfo = n.convertToType(e.browserInfo, "String")), e.hasOwnProperty("clientId") && (t.clientId = n.convertToType(e.clientId, "String")), e.hasOwnProperty("clientIpAddress") && (t.clientIpAddress = n.convertToType(e.clientIpAddress, "String")), e.hasOwnProperty("clientName") && (t.clientName = n.convertToType(e.clientName, "String")), e.hasOwnProperty("comments") && (t.comments = n.convertToType(e.comments, "String")), e.hasOwnProperty("correlationId") && (t.correlationId = n.convertToType(e.correlationId, "String")), e.hasOwnProperty("entityChanges") && (t.entityChanges = n.convertToType(e.entityChanges, [x])), e.hasOwnProperty("exceptions") && (t.exceptions = n.convertToType(e.exceptions, "String")), e.hasOwnProperty("executionDuration") && (t.executionDuration = n.convertToType(e.executionDuration, "Number")), e.hasOwnProperty("executionTime") && (t.executionTime = n.convertToType(e.executionTime, "Date")), e.hasOwnProperty("extraProperties") && (t.extraProperties = n.convertToType(e.extraProperties, {
          String: Object
        })), e.hasOwnProperty("httpMethod") && (t.httpMethod = n.convertToType(e.httpMethod, "String")), e.hasOwnProperty("httpStatusCode") && (t.httpStatusCode = n.convertToType(e.httpStatusCode, "Number")), e.hasOwnProperty("id") && (t.id = n.convertToType(e.id, "String")), e.hasOwnProperty("impersonatorTenantId") && (t.impersonatorTenantId = n.convertToType(e.impersonatorTenantId, "String")), e.hasOwnProperty("impersonatorUserId") && (t.impersonatorUserId = n.convertToType(e.impersonatorUserId, "String")), e.hasOwnProperty("tenantId") && (t.tenantId = n.convertToType(e.tenantId, "String")), e.hasOwnProperty("tenantName") && (t.tenantName = n.convertToType(e.tenantName, "String")), e.hasOwnProperty("url") && (t.url = n.convertToType(e.url, "String")), e.hasOwnProperty("userId") && (t.userId = n.convertToType(e.userId, "String")), e.hasOwnProperty("userName") && (t.userName = n.convertToType(e.userName, "String"))), t;
      }
    }]);
  }();
  m.prototype.actions = void 0, m.prototype.applicationName = void 0, m.prototype.browserInfo = void 0, m.prototype.clientId = void 0, m.prototype.clientIpAddress = void 0, m.prototype.clientName = void 0, m.prototype.comments = void 0, m.prototype.correlationId = void 0, m.prototype.entityChanges = void 0, m.prototype.exceptions = void 0, m.prototype.executionDuration = void 0, m.prototype.executionTime = void 0, m.prototype.extraProperties = void 0, m.prototype.httpMethod = void 0, m.prototype.httpStatusCode = void 0, m.prototype.id = void 0, m.prototype.impersonatorTenantId = void 0, m.prototype.impersonatorUserId = void 0, m.prototype.tenantId = void 0, m.prototype.tenantName = void 0, m.prototype.url = void 0, m.prototype.userId = void 0, m.prototype.userName = void 0;
  var ee = /*#__PURE__*/function () {
    function ee() {
      _classCallCheck(this, ee);
    }
    return _createClass(ee, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new ee(), e.hasOwnProperty("type") && (t.type = n.convertToType(e.type, "String")), e.hasOwnProperty("value") && (t.value = n.convertToType(e.value, "String"))), t;
      }
    }]);
  }();
  ee.prototype.type = void 0, ee.prototype.value = void 0;
  var V = /*#__PURE__*/function () {
    function V() {
      _classCallCheck(this, V);
    }
    return _createClass(V, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new V(), e.hasOwnProperty("description") && (t.description = n.convertToType(e.description, "String")), e.hasOwnProperty("expiration") && (t.expiration = n.convertToType(e.expiration, "Date")), e.hasOwnProperty("type") && (t.type = n.convertToType(e.type, "String")), e.hasOwnProperty("value") && (t.value = n.convertToType(e.value, "String"))), t;
      }
    }]);
  }();
  V.prototype.description = void 0, V.prototype.expiration = void 0, V.prototype.type = void 0, V.prototype.value = void 0;
  var u = /*#__PURE__*/function () {
    function u() {
      _classCallCheck(this, u);
    }
    return _createClass(u, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new u(), e.hasOwnProperty("absoluteRefreshTokenLifetime") && (t.absoluteRefreshTokenLifetime = n.convertToType(e.absoluteRefreshTokenLifetime, "Number")), e.hasOwnProperty("accessTokenLifetime") && (t.accessTokenLifetime = n.convertToType(e.accessTokenLifetime, "Number")), e.hasOwnProperty("accessTokenType") && (t.accessTokenType = n.convertToType(e.accessTokenType, "Number")), e.hasOwnProperty("allowAccessTokensViaBrowser") && (t.allowAccessTokensViaBrowser = n.convertToType(e.allowAccessTokensViaBrowser, "Boolean")), e.hasOwnProperty("allowOfflineAccess") && (t.allowOfflineAccess = n.convertToType(e.allowOfflineAccess, "Boolean")), e.hasOwnProperty("allowPlainTextPkce") && (t.allowPlainTextPkce = n.convertToType(e.allowPlainTextPkce, "Boolean")), e.hasOwnProperty("allowRememberConsent") && (t.allowRememberConsent = n.convertToType(e.allowRememberConsent, "Boolean")), e.hasOwnProperty("allowedCorsOrigins") && (t.allowedCorsOrigins = n.convertToType(e.allowedCorsOrigins, ["String"])), e.hasOwnProperty("allowedGrantTypes") && (t.allowedGrantTypes = n.convertToType(e.allowedGrantTypes, ["String"])), e.hasOwnProperty("allowedIdentityTokenSigningAlgorithms") && (t.allowedIdentityTokenSigningAlgorithms = n.convertToType(e.allowedIdentityTokenSigningAlgorithms, "String")), e.hasOwnProperty("allowedScopes") && (t.allowedScopes = n.convertToType(e.allowedScopes, ["String"])), e.hasOwnProperty("alwaysIncludeUserClaimsInIdToken") && (t.alwaysIncludeUserClaimsInIdToken = n.convertToType(e.alwaysIncludeUserClaimsInIdToken, "Boolean")), e.hasOwnProperty("alwaysSendClientClaims") && (t.alwaysSendClientClaims = n.convertToType(e.alwaysSendClientClaims, "Boolean")), e.hasOwnProperty("authorizationCodeLifetime") && (t.authorizationCodeLifetime = n.convertToType(e.authorizationCodeLifetime, "Number")), e.hasOwnProperty("backChannelLogoutSessionRequired") && (t.backChannelLogoutSessionRequired = n.convertToType(e.backChannelLogoutSessionRequired, "Boolean")), e.hasOwnProperty("backChannelLogoutUri") && (t.backChannelLogoutUri = n.convertToType(e.backChannelLogoutUri, "String")), e.hasOwnProperty("claims") && (t.claims = n.convertToType(e.claims, [ee])), e.hasOwnProperty("clientClaimsPrefix") && (t.clientClaimsPrefix = n.convertToType(e.clientClaimsPrefix, "String")), e.hasOwnProperty("clientId") && (t.clientId = n.convertToType(e.clientId, "String")), e.hasOwnProperty("clientName") && (t.clientName = n.convertToType(e.clientName, "String")), e.hasOwnProperty("clientSecrets") && (t.clientSecrets = n.convertToType(e.clientSecrets, [V])), e.hasOwnProperty("clientUri") && (t.clientUri = n.convertToType(e.clientUri, "String")), e.hasOwnProperty("consentLifetime") && (t.consentLifetime = n.convertToType(e.consentLifetime, "Number")), e.hasOwnProperty("creationTime") && (t.creationTime = n.convertToType(e.creationTime, "Date")), e.hasOwnProperty("creatorId") && (t.creatorId = n.convertToType(e.creatorId, "String")), e.hasOwnProperty("deleterId") && (t.deleterId = n.convertToType(e.deleterId, "String")), e.hasOwnProperty("deletionTime") && (t.deletionTime = n.convertToType(e.deletionTime, "Date")), e.hasOwnProperty("description") && (t.description = n.convertToType(e.description, "String")), e.hasOwnProperty("deviceCodeLifetime") && (t.deviceCodeLifetime = n.convertToType(e.deviceCodeLifetime, "Number")), e.hasOwnProperty("enableLocalLogin") && (t.enableLocalLogin = n.convertToType(e.enableLocalLogin, "Boolean")), e.hasOwnProperty("enabled") && (t.enabled = n.convertToType(e.enabled, "Boolean")), e.hasOwnProperty("frontChannelLogoutSessionRequired") && (t.frontChannelLogoutSessionRequired = n.convertToType(e.frontChannelLogoutSessionRequired, "Boolean")), e.hasOwnProperty("frontChannelLogoutUri") && (t.frontChannelLogoutUri = n.convertToType(e.frontChannelLogoutUri, "String")), e.hasOwnProperty("id") && (t.id = n.convertToType(e.id, "String")), e.hasOwnProperty("identityProviderRestrictions") && (t.identityProviderRestrictions = n.convertToType(e.identityProviderRestrictions, ["String"])), e.hasOwnProperty("identityTokenLifetime") && (t.identityTokenLifetime = n.convertToType(e.identityTokenLifetime, "Number")), e.hasOwnProperty("includeJwtId") && (t.includeJwtId = n.convertToType(e.includeJwtId, "Boolean")), e.hasOwnProperty("isDeleted") && (t.isDeleted = n.convertToType(e.isDeleted, "Boolean")), e.hasOwnProperty("lastModificationTime") && (t.lastModificationTime = n.convertToType(e.lastModificationTime, "Date")), e.hasOwnProperty("lastModifierId") && (t.lastModifierId = n.convertToType(e.lastModifierId, "String")), e.hasOwnProperty("logoUri") && (t.logoUri = n.convertToType(e.logoUri, "String")), e.hasOwnProperty("pairWiseSubjectSalt") && (t.pairWiseSubjectSalt = n.convertToType(e.pairWiseSubjectSalt, "String")), e.hasOwnProperty("postLogoutRedirectUris") && (t.postLogoutRedirectUris = n.convertToType(e.postLogoutRedirectUris, ["String"])), e.hasOwnProperty("properties") && (t.properties = n.convertToType(e.properties, [z])), e.hasOwnProperty("protocolType") && (t.protocolType = n.convertToType(e.protocolType, "String")), e.hasOwnProperty("redirectUris") && (t.redirectUris = n.convertToType(e.redirectUris, ["String"])), e.hasOwnProperty("refreshTokenExpiration") && (t.refreshTokenExpiration = n.convertToType(e.refreshTokenExpiration, "Number")), e.hasOwnProperty("refreshTokenUsage") && (t.refreshTokenUsage = n.convertToType(e.refreshTokenUsage, "Number")), e.hasOwnProperty("requireClientSecret") && (t.requireClientSecret = n.convertToType(e.requireClientSecret, "Boolean")), e.hasOwnProperty("requireConsent") && (t.requireConsent = n.convertToType(e.requireConsent, "Boolean")), e.hasOwnProperty("requirePkce") && (t.requirePkce = n.convertToType(e.requirePkce, "Boolean")), e.hasOwnProperty("requireRequestObject") && (t.requireRequestObject = n.convertToType(e.requireRequestObject, "Boolean")), e.hasOwnProperty("slidingRefreshTokenLifetime") && (t.slidingRefreshTokenLifetime = n.convertToType(e.slidingRefreshTokenLifetime, "Number")), e.hasOwnProperty("updateAccessTokenClaimsOnRefresh") && (t.updateAccessTokenClaimsOnRefresh = n.convertToType(e.updateAccessTokenClaimsOnRefresh, "Boolean")), e.hasOwnProperty("userCodeType") && (t.userCodeType = n.convertToType(e.userCodeType, "String")), e.hasOwnProperty("userSsoLifetime") && (t.userSsoLifetime = n.convertToType(e.userSsoLifetime, "Number"))), t;
      }
    }]);
  }();
  u.prototype.absoluteRefreshTokenLifetime = void 0, u.prototype.accessTokenLifetime = void 0, u.prototype.accessTokenType = void 0, u.prototype.allowAccessTokensViaBrowser = void 0, u.prototype.allowOfflineAccess = void 0, u.prototype.allowPlainTextPkce = void 0, u.prototype.allowRememberConsent = void 0, u.prototype.allowedCorsOrigins = void 0, u.prototype.allowedGrantTypes = void 0, u.prototype.allowedIdentityTokenSigningAlgorithms = void 0, u.prototype.allowedScopes = void 0, u.prototype.alwaysIncludeUserClaimsInIdToken = void 0, u.prototype.alwaysSendClientClaims = void 0, u.prototype.authorizationCodeLifetime = void 0, u.prototype.backChannelLogoutSessionRequired = void 0, u.prototype.backChannelLogoutUri = void 0, u.prototype.claims = void 0, u.prototype.clientClaimsPrefix = void 0, u.prototype.clientId = void 0, u.prototype.clientName = void 0, u.prototype.clientSecrets = void 0, u.prototype.clientUri = void 0, u.prototype.consentLifetime = void 0, u.prototype.creationTime = void 0, u.prototype.creatorId = void 0, u.prototype.deleterId = void 0, u.prototype.deletionTime = void 0, u.prototype.description = void 0, u.prototype.deviceCodeLifetime = void 0, u.prototype.enableLocalLogin = void 0, u.prototype.enabled = void 0, u.prototype.frontChannelLogoutSessionRequired = void 0, u.prototype.frontChannelLogoutUri = void 0, u.prototype.id = void 0, u.prototype.identityProviderRestrictions = void 0, u.prototype.identityTokenLifetime = void 0, u.prototype.includeJwtId = void 0, u.prototype.isDeleted = void 0, u.prototype.lastModificationTime = void 0, u.prototype.lastModifierId = void 0, u.prototype.logoUri = void 0, u.prototype.pairWiseSubjectSalt = void 0, u.prototype.postLogoutRedirectUris = void 0, u.prototype.properties = void 0, u.prototype.protocolType = void 0, u.prototype.redirectUris = void 0, u.prototype.refreshTokenExpiration = void 0, u.prototype.refreshTokenUsage = void 0, u.prototype.requireClientSecret = void 0, u.prototype.requireConsent = void 0, u.prototype.requirePkce = void 0, u.prototype.requireRequestObject = void 0, u.prototype.slidingRefreshTokenLifetime = void 0, u.prototype.updateAccessTokenClaimsOnRefresh = void 0, u.prototype.userCodeType = void 0, u.prototype.userSsoLifetime = void 0;
  var K = /*#__PURE__*/function () {
    function K(e) {
      _classCallCheck(this, K);
      this.name = e;
    }
    return _createClass(K, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new K(), e.hasOwnProperty("description") && (t.description = n.convertToType(e.description, "String")), e.hasOwnProperty("displayName") && (t.displayName = n.convertToType(e.displayName, "String")), e.hasOwnProperty("enabled") && (t.enabled = n.convertToType(e.enabled, "Boolean")), e.hasOwnProperty("name") && (t.name = n.convertToType(e.name, "String")), e.hasOwnProperty("showInDiscoveryDocument") && (t.showInDiscoveryDocument = n.convertToType(e.showInDiscoveryDocument, "Boolean")), e.hasOwnProperty("userClaims") && (t.userClaims = n.convertToType(e.userClaims, ["String"]))), t;
      }
    }]);
  }();
  K.prototype.description = void 0, K.prototype.displayName = void 0, K.prototype.enabled = void 0, K.prototype.name = void 0, K.prototype.showInDiscoveryDocument = void 0, K.prototype.userClaims = void 0;
  var q = /*#__PURE__*/function () {
    function q(e, t) {
      _classCallCheck(this, q);
      this.displayName = e, this.name = t;
    }
    return _createClass(q, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new q(), e.hasOwnProperty("description") && (t.description = n.convertToType(e.description, "String")), e.hasOwnProperty("displayName") && (t.displayName = n.convertToType(e.displayName, "String")), e.hasOwnProperty("emphasize") && (t.emphasize = n.convertToType(e.emphasize, "Boolean")), e.hasOwnProperty("enabled") && (t.enabled = n.convertToType(e.enabled, "Boolean")), e.hasOwnProperty("name") && (t.name = n.convertToType(e.name, "String")), e.hasOwnProperty("required") && (t.required = n.convertToType(e.required, "Boolean")), e.hasOwnProperty("showInDiscoveryDocument") && (t.showInDiscoveryDocument = n.convertToType(e.showInDiscoveryDocument, "Boolean")), e.hasOwnProperty("userClaims") && (t.userClaims = n.convertToType(e.userClaims, ["String"]))), t;
      }
    }]);
  }();
  q.prototype.description = void 0, q.prototype.displayName = void 0, q.prototype.emphasize = void 0, q.prototype.enabled = void 0, q.prototype.name = void 0, q.prototype.required = void 0, q.prototype.showInDiscoveryDocument = void 0, q.prototype.userClaims = void 0;
  var X = /*#__PURE__*/function () {
    function X(e, t) {
      _classCallCheck(this, X);
      this.type = e, this.value = t;
    }
    return _createClass(X, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new X(), e.hasOwnProperty("description") && (t.description = n.convertToType(e.description, "String")), e.hasOwnProperty("expiration") && (t.expiration = n.convertToType(e.expiration, "Date")), e.hasOwnProperty("type") && (t.type = n.convertToType(e.type, "String")), e.hasOwnProperty("value") && (t.value = n.convertToType(e.value, "String"))), t;
      }
    }]);
  }();
  X.prototype.description = void 0, X.prototype.expiration = void 0, X.prototype.type = void 0, X.prototype.value = void 0;
  var h = /*#__PURE__*/function () {
    function h(e, t, i, r) {
      _classCallCheck(this, h);
      this.allowedGrantTypes = e, this.clientId = t, this.clientName = i, this.protocolType = r;
    }
    return _createClass(h, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new h(), e.hasOwnProperty("absoluteRefreshTokenLifetime") && (t.absoluteRefreshTokenLifetime = n.convertToType(e.absoluteRefreshTokenLifetime, "Number")), e.hasOwnProperty("accessTokenLifetime") && (t.accessTokenLifetime = n.convertToType(e.accessTokenLifetime, "Number")), e.hasOwnProperty("allowAccessTokensViaBrowser") && (t.allowAccessTokensViaBrowser = n.convertToType(e.allowAccessTokensViaBrowser, "Boolean")), e.hasOwnProperty("allowOfflineAccess") && (t.allowOfflineAccess = n.convertToType(e.allowOfflineAccess, "Boolean")), e.hasOwnProperty("allowRememberConsent") && (t.allowRememberConsent = n.convertToType(e.allowRememberConsent, "Boolean")), e.hasOwnProperty("allowedGrantTypes") && (t.allowedGrantTypes = n.convertToType(e.allowedGrantTypes, ["String"])), e.hasOwnProperty("allowedScopes") && (t.allowedScopes = n.convertToType(e.allowedScopes, ["String"])), e.hasOwnProperty("authorizationCodeLifetime") && (t.authorizationCodeLifetime = n.convertToType(e.authorizationCodeLifetime, "Number")), e.hasOwnProperty("backChannelLogoutSessionRequired") && (t.backChannelLogoutSessionRequired = n.convertToType(e.backChannelLogoutSessionRequired, "Boolean")), e.hasOwnProperty("clientId") && (t.clientId = n.convertToType(e.clientId, "String")), e.hasOwnProperty("clientName") && (t.clientName = n.convertToType(e.clientName, "String")), e.hasOwnProperty("clientSecrets") && (t.clientSecrets = n.convertToType(e.clientSecrets, [X])), e.hasOwnProperty("clientUri") && (t.clientUri = n.convertToType(e.clientUri, "String")), e.hasOwnProperty("description") && (t.description = n.convertToType(e.description, "String")), e.hasOwnProperty("enableLocalLogin") && (t.enableLocalLogin = n.convertToType(e.enableLocalLogin, "Boolean")), e.hasOwnProperty("enabled") && (t.enabled = n.convertToType(e.enabled, "Boolean")), e.hasOwnProperty("frontChannelLogoutSessionRequired") && (t.frontChannelLogoutSessionRequired = n.convertToType(e.frontChannelLogoutSessionRequired, "Boolean")), e.hasOwnProperty("identityTokenLifetime") && (t.identityTokenLifetime = n.convertToType(e.identityTokenLifetime, "Number")), e.hasOwnProperty("logoUri") && (t.logoUri = n.convertToType(e.logoUri, "String")), e.hasOwnProperty("postLogoutRedirectUris") && (t.postLogoutRedirectUris = n.convertToType(e.postLogoutRedirectUris, ["String"])), e.hasOwnProperty("protocolType") && (t.protocolType = n.convertToType(e.protocolType, "String")), e.hasOwnProperty("redirectUris") && (t.redirectUris = n.convertToType(e.redirectUris, ["String"])), e.hasOwnProperty("refreshTokenExpiration") && (t.refreshTokenExpiration = n.convertToType(e.refreshTokenExpiration, "Number")), e.hasOwnProperty("refreshTokenUsage") && (t.refreshTokenUsage = n.convertToType(e.refreshTokenUsage, "Number")), e.hasOwnProperty("requireClientSecret") && (t.requireClientSecret = n.convertToType(e.requireClientSecret, "Boolean")), e.hasOwnProperty("slidingRefreshTokenLifetime") && (t.slidingRefreshTokenLifetime = n.convertToType(e.slidingRefreshTokenLifetime, "Number"))), t;
      }
    }]);
  }();
  h.prototype.absoluteRefreshTokenLifetime = void 0, h.prototype.accessTokenLifetime = void 0, h.prototype.allowAccessTokensViaBrowser = void 0, h.prototype.allowOfflineAccess = void 0, h.prototype.allowRememberConsent = void 0, h.prototype.allowedGrantTypes = void 0, h.prototype.allowedScopes = void 0, h.prototype.authorizationCodeLifetime = void 0, h.prototype.backChannelLogoutSessionRequired = void 0, h.prototype.clientId = void 0, h.prototype.clientName = void 0, h.prototype.clientSecrets = void 0, h.prototype.clientUri = void 0, h.prototype.description = void 0, h.prototype.enableLocalLogin = void 0, h.prototype.enabled = void 0, h.prototype.frontChannelLogoutSessionRequired = void 0, h.prototype.identityTokenLifetime = void 0, h.prototype.logoUri = void 0, h.prototype.postLogoutRedirectUris = void 0, h.prototype.protocolType = void 0, h.prototype.redirectUris = void 0, h.prototype.refreshTokenExpiration = void 0, h.prototype.refreshTokenUsage = void 0, h.prototype.requireClientSecret = void 0, h.prototype.slidingRefreshTokenLifetime = void 0;
  var E = /*#__PURE__*/function () {
    function E(e) {
      _classCallCheck(this, E);
      this.name = e;
    }
    return _createClass(E, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new E(), e.hasOwnProperty("description") && (t.description = n.convertToType(e.description, "String")), e.hasOwnProperty("displayName") && (t.displayName = n.convertToType(e.displayName, "String")), e.hasOwnProperty("emphasize") && (t.emphasize = n.convertToType(e.emphasize, "Boolean")), e.hasOwnProperty("enabled") && (t.enabled = n.convertToType(e.enabled, "Boolean")), e.hasOwnProperty("name") && (t.name = n.convertToType(e.name, "String")), e.hasOwnProperty("required") && (t.required = n.convertToType(e.required, "Boolean")), e.hasOwnProperty("showInDiscoveryDocument") && (t.showInDiscoveryDocument = n.convertToType(e.showInDiscoveryDocument, "Boolean")), e.hasOwnProperty("userClaims") && (t.userClaims = n.convertToType(e.userClaims, ["String"]))), t;
      }
    }]);
  }();
  E.prototype.description = void 0, E.prototype.displayName = void 0, E.prototype.emphasize = void 0, E.prototype.enabled = void 0, E.prototype.name = void 0, E.prototype.required = void 0, E.prototype.showInDiscoveryDocument = void 0, E.prototype.userClaims = void 0;
  var v = /*#__PURE__*/function () {
    function v() {
      _classCallCheck(this, v);
    }
    return _createClass(v, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new v(), e.hasOwnProperty("creationTime") && (t.creationTime = n.convertToType(e.creationTime, "Date")), e.hasOwnProperty("creatorId") && (t.creatorId = n.convertToType(e.creatorId, "String")), e.hasOwnProperty("deleterId") && (t.deleterId = n.convertToType(e.deleterId, "String")), e.hasOwnProperty("deletionTime") && (t.deletionTime = n.convertToType(e.deletionTime, "Date")), e.hasOwnProperty("description") && (t.description = n.convertToType(e.description, "String")), e.hasOwnProperty("displayName") && (t.displayName = n.convertToType(e.displayName, "String")), e.hasOwnProperty("emphasize") && (t.emphasize = n.convertToType(e.emphasize, "Boolean")), e.hasOwnProperty("enabled") && (t.enabled = n.convertToType(e.enabled, "Boolean")), e.hasOwnProperty("id") && (t.id = n.convertToType(e.id, "String")), e.hasOwnProperty("isDeleted") && (t.isDeleted = n.convertToType(e.isDeleted, "Boolean")), e.hasOwnProperty("lastModificationTime") && (t.lastModificationTime = n.convertToType(e.lastModificationTime, "Date")), e.hasOwnProperty("lastModifierId") && (t.lastModifierId = n.convertToType(e.lastModifierId, "String")), e.hasOwnProperty("name") && (t.name = n.convertToType(e.name, "String")), e.hasOwnProperty("properties") && (t.properties = n.convertToType(e.properties, [z])), e.hasOwnProperty("required") && (t.required = n.convertToType(e.required, "Boolean")), e.hasOwnProperty("showInDiscoveryDocument") && (t.showInDiscoveryDocument = n.convertToType(e.showInDiscoveryDocument, "Boolean")), e.hasOwnProperty("userClaims") && (t.userClaims = n.convertToType(e.userClaims, ["String"]))), t;
      }
    }]);
  }();
  v.prototype.creationTime = void 0, v.prototype.creatorId = void 0, v.prototype.deleterId = void 0, v.prototype.deletionTime = void 0, v.prototype.description = void 0, v.prototype.displayName = void 0, v.prototype.emphasize = void 0, v.prototype.enabled = void 0, v.prototype.id = void 0, v.prototype.isDeleted = void 0, v.prototype.lastModificationTime = void 0, v.prototype.lastModifierId = void 0, v.prototype.name = void 0, v.prototype.properties = void 0, v.prototype.required = void 0, v.prototype.showInDiscoveryDocument = void 0, v.prototype.userClaims = void 0;
  var A = /*#__PURE__*/function () {
    function A() {
      _classCallCheck(this, A);
    }
    return _createClass(A, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new A(), e.hasOwnProperty("clientId") && (t.clientId = n.convertToType(e.clientId, "String")), e.hasOwnProperty("consumedTime") && (t.consumedTime = n.convertToType(e.consumedTime, "Date")), e.hasOwnProperty("creationTime") && (t.creationTime = n.convertToType(e.creationTime, "Date")), e.hasOwnProperty("data") && (t.data = n.convertToType(e.data, "String")), e.hasOwnProperty("description") && (t.description = n.convertToType(e.description, "String")), e.hasOwnProperty("expiration") && (t.expiration = n.convertToType(e.expiration, "Date")), e.hasOwnProperty("extraProperties") && (t.extraProperties = n.convertToType(e.extraProperties, {
          String: Object
        })), e.hasOwnProperty("id") && (t.id = n.convertToType(e.id, "String")), e.hasOwnProperty("key") && (t.key = n.convertToType(e.key, "String")), e.hasOwnProperty("subjectId") && (t.subjectId = n.convertToType(e.subjectId, "String")), e.hasOwnProperty("type") && (t.type = n.convertToType(e.type, "String"))), t;
      }
    }]);
  }();
  A.prototype.clientId = void 0, A.prototype.consumedTime = void 0, A.prototype.creationTime = void 0, A.prototype.data = void 0, A.prototype.description = void 0, A.prototype.expiration = void 0, A.prototype.extraProperties = void 0, A.prototype.id = void 0, A.prototype.key = void 0, A.prototype.subjectId = void 0, A.prototype.type = void 0;
  var ne = /*#__PURE__*/function () {
    function ne() {
      _classCallCheck(this, ne);
    }
    return _createClass(ne, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new ne(), e.hasOwnProperty("members") && (t.members = n.convertToType(e.members, ["String"])), e.hasOwnProperty("message") && (t.message = n.convertToType(e.message, "String"))), t;
      }
    }]);
  }();
  ne.prototype.members = void 0, ne.prototype.message = void 0;
  var Q = /*#__PURE__*/function () {
    function Q() {
      _classCallCheck(this, Q);
    }
    return _createClass(Q, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new Q(), e.hasOwnProperty("code") && (t.code = n.convertToType(e.code, "String")), e.hasOwnProperty("data") && (t.data = n.convertToType(e.data, {
          String: Object
        })), e.hasOwnProperty("details") && (t.details = n.convertToType(e.details, "String")), e.hasOwnProperty("message") && (t.message = n.convertToType(e.message, "String")), e.hasOwnProperty("validationErrors") && (t.validationErrors = n.convertToType(e.validationErrors, [ne]))), t;
      }
    }]);
  }();
  Q.prototype.code = void 0, Q.prototype.data = void 0, Q.prototype.details = void 0, Q.prototype.message = void 0, Q.prototype.validationErrors = void 0;
  var me = /*#__PURE__*/function () {
    function me() {
      _classCallCheck(this, me);
    }
    return _createClass(me, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new me(), e.hasOwnProperty("error") && (t.error = Q.constructFromObject(e.error))), t;
      }
    }]);
  }();
  me.prototype.error = void 0;
  var R = /*#__PURE__*/function () {
    function R() {
      _classCallCheck(this, R);
    }
    return _createClass(R, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new R(), e.hasOwnProperty("allowedAccessTokenSigningAlgorithms") && (t.allowedAccessTokenSigningAlgorithms = n.convertToType(e.allowedAccessTokenSigningAlgorithms, "String")), e.hasOwnProperty("description") && (t.description = n.convertToType(e.description, "String")), e.hasOwnProperty("displayName") && (t.displayName = n.convertToType(e.displayName, "String")), e.hasOwnProperty("enabled") && (t.enabled = n.convertToType(e.enabled, "Boolean")), e.hasOwnProperty("scopes") && (t.scopes = n.convertToType(e.scopes, ["String"])), e.hasOwnProperty("showInDiscoveryDocument") && (t.showInDiscoveryDocument = n.convertToType(e.showInDiscoveryDocument, "Boolean")), e.hasOwnProperty("userClaims") && (t.userClaims = n.convertToType(e.userClaims, ["String"]))), t;
      }
    }]);
  }();
  R.prototype.allowedAccessTokenSigningAlgorithms = void 0, R.prototype.description = void 0, R.prototype.displayName = void 0, R.prototype.enabled = void 0, R.prototype.scopes = void 0, R.prototype.showInDiscoveryDocument = void 0, R.prototype.userClaims = void 0;
  var W = /*#__PURE__*/function () {
    function W(e) {
      _classCallCheck(this, W);
      this.displayName = e;
    }
    return _createClass(W, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new W(), e.hasOwnProperty("description") && (t.description = n.convertToType(e.description, "String")), e.hasOwnProperty("displayName") && (t.displayName = n.convertToType(e.displayName, "String")), e.hasOwnProperty("emphasize") && (t.emphasize = n.convertToType(e.emphasize, "Boolean")), e.hasOwnProperty("enabled") && (t.enabled = n.convertToType(e.enabled, "Boolean")), e.hasOwnProperty("required") && (t.required = n.convertToType(e.required, "Boolean")), e.hasOwnProperty("showInDiscoveryDocument") && (t.showInDiscoveryDocument = n.convertToType(e.showInDiscoveryDocument, "Boolean")), e.hasOwnProperty("userClaims") && (t.userClaims = n.convertToType(e.userClaims, ["String"]))), t;
      }
    }]);
  }();
  W.prototype.description = void 0, W.prototype.displayName = void 0, W.prototype.emphasize = void 0, W.prototype.enabled = void 0, W.prototype.required = void 0, W.prototype.showInDiscoveryDocument = void 0, W.prototype.userClaims = void 0;
  var w = /*#__PURE__*/function () {
    function w(e, t) {
      _classCallCheck(this, w);
      this.allowedGrantTypes = e, this.clientName = t;
    }
    return _createClass(w, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new w(), e.hasOwnProperty("absoluteRefreshTokenLifetime") && (t.absoluteRefreshTokenLifetime = n.convertToType(e.absoluteRefreshTokenLifetime, "Number")), e.hasOwnProperty("accessTokenLifetime") && (t.accessTokenLifetime = n.convertToType(e.accessTokenLifetime, "Number")), e.hasOwnProperty("allowAccessTokensViaBrowser") && (t.allowAccessTokensViaBrowser = n.convertToType(e.allowAccessTokensViaBrowser, "Boolean")), e.hasOwnProperty("allowOfflineAccess") && (t.allowOfflineAccess = n.convertToType(e.allowOfflineAccess, "Boolean")), e.hasOwnProperty("allowPlainTextPkce") && (t.allowPlainTextPkce = n.convertToType(e.allowPlainTextPkce, "Boolean")), e.hasOwnProperty("allowedGrantTypes") && (t.allowedGrantTypes = n.convertToType(e.allowedGrantTypes, ["String"])), e.hasOwnProperty("allowedScopes") && (t.allowedScopes = n.convertToType(e.allowedScopes, ["String"])), e.hasOwnProperty("authorizationCodeLifetime") && (t.authorizationCodeLifetime = n.convertToType(e.authorizationCodeLifetime, "Number")), e.hasOwnProperty("claims") && (t.claims = n.convertToType(e.claims, [ee])), e.hasOwnProperty("clientName") && (t.clientName = n.convertToType(e.clientName, "String")), e.hasOwnProperty("clientUri") && (t.clientUri = n.convertToType(e.clientUri, "String")), e.hasOwnProperty("description") && (t.description = n.convertToType(e.description, "String")), e.hasOwnProperty("enableLocalLogin") && (t.enableLocalLogin = n.convertToType(e.enableLocalLogin, "Boolean")), e.hasOwnProperty("enabled") && (t.enabled = n.convertToType(e.enabled, "Boolean")), e.hasOwnProperty("identityTokenLifetime") && (t.identityTokenLifetime = n.convertToType(e.identityTokenLifetime, "Number")), e.hasOwnProperty("logoUri") && (t.logoUri = n.convertToType(e.logoUri, "String")), e.hasOwnProperty("postLogoutRedirectUris") && (t.postLogoutRedirectUris = n.convertToType(e.postLogoutRedirectUris, ["String"])), e.hasOwnProperty("redirectUris") && (t.redirectUris = n.convertToType(e.redirectUris, ["String"])), e.hasOwnProperty("refreshTokenExpiration") && (t.refreshTokenExpiration = n.convertToType(e.refreshTokenExpiration, "Number")), e.hasOwnProperty("refreshTokenUsage") && (t.refreshTokenUsage = n.convertToType(e.refreshTokenUsage, "Number")), e.hasOwnProperty("requireClientSecret") && (t.requireClientSecret = n.convertToType(e.requireClientSecret, "Boolean")), e.hasOwnProperty("requirePkce") && (t.requirePkce = n.convertToType(e.requirePkce, "Boolean")), e.hasOwnProperty("slidingRefreshTokenLifetime") && (t.slidingRefreshTokenLifetime = n.convertToType(e.slidingRefreshTokenLifetime, "Number")), e.hasOwnProperty("userSsoLifetime") && (t.userSsoLifetime = n.convertToType(e.userSsoLifetime, "Number"))), t;
      }
    }]);
  }();
  w.prototype.absoluteRefreshTokenLifetime = void 0, w.prototype.accessTokenLifetime = void 0, w.prototype.allowAccessTokensViaBrowser = void 0, w.prototype.allowOfflineAccess = void 0, w.prototype.allowPlainTextPkce = void 0, w.prototype.allowedGrantTypes = void 0, w.prototype.allowedScopes = void 0, w.prototype.authorizationCodeLifetime = void 0, w.prototype.claims = void 0, w.prototype.clientName = void 0, w.prototype.clientUri = void 0, w.prototype.description = void 0, w.prototype.enableLocalLogin = void 0, w.prototype.enabled = void 0, w.prototype.identityTokenLifetime = void 0, w.prototype.logoUri = void 0, w.prototype.postLogoutRedirectUris = void 0, w.prototype.redirectUris = void 0, w.prototype.refreshTokenExpiration = void 0, w.prototype.refreshTokenUsage = void 0, w.prototype.requireClientSecret = void 0, w.prototype.requirePkce = void 0, w.prototype.slidingRefreshTokenLifetime = void 0, w.prototype.userSsoLifetime = void 0;
  var H = /*#__PURE__*/function () {
    function H() {
      _classCallCheck(this, H);
    }
    return _createClass(H, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new H(), e.hasOwnProperty("description") && (t.description = n.convertToType(e.description, "String")), e.hasOwnProperty("displayName") && (t.displayName = n.convertToType(e.displayName, "String")), e.hasOwnProperty("emphasize") && (t.emphasize = n.convertToType(e.emphasize, "Boolean")), e.hasOwnProperty("enabled") && (t.enabled = n.convertToType(e.enabled, "Boolean")), e.hasOwnProperty("required") && (t.required = n.convertToType(e.required, "Boolean")), e.hasOwnProperty("showInDiscoveryDocument") && (t.showInDiscoveryDocument = n.convertToType(e.showInDiscoveryDocument, "Boolean")), e.hasOwnProperty("userClaims") && (t.userClaims = n.convertToType(e.userClaims, ["String"]))), t;
      }
    }]);
  }();
  H.prototype.description = void 0, H.prototype.displayName = void 0, H.prototype.emphasize = void 0, H.prototype.enabled = void 0, H.prototype.required = void 0, H.prototype.showInDiscoveryDocument = void 0, H.prototype.userClaims = void 0;
  var P = /*#__PURE__*/function () {
    function P() {
      _classCallCheck(this, P);
    }
    return _createClass(P, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new P(), e.hasOwnProperty("allowedAccessTokenSigningAlgorithms") && (t.allowedAccessTokenSigningAlgorithms = n.convertToType(e.allowedAccessTokenSigningAlgorithms, "String")), e.hasOwnProperty("creationTime") && (t.creationTime = n.convertToType(e.creationTime, "Date")), e.hasOwnProperty("creatorId") && (t.creatorId = n.convertToType(e.creatorId, "String")), e.hasOwnProperty("deleterId") && (t.deleterId = n.convertToType(e.deleterId, "String")), e.hasOwnProperty("deletionTime") && (t.deletionTime = n.convertToType(e.deletionTime, "Date")), e.hasOwnProperty("description") && (t.description = n.convertToType(e.description, "String")), e.hasOwnProperty("displayName") && (t.displayName = n.convertToType(e.displayName, "String")), e.hasOwnProperty("enabled") && (t.enabled = n.convertToType(e.enabled, "Boolean")), e.hasOwnProperty("id") && (t.id = n.convertToType(e.id, "String")), e.hasOwnProperty("isDeleted") && (t.isDeleted = n.convertToType(e.isDeleted, "Boolean")), e.hasOwnProperty("lastModificationTime") && (t.lastModificationTime = n.convertToType(e.lastModificationTime, "Date")), e.hasOwnProperty("lastModifierId") && (t.lastModifierId = n.convertToType(e.lastModifierId, "String")), e.hasOwnProperty("name") && (t.name = n.convertToType(e.name, "String")), e.hasOwnProperty("properties") && (t.properties = n.convertToType(e.properties, [z])), e.hasOwnProperty("scopes") && (t.scopes = n.convertToType(e.scopes, ["String"])), e.hasOwnProperty("secrets") && (t.secrets = n.convertToType(e.secrets, [V])), e.hasOwnProperty("showInDiscoveryDocument") && (t.showInDiscoveryDocument = n.convertToType(e.showInDiscoveryDocument, "Boolean")), e.hasOwnProperty("userClaims") && (t.userClaims = n.convertToType(e.userClaims, ["String"]))), t;
      }
    }]);
  }();
  P.prototype.allowedAccessTokenSigningAlgorithms = void 0, P.prototype.creationTime = void 0, P.prototype.creatorId = void 0, P.prototype.deleterId = void 0, P.prototype.deletionTime = void 0, P.prototype.description = void 0, P.prototype.displayName = void 0, P.prototype.enabled = void 0, P.prototype.id = void 0, P.prototype.isDeleted = void 0, P.prototype.lastModificationTime = void 0, P.prototype.lastModifierId = void 0, P.prototype.name = void 0, P.prototype.properties = void 0, P.prototype.scopes = void 0, P.prototype.secrets = void 0, P.prototype.showInDiscoveryDocument = void 0, P.prototype.userClaims = void 0;
  var J = /*#__PURE__*/function () {
    function J() {
      _classCallCheck(this, J);
    }
    return _createClass(J, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new J(), e.hasOwnProperty("code") && (t.code = n.convertToType(e.code, "String")), e.hasOwnProperty("errorMessage") && (t.errorMessage = n.convertToType(e.errorMessage, "String")), e.hasOwnProperty("errorTitle") && (t.errorTitle = n.convertToType(e.errorTitle, "String")), e.hasOwnProperty("isSuccess") && (t.isSuccess = n.convertToType(e.isSuccess, "Boolean"))), t;
      }
    }]);
  }();
  J.prototype.code = void 0, J.prototype.errorMessage = void 0, J.prototype.errorTitle = void 0, J.prototype.isSuccess = void 0;
  var Y = /*#__PURE__*/function () {
    function Y() {
      _classCallCheck(this, Y);
    }
    return _createClass(Y, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new Y(), e.hasOwnProperty("clientId") && (t.clientId = n.convertToType(e.clientId, "String")), e.hasOwnProperty("clientSecret") && (t.clientSecret = n.convertToType(e.clientSecret, "String")), e.hasOwnProperty("code") && (t.code = n.convertToType(e.code, "String")), e.hasOwnProperty("redirectUri") && (t.redirectUri = n.convertToType(e.redirectUri, "String")), e.hasOwnProperty("scope") && (t.scope = n.convertToType(e.scope, "String"))), t;
      }
    }]);
  }();
  Y.prototype.clientId = void 0, Y.prototype.clientSecret = void 0, Y.prototype.code = void 0, Y.prototype.redirectUri = void 0, Y.prototype.scope = void 0;
  var G = /*#__PURE__*/function () {
    function G() {
      _classCallCheck(this, G);
    }
    return _createClass(G, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new G(), e.hasOwnProperty("access_token") && (t.accessToken = n.convertToType(e.access_token, "String")), e.hasOwnProperty("error_msg") && (t.errorMsg = n.convertToType(e.error_msg, "String")), e.hasOwnProperty("expires_in") && (t.expiresIn = n.convertToType(e.expires_in, "String")), e.hasOwnProperty("is_success") && (t.isSuccess = n.convertToType(e.is_success, "Boolean")), e.hasOwnProperty("scope") && (t.scope = n.convertToType(e.scope, "String")), e.hasOwnProperty("token_type") && (t.tokenType = n.convertToType(e.token_type, "String"))), t;
      }
    }]);
  }();
  G.prototype.accessToken = void 0, G.prototype.errorMsg = void 0, G.prototype.expiresIn = void 0, G.prototype.isSuccess = void 0, G.prototype.scope = void 0, G.prototype.tokenType = void 0;
  var Z = /*#__PURE__*/function () {
    function Z(e, t) {
      _classCallCheck(this, Z);
      this.password = e, this.userNameOrEmailAddress = t;
    }
    return _createClass(Z, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new Z(), e.hasOwnProperty("password") && (t.password = n.convertToType(e.password, "String")), e.hasOwnProperty("rememberMe") && (t.rememberMe = n.convertToType(e.rememberMe, "Boolean")), e.hasOwnProperty("userNameOrEmailAddress") && (t.userNameOrEmailAddress = n.convertToType(e.userNameOrEmailAddress, "String")), e.hasOwnProperty("validateCode") && (t.validateCode = n.convertToType(e.validateCode, "String")), e.hasOwnProperty("validateCodeId") && (t.validateCodeId = n.convertToType(e.validateCodeId, "String"))), t;
      }
    }]);
  }();
  Z.prototype.password = void 0, Z.prototype.rememberMe = void 0, Z.prototype.userNameOrEmailAddress = void 0, Z.prototype.validateCode = void 0, Z.prototype.validateCodeId = void 0;
  var ue = /*#__PURE__*/function () {
    function ue(e) {
      _classCallCheck(this, ue);
      this.bindKey = e;
    }
    return _createClass(ue, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new ue(), e.hasOwnProperty("bindKey") && (t.bindKey = n.convertToType(e.bindKey, "String")), e.hasOwnProperty("userId") && (t.userId = n.convertToType(e.userId, "String"))), t;
      }
    }]);
  }();
  ue.prototype.bindKey = void 0, ue.prototype.userId = void 0;
  var re = /*#__PURE__*/function () {
    function re() {
      _classCallCheck(this, re);
    }
    return _createClass(re, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new re(), e.hasOwnProperty("codeId") && (t.codeId = n.convertToType(e.codeId, "String")), e.hasOwnProperty("imageBase64") && (t.imageBase64 = n.convertToType(e.imageBase64, "String"))), t;
      }
    }]);
  }();
  re.prototype.codeId = void 0, re.prototype.imageBase64 = void 0;
  var M = /*#__PURE__*/function () {
    function M() {
      _classCallCheck(this, M);
    }
    return _createClass(M, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new M(), e.hasOwnProperty("access_token") && (t.accessToken = n.convertToType(e.access_token, "String")), e.hasOwnProperty("errcode") && (t.errcode = n.convertToType(e.errcode, "Number")), e.hasOwnProperty("errmsg") && (t.errmsg = n.convertToType(e.errmsg, "String")), e.hasOwnProperty("expires_time") && (t.expiresTime = n.convertToType(e.expires_time, "Number")), e.hasOwnProperty("isAccessTokenExpired") && (t.isAccessTokenExpired = n.convertToType(e.isAccessTokenExpired, "Boolean")), e.hasOwnProperty("isFail") && (t.isFail = n.convertToType(e.isFail, "Boolean")), e.hasOwnProperty("isIpNotAllowed") && (t.isIpNotAllowed = n.convertToType(e.isIpNotAllowed, "Boolean"))), t;
      }
    }]);
  }();
  M.prototype.accessToken = void 0, M.prototype.errcode = void 0, M.prototype.errmsg = void 0, M.prototype.expiresTime = void 0, M.prototype.isAccessTokenExpired = void 0, M.prototype.isFail = void 0, M.prototype.isIpNotAllowed = void 0;
  var F = /*#__PURE__*/function () {
    function F() {
      _classCallCheck(this, F);
    }
    return _createClass(F, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new F(), e.hasOwnProperty("data") && (t.data = n.convertToType(e.data, "String")), e.hasOwnProperty("errcode") && (t.errcode = n.convertToType(e.errcode, "Number")), e.hasOwnProperty("errmsg") && (t.errmsg = n.convertToType(e.errmsg, "String")), e.hasOwnProperty("isAccessTokenExpired") && (t.isAccessTokenExpired = n.convertToType(e.isAccessTokenExpired, "Boolean")), e.hasOwnProperty("isFail") && (t.isFail = n.convertToType(e.isFail, "Boolean")), e.hasOwnProperty("isIpNotAllowed") && (t.isIpNotAllowed = n.convertToType(e.isIpNotAllowed, "Boolean"))), t;
      }
    }]);
  }();
  F.prototype.data = void 0, F.prototype.errcode = void 0, F.prototype.errmsg = void 0, F.prototype.isAccessTokenExpired = void 0, F.prototype.isFail = void 0, F.prototype.isIpNotAllowed = void 0;
  var U = /*#__PURE__*/function () {
    function U() {
      _classCallCheck(this, U);
    }
    return _createClass(U, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new U(), e.hasOwnProperty("errcode") && (t.errcode = n.convertToType(e.errcode, "Number")), e.hasOwnProperty("errmsg") && (t.errmsg = n.convertToType(e.errmsg, "String")), e.hasOwnProperty("isAccessTokenExpired") && (t.isAccessTokenExpired = n.convertToType(e.isAccessTokenExpired, "Boolean")), e.hasOwnProperty("isFail") && (t.isFail = n.convertToType(e.isFail, "Boolean")), e.hasOwnProperty("isIpNotAllowed") && (t.isIpNotAllowed = n.convertToType(e.isIpNotAllowed, "Boolean")), e.hasOwnProperty("user_ticket") && (t.userTicket = n.convertToType(e.user_ticket, "String")), e.hasOwnProperty("userid") && (t.userid = n.convertToType(e.userid, "String"))), t;
      }
    }]);
  }();
  U.prototype.errcode = void 0, U.prototype.errmsg = void 0, U.prototype.isAccessTokenExpired = void 0, U.prototype.isFail = void 0, U.prototype.isIpNotAllowed = void 0, U.prototype.userTicket = void 0, U.prototype.userid = void 0;
  var de = /*#__PURE__*/function () {
    function de() {
      _classCallCheck(this, de);
    }
    return _createClass(de, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new de(), e.hasOwnProperty("publicKey") && (t.publicKey = n.convertToType(e.publicKey, "String"))), t;
      }
    }]);
  }();
  de.prototype.publicKey = void 0;
  var L = /*#__PURE__*/function () {
    function L() {
      _classCallCheck(this, L);
    }
    return _createClass(L, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new L(), e.hasOwnProperty("desc") && (t.desc = n.convertToType(e.desc, "String")), e.hasOwnProperty("group") && (t.group = n.convertToType(e.group, "String")), e.hasOwnProperty("id") && (t.id = n.convertToType(e.id, "String")), e.hasOwnProperty("isInner") && (t.isInner = n.convertToType(e.isInner, "Boolean")), e.hasOwnProperty("menuId") && (t.menuId = n.convertToType(e.menuId, "String")), e.hasOwnProperty("name") && (t.name = n.convertToType(e.name, "String")), e.hasOwnProperty("operationKey") && (t.operationKey = n.convertToType(e.operationKey, "String")), e.hasOwnProperty("seqNo") && (t.seqNo = n.convertToType(e.seqNo, "Number")), e.hasOwnProperty("url") && (t.url = n.convertToType(e.url, "String")), e.hasOwnProperty("value") && (t.value = n.convertToType(e.value, "Number"))), t;
      }
    }]);
  }();
  L.prototype.desc = void 0, L.prototype.group = void 0, L.prototype.id = void 0, L.prototype.isInner = void 0, L.prototype.menuId = void 0, L.prototype.name = void 0, L.prototype.operationKey = void 0, L.prototype.seqNo = void 0, L.prototype.url = void 0, L.prototype.value = void 0;
  var Oe = {
    _1: 1,
    _2: 2,
    _4: 4,
    constructFromObject: function constructFromObject(O) {
      return O;
    }
  };
  var f = /*#__PURE__*/function () {
    function f() {
      _classCallCheck(this, f);
    }
    return _createClass(f, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new f(), e.hasOwnProperty("creationTime") && (t.creationTime = n.convertToType(e.creationTime, "Date")), e.hasOwnProperty("creatorId") && (t.creatorId = n.convertToType(e.creatorId, "String")), e.hasOwnProperty("deleterId") && (t.deleterId = n.convertToType(e.deleterId, "String")), e.hasOwnProperty("deletionTime") && (t.deletionTime = n.convertToType(e.deletionTime, "Date")), e.hasOwnProperty("flag") && (t.flag = n.convertToType(e.flag, "Number")), e.hasOwnProperty("hidden") && (t.hidden = n.convertToType(e.hidden, "Boolean")), e.hasOwnProperty("icon") && (t.icon = n.convertToType(e.icon, "String")), e.hasOwnProperty("id") && (t.id = n.convertToType(e.id, "String")), e.hasOwnProperty("isActive") && (t.isActive = n.convertToType(e.isActive, "Boolean")), e.hasOwnProperty("isDeleted") && (t.isDeleted = n.convertToType(e.isDeleted, "Boolean")), e.hasOwnProperty("isLeaf") && (t.isLeaf = n.convertToType(e.isLeaf, "Boolean")), e.hasOwnProperty("isVisibleInMenu") && (t.isVisibleInMenu = n.convertToType(e.isVisibleInMenu, "Boolean")), e.hasOwnProperty("lastModificationTime") && (t.lastModificationTime = n.convertToType(e.lastModificationTime, "Date")), e.hasOwnProperty("lastModifierId") && (t.lastModifierId = n.convertToType(e.lastModifierId, "String")), e.hasOwnProperty("menuGroup") && (t.menuGroup = n.convertToType(e.menuGroup, "String")), e.hasOwnProperty("menuKey") && (t.menuKey = n.convertToType(e.menuKey, "String")), e.hasOwnProperty("menuType") && (t.menuType = Oe.constructFromObject(e.menuType)), e.hasOwnProperty("name") && (t.name = n.convertToType(e.name, "String")), e.hasOwnProperty("openType") && (t.openType = n.convertToType(e.openType, "Number")), e.hasOwnProperty("operations") && (t.operations = n.convertToType(e.operations, [L])), e.hasOwnProperty("parentId") && (t.parentId = n.convertToType(e.parentId, "String")), e.hasOwnProperty("path") && (t.path = n.convertToType(e.path, "String")), e.hasOwnProperty("permissionMode") && (t.permissionMode = n.convertToType(e.permissionMode, "Number")), e.hasOwnProperty("seqNo") && (t.seqNo = n.convertToType(e.seqNo, "Number")), e.hasOwnProperty("title") && (t.title = n.convertToType(e.title, "String")), e.hasOwnProperty("topId") && (t.topId = n.convertToType(e.topId, "String")), e.hasOwnProperty("url") && (t.url = n.convertToType(e.url, "String")), e.hasOwnProperty("version") && (t.version = n.convertToType(e.version, "String"))), t;
      }
    }]);
  }();
  f.prototype.creationTime = void 0, f.prototype.creatorId = void 0, f.prototype.deleterId = void 0, f.prototype.deletionTime = void 0, f.prototype.flag = void 0, f.prototype.hidden = void 0, f.prototype.icon = void 0, f.prototype.id = void 0, f.prototype.isActive = void 0, f.prototype.isDeleted = void 0, f.prototype.isLeaf = void 0, f.prototype.isVisibleInMenu = void 0, f.prototype.lastModificationTime = void 0, f.prototype.lastModifierId = void 0, f.prototype.menuGroup = void 0, f.prototype.menuKey = void 0, f.prototype.menuType = void 0, f.prototype.name = void 0, f.prototype.openType = void 0, f.prototype.operations = void 0, f.prototype.parentId = void 0, f.prototype.path = void 0, f.prototype.permissionMode = void 0, f.prototype.seqNo = void 0, f.prototype.title = void 0, f.prototype.topId = void 0, f.prototype.url = void 0, f.prototype.version = void 0;
  var Se = {
    _0: 0,
    _1: 1,
    constructFromObject: function constructFromObject(O) {
      return O;
    }
  };
  var te = /*#__PURE__*/function () {
    function te() {
      _classCallCheck(this, te);
    }
    return _createClass(te, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new te(), e.hasOwnProperty("type") && (t.type = n.convertToType(e.type, "String")), e.hasOwnProperty("value") && (t.value = n.convertToType(e.value, "String")), e.hasOwnProperty("valueType") && (t.valueType = n.convertToType(e.valueType, "String"))), t;
      }
    }]);
  }();
  te.prototype.type = void 0, te.prototype.value = void 0, te.prototype.valueType = void 0;
  var b = /*#__PURE__*/function () {
    function b() {
      _classCallCheck(this, b);
    }
    return _createClass(b, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new b(), e.hasOwnProperty("description") && (t.description = n.convertToType(e.description, "String")), e.hasOwnProperty("expiration") && (t.expiration = n.convertToType(e.expiration, "Date")), e.hasOwnProperty("type") && (t.type = n.convertToType(e.type, "String")), e.hasOwnProperty("value") && (t.value = n.convertToType(e.value, "String"))), t;
      }
    }]);
  }();
  b.prototype.description = void 0, b.prototype.expiration = void 0, b.prototype.type = void 0, b.prototype.value = void 0;
  var Ie = {
      _0: 0,
      _1: 1,
      constructFromObject: function constructFromObject(O) {
        return O;
      }
    },
    Ce = {
      _0: 0,
      _1: 1,
      constructFromObject: function constructFromObject(O) {
        return O;
      }
    };
  var d = /*#__PURE__*/function () {
    function d() {
      _classCallCheck(this, d);
    }
    return _createClass(d, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new d(), e.hasOwnProperty("absoluteRefreshTokenLifetime") && (t.absoluteRefreshTokenLifetime = n.convertToType(e.absoluteRefreshTokenLifetime, "Number")), e.hasOwnProperty("accessTokenLifetime") && (t.accessTokenLifetime = n.convertToType(e.accessTokenLifetime, "Number")), e.hasOwnProperty("accessTokenType") && (t.accessTokenType = Se.constructFromObject(e.accessTokenType)), e.hasOwnProperty("allowAccessTokensViaBrowser") && (t.allowAccessTokensViaBrowser = n.convertToType(e.allowAccessTokensViaBrowser, "Boolean")), e.hasOwnProperty("allowOfflineAccess") && (t.allowOfflineAccess = n.convertToType(e.allowOfflineAccess, "Boolean")), e.hasOwnProperty("allowPlainTextPkce") && (t.allowPlainTextPkce = n.convertToType(e.allowPlainTextPkce, "Boolean")), e.hasOwnProperty("allowRememberConsent") && (t.allowRememberConsent = n.convertToType(e.allowRememberConsent, "Boolean")), e.hasOwnProperty("allowedCorsOrigins") && (t.allowedCorsOrigins = n.convertToType(e.allowedCorsOrigins, ["String"])), e.hasOwnProperty("allowedGrantTypes") && (t.allowedGrantTypes = n.convertToType(e.allowedGrantTypes, ["String"])), e.hasOwnProperty("allowedIdentityTokenSigningAlgorithms") && (t.allowedIdentityTokenSigningAlgorithms = n.convertToType(e.allowedIdentityTokenSigningAlgorithms, ["String"])), e.hasOwnProperty("allowedScopes") && (t.allowedScopes = n.convertToType(e.allowedScopes, ["String"])), e.hasOwnProperty("alwaysIncludeUserClaimsInIdToken") && (t.alwaysIncludeUserClaimsInIdToken = n.convertToType(e.alwaysIncludeUserClaimsInIdToken, "Boolean")), e.hasOwnProperty("alwaysSendClientClaims") && (t.alwaysSendClientClaims = n.convertToType(e.alwaysSendClientClaims, "Boolean")), e.hasOwnProperty("authorizationCodeLifetime") && (t.authorizationCodeLifetime = n.convertToType(e.authorizationCodeLifetime, "Number")), e.hasOwnProperty("backChannelLogoutSessionRequired") && (t.backChannelLogoutSessionRequired = n.convertToType(e.backChannelLogoutSessionRequired, "Boolean")), e.hasOwnProperty("backChannelLogoutUri") && (t.backChannelLogoutUri = n.convertToType(e.backChannelLogoutUri, "String")), e.hasOwnProperty("claims") && (t.claims = n.convertToType(e.claims, [te])), e.hasOwnProperty("clientClaimsPrefix") && (t.clientClaimsPrefix = n.convertToType(e.clientClaimsPrefix, "String")), e.hasOwnProperty("clientId") && (t.clientId = n.convertToType(e.clientId, "String")), e.hasOwnProperty("clientName") && (t.clientName = n.convertToType(e.clientName, "String")), e.hasOwnProperty("clientSecrets") && (t.clientSecrets = n.convertToType(e.clientSecrets, [b])), e.hasOwnProperty("clientUri") && (t.clientUri = n.convertToType(e.clientUri, "String")), e.hasOwnProperty("consentLifetime") && (t.consentLifetime = n.convertToType(e.consentLifetime, "Number")), e.hasOwnProperty("description") && (t.description = n.convertToType(e.description, "String")), e.hasOwnProperty("deviceCodeLifetime") && (t.deviceCodeLifetime = n.convertToType(e.deviceCodeLifetime, "Number")), e.hasOwnProperty("enableLocalLogin") && (t.enableLocalLogin = n.convertToType(e.enableLocalLogin, "Boolean")), e.hasOwnProperty("enabled") && (t.enabled = n.convertToType(e.enabled, "Boolean")), e.hasOwnProperty("frontChannelLogoutSessionRequired") && (t.frontChannelLogoutSessionRequired = n.convertToType(e.frontChannelLogoutSessionRequired, "Boolean")), e.hasOwnProperty("frontChannelLogoutUri") && (t.frontChannelLogoutUri = n.convertToType(e.frontChannelLogoutUri, "String")), e.hasOwnProperty("identityProviderRestrictions") && (t.identityProviderRestrictions = n.convertToType(e.identityProviderRestrictions, ["String"])), e.hasOwnProperty("identityTokenLifetime") && (t.identityTokenLifetime = n.convertToType(e.identityTokenLifetime, "Number")), e.hasOwnProperty("includeJwtId") && (t.includeJwtId = n.convertToType(e.includeJwtId, "Boolean")), e.hasOwnProperty("logoUri") && (t.logoUri = n.convertToType(e.logoUri, "String")), e.hasOwnProperty("pairWiseSubjectSalt") && (t.pairWiseSubjectSalt = n.convertToType(e.pairWiseSubjectSalt, "String")), e.hasOwnProperty("postLogoutRedirectUris") && (t.postLogoutRedirectUris = n.convertToType(e.postLogoutRedirectUris, ["String"])), e.hasOwnProperty("properties") && (t.properties = n.convertToType(e.properties, {
          String: "String"
        })), e.hasOwnProperty("protocolType") && (t.protocolType = n.convertToType(e.protocolType, "String")), e.hasOwnProperty("redirectUris") && (t.redirectUris = n.convertToType(e.redirectUris, ["String"])), e.hasOwnProperty("refreshTokenExpiration") && (t.refreshTokenExpiration = Ie.constructFromObject(e.refreshTokenExpiration)), e.hasOwnProperty("refreshTokenUsage") && (t.refreshTokenUsage = Ce.constructFromObject(e.refreshTokenUsage)), e.hasOwnProperty("requireClientSecret") && (t.requireClientSecret = n.convertToType(e.requireClientSecret, "Boolean")), e.hasOwnProperty("requireConsent") && (t.requireConsent = n.convertToType(e.requireConsent, "Boolean")), e.hasOwnProperty("requirePkce") && (t.requirePkce = n.convertToType(e.requirePkce, "Boolean")), e.hasOwnProperty("requireRequestObject") && (t.requireRequestObject = n.convertToType(e.requireRequestObject, "Boolean")), e.hasOwnProperty("slidingRefreshTokenLifetime") && (t.slidingRefreshTokenLifetime = n.convertToType(e.slidingRefreshTokenLifetime, "Number")), e.hasOwnProperty("updateAccessTokenClaimsOnRefresh") && (t.updateAccessTokenClaimsOnRefresh = n.convertToType(e.updateAccessTokenClaimsOnRefresh, "Boolean")), e.hasOwnProperty("userCodeType") && (t.userCodeType = n.convertToType(e.userCodeType, "String")), e.hasOwnProperty("userSsoLifetime") && (t.userSsoLifetime = n.convertToType(e.userSsoLifetime, "Number"))), t;
      }
    }]);
  }();
  d.prototype.absoluteRefreshTokenLifetime = void 0, d.prototype.accessTokenLifetime = void 0, d.prototype.accessTokenType = void 0, d.prototype.allowAccessTokensViaBrowser = void 0, d.prototype.allowOfflineAccess = void 0, d.prototype.allowPlainTextPkce = void 0, d.prototype.allowRememberConsent = void 0, d.prototype.allowedCorsOrigins = void 0, d.prototype.allowedGrantTypes = void 0, d.prototype.allowedIdentityTokenSigningAlgorithms = void 0, d.prototype.allowedScopes = void 0, d.prototype.alwaysIncludeUserClaimsInIdToken = void 0, d.prototype.alwaysSendClientClaims = void 0, d.prototype.authorizationCodeLifetime = void 0, d.prototype.backChannelLogoutSessionRequired = void 0, d.prototype.backChannelLogoutUri = void 0, d.prototype.claims = void 0, d.prototype.clientClaimsPrefix = void 0, d.prototype.clientId = void 0, d.prototype.clientName = void 0, d.prototype.clientSecrets = void 0, d.prototype.clientUri = void 0, d.prototype.consentLifetime = void 0, d.prototype.description = void 0, d.prototype.deviceCodeLifetime = void 0, d.prototype.enableLocalLogin = void 0, d.prototype.enabled = void 0, d.prototype.frontChannelLogoutSessionRequired = void 0, d.prototype.frontChannelLogoutUri = void 0, d.prototype.identityProviderRestrictions = void 0, d.prototype.identityTokenLifetime = void 0, d.prototype.includeJwtId = void 0, d.prototype.logoUri = void 0, d.prototype.pairWiseSubjectSalt = void 0, d.prototype.postLogoutRedirectUris = void 0, d.prototype.properties = void 0, d.prototype.protocolType = void 0, d.prototype.redirectUris = void 0, d.prototype.refreshTokenExpiration = void 0, d.prototype.refreshTokenUsage = void 0, d.prototype.requireClientSecret = void 0, d.prototype.requireConsent = void 0, d.prototype.requirePkce = void 0, d.prototype.requireRequestObject = void 0, d.prototype.slidingRefreshTokenLifetime = void 0, d.prototype.updateAccessTokenClaimsOnRefresh = void 0, d.prototype.userCodeType = void 0, d.prototype.userSsoLifetime = void 0;
  var He = {
    _100: 100,
    _101: 101,
    _102: 102,
    _103: 103,
    _200: 200,
    _201: 201,
    _202: 202,
    _203: 203,
    _204: 204,
    _205: 205,
    _206: 206,
    _207: 207,
    _208: 208,
    _226: 226,
    _300: 300,
    _301: 301,
    _302: 302,
    _303: 303,
    _304: 304,
    _305: 305,
    _306: 306,
    _307: 307,
    _308: 308,
    _400: 400,
    _401: 401,
    _402: 402,
    _403: 403,
    _404: 404,
    _405: 405,
    _406: 406,
    _407: 407,
    _408: 408,
    _409: 409,
    _410: 410,
    _411: 411,
    _412: 412,
    _413: 413,
    _414: 414,
    _415: 415,
    _416: 416,
    _417: 417,
    _421: 421,
    _422: 422,
    _423: 423,
    _424: 424,
    _426: 426,
    _428: 428,
    _429: 429,
    _431: 431,
    _451: 451,
    _500: 500,
    _501: 501,
    _502: 502,
    _503: 503,
    _504: 504,
    _505: 505,
    _506: 506,
    _507: 507,
    _508: 508,
    _510: 510,
    _511: 511,
    constructFromObject: function constructFromObject(O) {
      return O;
    }
  };
  var ie = /*#__PURE__*/function () {
    function ie() {
      _classCallCheck(this, ie);
    }
    return _createClass(ie, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new ie(), e.hasOwnProperty("items") && (t.items = n.convertToType(e.items, [g])), e.hasOwnProperty("totalCount") && (t.totalCount = n.convertToType(e.totalCount, "Number"))), t;
      }
    }]);
  }();
  ie.prototype.items = void 0, ie.prototype.totalCount = void 0;
  var oe = /*#__PURE__*/function () {
    function oe() {
      _classCallCheck(this, oe);
    }
    return _createClass(oe, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new oe(), e.hasOwnProperty("items") && (t.items = n.convertToType(e.items, [m])), e.hasOwnProperty("totalCount") && (t.totalCount = n.convertToType(e.totalCount, "Number"))), t;
      }
    }]);
  }();
  oe.prototype.items = void 0, oe.prototype.totalCount = void 0;
  var se = /*#__PURE__*/function () {
    function se() {
      _classCallCheck(this, se);
    }
    return _createClass(se, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new se(), e.hasOwnProperty("items") && (t.items = n.convertToType(e.items, [u])), e.hasOwnProperty("totalCount") && (t.totalCount = n.convertToType(e.totalCount, "Number"))), t;
      }
    }]);
  }();
  se.prototype.items = void 0, se.prototype.totalCount = void 0;
  var pe = /*#__PURE__*/function () {
    function pe() {
      _classCallCheck(this, pe);
    }
    return _createClass(pe, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new pe(), e.hasOwnProperty("items") && (t.items = n.convertToType(e.items, [v])), e.hasOwnProperty("totalCount") && (t.totalCount = n.convertToType(e.totalCount, "Number"))), t;
      }
    }]);
  }();
  pe.prototype.items = void 0, pe.prototype.totalCount = void 0;
  var ce = /*#__PURE__*/function () {
    function ce() {
      _classCallCheck(this, ce);
    }
    return _createClass(ce, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new ce(), e.hasOwnProperty("items") && (t.items = n.convertToType(e.items, [A])), e.hasOwnProperty("totalCount") && (t.totalCount = n.convertToType(e.totalCount, "Number"))), t;
      }
    }]);
  }();
  ce.prototype.items = void 0, ce.prototype.totalCount = void 0;
  var le = /*#__PURE__*/function () {
    function le() {
      _classCallCheck(this, le);
    }
    return _createClass(le, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new le(), e.hasOwnProperty("items") && (t.items = n.convertToType(e.items, [P])), e.hasOwnProperty("totalCount") && (t.totalCount = n.convertToType(e.totalCount, "Number"))), t;
      }
    }]);
  }();
  le.prototype.items = void 0, le.prototype.totalCount = void 0;
  var fe = /*#__PURE__*/function () {
    function fe() {
      _classCallCheck(this, fe);
    }
    return _createClass(fe, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new fe(), e.hasOwnProperty("module") && (t.module = n.convertToType(e.module, "Number")), e.hasOwnProperty("subTenantId") && (t.subTenantId = n.convertToType(e.subTenantId, "String"))), t;
      }
    }]);
  }();
  fe.prototype.module = void 0, fe.prototype.subTenantId = void 0;
  var ye = /*#__PURE__*/function () {
    function ye() {
      _classCallCheck(this, ye);
    }
    return _createClass(ye, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new ye(), e.hasOwnProperty("accessToken") && (t.accessToken = n.convertToType(e.accessToken, "String")), e.hasOwnProperty("accessTokenLifetime") && (t.accessTokenLifetime = n.convertToType(e.accessTokenLifetime, "Number"))), t;
      }
    }]);
  }();
  ye.prototype.accessToken = void 0, ye.prototype.accessTokenLifetime = void 0;
  var $ = /*#__PURE__*/function () {
    function $() {
      _classCallCheck(this, $);
    }
    return _createClass($, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new $(), e.hasOwnProperty("hidden") && (t.hidden = n.convertToType(e.hidden, "Boolean")), e.hasOwnProperty("icon") && (t.icon = n.convertToType(e.icon, "String")), e.hasOwnProperty("id") && (t.id = n.convertToType(e.id, "String")), e.hasOwnProperty("permissionMode") && (t.permissionMode = n.convertToType(e.permissionMode, "Number")), e.hasOwnProperty("title") && (t.title = n.convertToType(e.title, "String"))), t;
      }
    }]);
  }();
  $.prototype.hidden = void 0, $.prototype.icon = void 0, $.prototype.id = void 0, $.prototype.permissionMode = void 0, $.prototype.title = void 0;
  var k = /*#__PURE__*/function () {
    function k() {
      _classCallCheck(this, k);
    }
    return _createClass(k, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new k(), e.hasOwnProperty("desc") && (t.desc = n.convertToType(e.desc, "String")), e.hasOwnProperty("group") && (t.group = n.convertToType(e.group, "String")), e.hasOwnProperty("id") && (t.id = n.convertToType(e.id, "String")), e.hasOwnProperty("isInner") && (t.isInner = n.convertToType(e.isInner, "Boolean")), e.hasOwnProperty("menuId") && (t.menuId = n.convertToType(e.menuId, "String")), e.hasOwnProperty("name") && (t.name = n.convertToType(e.name, "String")), e.hasOwnProperty("operationKey") && (t.operationKey = n.convertToType(e.operationKey, "String")), e.hasOwnProperty("permissionType") && (t.permissionType = n.convertToType(e.permissionType, "Number")), e.hasOwnProperty("seqNo") && (t.seqNo = n.convertToType(e.seqNo, "Number")), e.hasOwnProperty("url") && (t.url = n.convertToType(e.url, "String")), e.hasOwnProperty("value") && (t.value = n.convertToType(e.value, "Number"))), t;
      }
    }]);
  }();
  k.prototype.desc = void 0, k.prototype.group = void 0, k.prototype.id = void 0, k.prototype.isInner = void 0, k.prototype.menuId = void 0, k.prototype.name = void 0, k.prototype.operationKey = void 0, k.prototype.permissionType = void 0, k.prototype.seqNo = void 0, k.prototype.url = void 0, k.prototype.value = void 0;
  var T = /*#__PURE__*/function () {
    function T() {
      _classCallCheck(this, T);
    }
    return _createClass(T, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new T(), e.hasOwnProperty("clientKey") && (t.clientKey = n.convertToType(e.clientKey, "String")), e.hasOwnProperty("flag") && (t.flag = n.convertToType(e.flag, "Number")), e.hasOwnProperty("hidden") && (t.hidden = n.convertToType(e.hidden, "Boolean")), e.hasOwnProperty("icon") && (t.icon = n.convertToType(e.icon, "String")), e.hasOwnProperty("id") && (t.id = n.convertToType(e.id, "String")), e.hasOwnProperty("isActive") && (t.isActive = n.convertToType(e.isActive, "Boolean")), e.hasOwnProperty("isDefine") && (t.isDefine = n.convertToType(e.isDefine, "Boolean")), e.hasOwnProperty("isHomeMenu") && (t.isHomeMenu = n.convertToType(e.isHomeMenu, "Boolean")), e.hasOwnProperty("isLeaf") && (t.isLeaf = n.convertToType(e.isLeaf, "Boolean")), e.hasOwnProperty("isVisibleInMenu") && (t.isVisibleInMenu = n.convertToType(e.isVisibleInMenu, "Boolean")), e.hasOwnProperty("menuGroup") && (t.menuGroup = n.convertToType(e.menuGroup, "String")), e.hasOwnProperty("menuKey") && (t.menuKey = n.convertToType(e.menuKey, "String")), e.hasOwnProperty("metaMenuIsDeleted") && (t.metaMenuIsDeleted = n.convertToType(e.metaMenuIsDeleted, "Boolean")), e.hasOwnProperty("name") && (t.name = n.convertToType(e.name, "String")), e.hasOwnProperty("openType") && (t.openType = n.convertToType(e.openType, "Number")), e.hasOwnProperty("operations") && (t.operations = n.convertToType(e.operations, [k])), e.hasOwnProperty("originMeta") && (t.originMeta = $.constructFromObject(e.originMeta)), e.hasOwnProperty("parentId") && (t.parentId = n.convertToType(e.parentId, "String")), e.hasOwnProperty("path") && (t.path = n.convertToType(e.path, "String")), e.hasOwnProperty("permissionMode") && (t.permissionMode = n.convertToType(e.permissionMode, "Number")), e.hasOwnProperty("seqNo") && (t.seqNo = n.convertToType(e.seqNo, "Number")), e.hasOwnProperty("title") && (t.title = n.convertToType(e.title, "String")), e.hasOwnProperty("topId") && (t.topId = n.convertToType(e.topId, "String")), e.hasOwnProperty("url") && (t.url = n.convertToType(e.url, "String")), e.hasOwnProperty("version") && (t.version = n.convertToType(e.version, "String"))), t;
      }
    }]);
  }();
  T.prototype.clientKey = void 0, T.prototype.flag = void 0, T.prototype.hidden = void 0, T.prototype.icon = void 0, T.prototype.id = void 0, T.prototype.isActive = void 0, T.prototype.isDefine = void 0, T.prototype.isHomeMenu = void 0, T.prototype.isLeaf = void 0, T.prototype.isVisibleInMenu = void 0, T.prototype.menuGroup = void 0, T.prototype.menuKey = void 0, T.prototype.metaMenuIsDeleted = void 0, T.prototype.name = void 0, T.prototype.openType = void 0, T.prototype.operations = void 0, T.prototype.originMeta = void 0, T.prototype.parentId = void 0, T.prototype.path = void 0, T.prototype.permissionMode = void 0, T.prototype.seqNo = void 0, T.prototype.title = void 0, T.prototype.topId = void 0, T.prototype.url = void 0, T.prototype.version = void 0;
  var Ae = /*#__PURE__*/function () {
    function Ae(e) {
      _classCallCheck(this, Ae);
      this.apiClient = e || n.GetInstance("auth-server", "ApiResourceApi");
    }
    return _createClass(Ae, [{
      key: "addSecretWithHttpInfo",
      value: function addSecretWithHttpInfo(e, t) {
        t = t || {};
        var i = t.body;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling addSecret");
        var r = {
            id: e
          },
          o = {},
          s = t.header || {},
          p = {},
          c = ["oauth2"],
          l = ["application/_*+json", "application/json", "text/json"],
          y = ["application/json", "text/json", "text/plain"],
          S = P;
        return this.apiClient.callApi("/api/identity-server/api-resources/{id}/secrets", "POST", r, o, s, p, i, c, l, y, S);
      }
    }, {
      key: "addSecret",
      value: function addSecret(e, t) {
        return this.addSecretWithHttpInfo(e, t);
      }
    }, {
      key: "callDeleteWithHttpInfo",
      value: function callDeleteWithHttpInfo(e) {
        var t = null;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling callDelete");
        var i = {
            id: e
          },
          r = {},
          o = {},
          s = {},
          p = ["oauth2"],
          c = [],
          l = ["application/json", "text/json", "text/plain"],
          y = null;
        return this.apiClient.callApi("/api/identity-server/api-resources/{id}", "DELETE", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "callDelete",
      value: function callDelete(e) {
        return this.callDeleteWithHttpInfo(e);
      }
    }, {
      key: "createWithHttpInfo",
      value: function createWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          i = {},
          r = {},
          o = e.header || {},
          s = {},
          p = ["oauth2"],
          c = ["application/_*+json", "application/json", "text/json"],
          l = ["application/json", "text/json", "text/plain"],
          y = P;
        return this.apiClient.callApi("/api/identity-server/api-resources", "POST", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "create",
      value: function create(e) {
        return this.createWithHttpInfo(e);
      }
    }, {
      key: "findByNameWithHttpInfo",
      value: function findByNameWithHttpInfo(e) {
        e = e || {};
        var t = null,
          i = {},
          r = {
            name: e.name
          },
          o = e.header || {},
          s = {},
          p = ["oauth2"],
          c = [],
          l = ["application/json", "text/json", "text/plain"],
          y = P;
        return this.apiClient.callApi("/api/identity-server/api-resources/by-name", "GET", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "findByName",
      value: function findByName(e) {
        return this.findByNameWithHttpInfo(e);
      }
    }, {
      key: "getWithHttpInfo",
      value: function getWithHttpInfo(e) {
        var t = null;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling get");
        var i = {
            id: e
          },
          r = {},
          o = {},
          s = {},
          p = ["oauth2"],
          c = [],
          l = ["application/json", "text/json", "text/plain"],
          y = P;
        return this.apiClient.callApi("/api/identity-server/api-resources/{id}", "GET", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "get",
      value: function get(e) {
        return this.getWithHttpInfo(e);
      }
    }, {
      key: "getApiScopesWithHttpInfo",
      value: function getApiScopesWithHttpInfo(e) {
        var t = null;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling getApiScopes");
        var i = {
            id: e
          },
          r = {},
          o = {},
          s = {},
          p = ["oauth2"],
          c = [],
          l = ["application/json", "text/json", "text/plain"],
          y = [g];
        return this.apiClient.callApi("/api/identity-server/api-resources/{id}/api-scopes", "GET", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "getApiScopes",
      value: function getApiScopes(e) {
        return this.getApiScopesWithHttpInfo(e);
      }
    }, {
      key: "getListWithHttpInfo",
      value: function getListWithHttpInfo(e) {
        e = e || {};
        var t = null,
          i = {},
          r = {
            Sorting: e.sorting,
            SkipCount: e.skipCount,
            MaxResultCount: e.maxResultCount
          },
          o = e.header || {},
          s = {},
          p = ["oauth2"],
          c = [],
          l = ["application/json", "text/json", "text/plain"],
          y = le;
        return this.apiClient.callApi("/api/identity-server/api-resources", "GET", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "getList",
      value: function getList(e) {
        return this.getListWithHttpInfo(e);
      }
    }, {
      key: "removeSeccretWithHttpInfo",
      value: function removeSeccretWithHttpInfo(e, t) {
        t = t || {};
        var i = null;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling removeSeccret");
        var r = {
            id: e
          },
          o = {
            value: t.value,
            type: t.type
          },
          s = t.header || {},
          p = {},
          c = ["oauth2"],
          l = [],
          y = ["application/json", "text/json", "text/plain"],
          S = t.returnType || null;
        return this.apiClient.callApi("/api/identity-server/api-resources/{id}/secrets", "DELETE", r, o, s, p, i, c, l, y, S);
      }
    }, {
      key: "removeSeccret",
      value: function removeSeccret(e, t) {
        return this.removeSeccretWithHttpInfo(e, t);
      }
    }, {
      key: "updateWithHttpInfo",
      value: function updateWithHttpInfo(e, t) {
        t = t || {};
        var i = t.body;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling update");
        var r = {
            id: e
          },
          o = {},
          s = t.header || {},
          p = {},
          c = ["oauth2"],
          l = ["application/_*+json", "application/json", "text/json"],
          y = ["application/json", "text/json", "text/plain"],
          S = P;
        return this.apiClient.callApi("/api/identity-server/api-resources/{id}", "PUT", r, o, s, p, i, c, l, y, S);
      }
    }, {
      key: "update",
      value: function update(e, t) {
        return this.updateWithHttpInfo(e, t);
      }
    }]);
  }();
  D(Ae, "Methods", {
    addSecret: {
      desc: "添加密钥",
      method: "POST",
      path: "/api/identity-server/api-resources/{id}/secrets"
    },
    callDelete: {
      desc: "删除Api资源",
      method: "DELETE",
      path: "/api/identity-server/api-resources/{id}"
    },
    create: {
      desc: "新增Api资源",
      method: "POST",
      path: "/api/identity-server/api-resources"
    },
    findByName: {
      desc: "根据名称查找Api资源",
      method: "GET",
      path: "/api/identity-server/api-resources/by-name"
    },
    get: {
      desc: "获取Api资源",
      method: "GET",
      path: "/api/identity-server/api-resources/{id}"
    },
    getApiScopes: {
      desc: "获取资源的Api范围列表",
      method: "GET",
      path: "/api/identity-server/api-resources/{id}/api-scopes"
    },
    getList: {
      desc: "获取Api资源列表",
      method: "GET",
      path: "/api/identity-server/api-resources"
    },
    removeSeccret: {
      desc: "删除密钥",
      method: "DELETE",
      path: "/api/identity-server/api-resources/{id}/secrets"
    },
    update: {
      desc: "编辑Api资源",
      method: "PUT",
      path: "/api/identity-server/api-resources/{id}"
    }
  });
  var ke = /*#__PURE__*/function () {
    function ke(e) {
      _classCallCheck(this, ke);
      this.apiClient = e || n.GetInstance("auth-server", "ApiScopeApi");
    }
    return _createClass(ke, [{
      key: "callDeleteWithHttpInfo",
      value: function callDeleteWithHttpInfo(e) {
        var t = null;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling callDelete");
        var i = {
            id: e
          },
          r = {},
          o = {},
          s = {},
          p = ["oauth2"],
          c = [],
          l = ["application/json", "text/json", "text/plain"],
          y = null;
        return this.apiClient.callApi("/api/identity-server/api-scopes/{id}", "DELETE", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "callDelete",
      value: function callDelete(e) {
        return this.callDeleteWithHttpInfo(e);
      }
    }, {
      key: "createWithHttpInfo",
      value: function createWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          i = {},
          r = {},
          o = e.header || {},
          s = {},
          p = ["oauth2"],
          c = ["application/_*+json", "application/json", "text/json"],
          l = ["application/json", "text/json", "text/plain"],
          y = g;
        return this.apiClient.callApi("/api/identity-server/api-scopes", "POST", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "create",
      value: function create(e) {
        return this.createWithHttpInfo(e);
      }
    }, {
      key: "findByNameWithHttpInfo",
      value: function findByNameWithHttpInfo(e) {
        e = e || {};
        var t = null,
          i = {},
          r = {
            name: e.name
          },
          o = e.header || {},
          s = {},
          p = ["oauth2"],
          c = [],
          l = ["application/json", "text/json", "text/plain"],
          y = g;
        return this.apiClient.callApi("/api/identity-server/api-scopes/by-name", "GET", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "findByName",
      value: function findByName(e) {
        return this.findByNameWithHttpInfo(e);
      }
    }, {
      key: "getWithHttpInfo",
      value: function getWithHttpInfo(e) {
        var t = null;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling get");
        var i = {
            id: e
          },
          r = {},
          o = {},
          s = {},
          p = ["oauth2"],
          c = [],
          l = ["application/json", "text/json", "text/plain"],
          y = g;
        return this.apiClient.callApi("/api/identity-server/api-scopes/{id}", "GET", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "get",
      value: function get(e) {
        return this.getWithHttpInfo(e);
      }
    }, {
      key: "getApiResourceNamesWithHttpInfo",
      value: function getApiResourceNamesWithHttpInfo(e) {
        var t = null;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling getApiResourceNames");
        var i = {
            id: e
          },
          r = {},
          o = {},
          s = {},
          p = ["oauth2"],
          c = [],
          l = ["application/json", "text/json", "text/plain"],
          y = ["String"];
        return this.apiClient.callApi("/api/identity-server/api-scopes/{id}/resource-names", "GET", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "getApiResourceNames",
      value: function getApiResourceNames(e) {
        return this.getApiResourceNamesWithHttpInfo(e);
      }
    }, {
      key: "getListWithHttpInfo",
      value: function getListWithHttpInfo(e) {
        e = e || {};
        var t = null,
          i = {},
          r = {
            Sorting: e.sorting,
            SkipCount: e.skipCount,
            MaxResultCount: e.maxResultCount
          },
          o = e.header || {},
          s = {},
          p = ["oauth2"],
          c = [],
          l = ["application/json", "text/json", "text/plain"],
          y = ie;
        return this.apiClient.callApi("/api/identity-server/api-scopes", "GET", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "getList",
      value: function getList(e) {
        return this.getListWithHttpInfo(e);
      }
    }, {
      key: "updateWithHttpInfo",
      value: function updateWithHttpInfo(e, t) {
        t = t || {};
        var i = t.body;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling update");
        var r = {
            id: e
          },
          o = {},
          s = t.header || {},
          p = {},
          c = ["oauth2"],
          l = ["application/_*+json", "application/json", "text/json"],
          y = ["application/json", "text/json", "text/plain"],
          S = g;
        return this.apiClient.callApi("/api/identity-server/api-scopes/{id}", "PUT", r, o, s, p, i, c, l, y, S);
      }
    }, {
      key: "update",
      value: function update(e, t) {
        return this.updateWithHttpInfo(e, t);
      }
    }]);
  }();
  D(ke, "Methods", {
    callDelete: {
      desc: "删除Api范围",
      method: "DELETE",
      path: "/api/identity-server/api-scopes/{id}"
    },
    create: {
      desc: "新增Api范围",
      method: "POST",
      path: "/api/identity-server/api-scopes"
    },
    findByName: {
      desc: "根据名称查找Api范围",
      method: "GET",
      path: "/api/identity-server/api-scopes/by-name"
    },
    get: {
      desc: "获取Api范围",
      method: "GET",
      path: "/api/identity-server/api-scopes/{id}"
    },
    getApiResourceNames: {
      desc: "获取用到指定范围的Api资源列表",
      method: "GET",
      path: "/api/identity-server/api-scopes/{id}/resource-names"
    },
    getList: {
      desc: "获取Api范围列表",
      method: "GET",
      path: "/api/identity-server/api-scopes"
    },
    update: {
      desc: "编辑Api范围",
      method: "PUT",
      path: "/api/identity-server/api-scopes/{id}"
    }
  });
  var Ne = /*#__PURE__*/function () {
    function Ne(e) {
      _classCallCheck(this, Ne);
      this.apiClient = e || n.GetInstance("auth-server", "AuditLogApi");
    }
    return _createClass(Ne, [{
      key: "callDeleteWithHttpInfo",
      value: function callDeleteWithHttpInfo(e) {
        var t = null;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling callDelete");
        var i = {
            id: e
          },
          r = {},
          o = {},
          s = {},
          p = ["oauth2"],
          c = [],
          l = ["application/json", "text/json", "text/plain"],
          y = null;
        return this.apiClient.callApi("/api/audit-logging/audit-logs/{id}", "DELETE", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "callDelete",
      value: function callDelete(e) {
        return this.callDeleteWithHttpInfo(e);
      }
    }, {
      key: "deleteManyWithHttpInfo",
      value: function deleteManyWithHttpInfo(e) {
        e = e || {};
        var t = null,
          i = {},
          r = {
            ids: this.apiClient.buildCollectionParam(e.ids, "multi")
          },
          o = e.header || {},
          s = {},
          p = ["oauth2"],
          c = [],
          l = ["application/json", "text/json", "text/plain"],
          y = e.returnType || null;
        return this.apiClient.callApi("/api/audit-logging/audit-logs/delete-many", "DELETE", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "deleteMany",
      value: function deleteMany(e) {
        return this.deleteManyWithHttpInfo(e);
      }
    }, {
      key: "getWithHttpInfo",
      value: function getWithHttpInfo(e) {
        var t = null;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling get");
        var i = {
            id: e
          },
          r = {},
          o = {},
          s = {},
          p = ["oauth2"],
          c = [],
          l = ["application/json", "text/json", "text/plain"],
          y = m;
        return this.apiClient.callApi("/api/audit-logging/audit-logs/{id}", "GET", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "get",
      value: function get(e) {
        return this.getWithHttpInfo(e);
      }
    }, {
      key: "getListWithHttpInfo",
      value: function getListWithHttpInfo(e) {
        e = e || {};
        var t = null,
          i = {},
          r = {
            StartTime: e.startTime,
            EndTime: e.endTime,
            HttpMethod: e.httpMethod,
            Url: e.url,
            UserName: e.userName,
            ApplicationName: e.applicationName,
            CorrelationId: e.correlationId,
            MaxExecutionDuration: e.maxExecutionDuration,
            MinExecutionDuration: e.minExecutionDuration,
            HasException: e.hasException,
            HttpStatusCode: e.httpStatusCode,
            IncludeDetails: e.includeDetails,
            Sorting: e.sorting,
            SkipCount: e.skipCount,
            MaxResultCount: e.maxResultCount
          },
          o = e.header || {},
          s = {},
          p = ["oauth2"],
          c = [],
          l = ["application/json", "text/json", "text/plain"],
          y = oe;
        return this.apiClient.callApi("/api/audit-logging/audit-logs", "GET", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "getList",
      value: function getList(e) {
        return this.getListWithHttpInfo(e);
      }
    }]);
  }();
  D(Ne, "Methods", {
    callDelete: {
      desc: "删除审计日志",
      method: "DELETE",
      path: "/api/audit-logging/audit-logs/{id}"
    },
    deleteMany: {
      desc: "批量删除审计日志",
      method: "DELETE",
      path: "/api/audit-logging/audit-logs/delete-many"
    },
    get: {
      desc: "获取审计日志",
      method: "GET",
      path: "/api/audit-logging/audit-logs/{id}"
    },
    getList: {
      desc: "查询分页审计日志列表",
      method: "GET",
      path: "/api/audit-logging/audit-logs"
    }
  });
  var Le = /*#__PURE__*/function () {
    function Le(e) {
      _classCallCheck(this, Le);
      this.apiClient = e || n.GetInstance("auth-server", "ClientApi");
    }
    return _createClass(Le, [{
      key: "addSecretWithHttpInfo",
      value: function addSecretWithHttpInfo(e, t) {
        t = t || {};
        var i = t.body;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling addSecret");
        var r = {
            id: e
          },
          o = {},
          s = t.header || {},
          p = {},
          c = ["oauth2"],
          l = ["application/_*+json", "application/json", "text/json"],
          y = ["application/json", "text/json", "text/plain"],
          S = u;
        return this.apiClient.callApi("/api/identity-server/clients/{id}/secrets", "POST", r, o, s, p, i, c, l, y, S);
      }
    }, {
      key: "addSecret",
      value: function addSecret(e, t) {
        return this.addSecretWithHttpInfo(e, t);
      }
    }, {
      key: "callDeleteWithHttpInfo",
      value: function callDeleteWithHttpInfo(e) {
        var t = null;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling callDelete");
        var i = {
            id: e
          },
          r = {},
          o = {},
          s = {},
          p = ["oauth2"],
          c = [],
          l = ["application/json", "text/json", "text/plain"],
          y = null;
        return this.apiClient.callApi("/api/identity-server/clients/{id}", "DELETE", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "callDelete",
      value: function callDelete(e) {
        return this.callDeleteWithHttpInfo(e);
      }
    }, {
      key: "createWithHttpInfo",
      value: function createWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          i = {},
          r = {},
          o = e.header || {},
          s = {},
          p = ["oauth2"],
          c = ["application/_*+json", "application/json", "text/json"],
          l = ["application/json", "text/json", "text/plain"],
          y = u;
        return this.apiClient.callApi("/api/identity-server/clients", "POST", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "create",
      value: function create(e) {
        return this.createWithHttpInfo(e);
      }
    }, {
      key: "findByClientIdWithHttpInfo",
      value: function findByClientIdWithHttpInfo(e) {
        e = e || {};
        var t = null,
          i = {},
          r = {
            clientId: e.clientId
          },
          o = e.header || {},
          s = {},
          p = ["oauth2"],
          c = [],
          l = ["application/json", "text/json", "text/plain"],
          y = u;
        return this.apiClient.callApi("/api/identity-server/clients/by-client-id", "GET", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "findByClientId",
      value: function findByClientId(e) {
        return this.findByClientIdWithHttpInfo(e);
      }
    }, {
      key: "getWithHttpInfo",
      value: function getWithHttpInfo(e) {
        var t = null;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling get");
        var i = {
            id: e
          },
          r = {},
          o = {},
          s = {},
          p = ["oauth2"],
          c = [],
          l = ["application/json", "text/json", "text/plain"],
          y = u;
        return this.apiClient.callApi("/api/identity-server/clients/{id}", "GET", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "get",
      value: function get(e) {
        return this.getWithHttpInfo(e);
      }
    }, {
      key: "getListWithHttpInfo",
      value: function getListWithHttpInfo(e) {
        e = e || {};
        var t = null,
          i = {},
          r = {
            Filter: e.filter,
            Sorting: e.sorting,
            SkipCount: e.skipCount,
            MaxResultCount: e.maxResultCount
          },
          o = e.header || {},
          s = {},
          p = ["oauth2"],
          c = [],
          l = ["application/json", "text/json", "text/plain"],
          y = se;
        return this.apiClient.callApi("/api/identity-server/clients", "GET", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "getList",
      value: function getList(e) {
        return this.getListWithHttpInfo(e);
      }
    }, {
      key: "removeSeccretWithHttpInfo",
      value: function removeSeccretWithHttpInfo(e, t) {
        t = t || {};
        var i = null;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling removeSeccret");
        var r = {
            id: e
          },
          o = {
            value: t.value,
            type: t.type
          },
          s = t.header || {},
          p = {},
          c = ["oauth2"],
          l = [],
          y = ["application/json", "text/json", "text/plain"],
          S = t.returnType || null;
        return this.apiClient.callApi("/api/identity-server/clients/{id}/secrets", "DELETE", r, o, s, p, i, c, l, y, S);
      }
    }, {
      key: "removeSeccret",
      value: function removeSeccret(e, t) {
        return this.removeSeccretWithHttpInfo(e, t);
      }
    }, {
      key: "searchConstsWithHttpInfo",
      value: function searchConstsWithHttpInfo(e) {
        e = e || {};
        var t = null,
          i = {},
          r = {
            Type: e.type,
            Filter: e.filter,
            Limit: e.limit
          },
          o = e.header || {},
          s = {},
          p = ["oauth2"],
          c = [],
          l = ["application/json", "text/json", "text/plain"],
          y = ["String"];
        return this.apiClient.callApi("/api/identity-server/clients/search-consts", "GET", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "searchConsts",
      value: function searchConsts(e) {
        return this.searchConstsWithHttpInfo(e);
      }
    }, {
      key: "updateWithHttpInfo",
      value: function updateWithHttpInfo(e, t) {
        t = t || {};
        var i = t.body;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling update");
        var r = {
            id: e
          },
          o = {},
          s = t.header || {},
          p = {},
          c = ["oauth2"],
          l = ["application/_*+json", "application/json", "text/json"],
          y = ["application/json", "text/json", "text/plain"],
          S = u;
        return this.apiClient.callApi("/api/identity-server/clients/{id}", "PUT", r, o, s, p, i, c, l, y, S);
      }
    }, {
      key: "update",
      value: function update(e, t) {
        return this.updateWithHttpInfo(e, t);
      }
    }]);
  }();
  D(Le, "Methods", {
    addSecret: {
      desc: "添加客户端密钥",
      method: "POST",
      path: "/api/identity-server/clients/{id}/secrets"
    },
    callDelete: {
      desc: "删除客户端",
      method: "DELETE",
      path: "/api/identity-server/clients/{id}"
    },
    create: {
      desc: "创建客户端",
      method: "POST",
      path: "/api/identity-server/clients"
    },
    findByClientId: {
      desc: "根据ClientId查找客户端",
      method: "GET",
      path: "/api/identity-server/clients/by-client-id"
    },
    get: {
      desc: "获取客户端",
      method: "GET",
      path: "/api/identity-server/clients/{id}"
    },
    getList: {
      desc: "获取客户端列表",
      method: "GET",
      path: "/api/identity-server/clients"
    },
    removeSeccret: {
      desc: "删除密钥",
      method: "DELETE",
      path: "/api/identity-server/clients/{id}/secrets"
    },
    searchConsts: {
      desc: "查找可用数据",
      method: "GET",
      path: "/api/identity-server/clients/search-consts"
    },
    update: {
      desc: "更新客户端",
      method: "PUT",
      path: "/api/identity-server/clients/{id}"
    }
  });
  var xe = /*#__PURE__*/function () {
    function xe(e) {
      _classCallCheck(this, xe);
      this.apiClient = e || n.GetInstance("auth-server", "EafCacheApi");
    }
    return _createClass(xe, [{
      key: "clearMenuCachaWithHttpInfo",
      value: function clearMenuCachaWithHttpInfo() {
        var e = null,
          t = {},
          i = {},
          r = {},
          o = {},
          s = ["oauth2"],
          p = [],
          c = ["application/json", "text/json", "text/plain"],
          l = null;
        return this.apiClient.callApi("/api/eaf-cache/clear-meta-menu-cache", "POST", t, i, r, o, e, s, p, c, l);
      }
    }, {
      key: "clearMenuCacha",
      value: function clearMenuCacha() {
        return this.clearMenuCachaWithHttpInfo();
      }
    }, {
      key: "clearTenantIdentityClientCachaWithHttpInfo",
      value: function clearTenantIdentityClientCachaWithHttpInfo(e) {
        e = e || {};
        var t = null,
          i = {},
          r = {
            tenantId: e.tenantId,
            clientId: e.clientId
          },
          o = e.header || {},
          s = {},
          p = ["oauth2"],
          c = [],
          l = ["application/json", "text/json", "text/plain"],
          y = e.returnType || null;
        return this.apiClient.callApi("/api/eaf-cache/clear-identity-client-cache", "POST", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "clearTenantIdentityClientCacha",
      value: function clearTenantIdentityClientCacha(e) {
        return this.clearTenantIdentityClientCachaWithHttpInfo(e);
      }
    }, {
      key: "clearTenantMenuCachaWithHttpInfo",
      value: function clearTenantMenuCachaWithHttpInfo(e) {
        e = e || {};
        var t = null,
          i = {},
          r = {
            tenantId: e.tenantId
          },
          o = e.header || {},
          s = {},
          p = ["oauth2"],
          c = [],
          l = ["application/json", "text/json", "text/plain"],
          y = e.returnType || null;
        return this.apiClient.callApi("/api/eaf-cache/clear-tenant-menu-cache", "POST", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "clearTenantMenuCacha",
      value: function clearTenantMenuCacha(e) {
        return this.clearTenantMenuCachaWithHttpInfo(e);
      }
    }, {
      key: "getIdentityClientCachaWithHttpInfo",
      value: function getIdentityClientCachaWithHttpInfo(e) {
        e = e || {};
        var t = null,
          i = {},
          r = {
            tenantId: e.tenantId,
            clientId: e.clientId
          },
          o = e.header || {},
          s = {},
          p = ["oauth2"],
          c = [],
          l = ["application/json", "text/json", "text/plain"],
          y = d;
        return this.apiClient.callApi("/api/eaf-cache/identity-client-cache", "GET", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "getIdentityClientCacha",
      value: function getIdentityClientCacha(e) {
        return this.getIdentityClientCachaWithHttpInfo(e);
      }
    }, {
      key: "getMenuCachaWithHttpInfo",
      value: function getMenuCachaWithHttpInfo() {
        var e = null,
          t = {},
          i = {},
          r = {},
          o = {},
          s = ["oauth2"],
          p = [],
          c = ["application/json", "text/json", "text/plain"],
          l = [f];
        return this.apiClient.callApi("/api/eaf-cache/meta-menu-cache", "GET", t, i, r, o, e, s, p, c, l);
      }
    }, {
      key: "getMenuCacha",
      value: function getMenuCacha() {
        return this.getMenuCachaWithHttpInfo();
      }
    }, {
      key: "getTenantMenuCachaWithHttpInfo",
      value: function getTenantMenuCachaWithHttpInfo(e) {
        e = e || {};
        var t = null,
          i = {},
          r = {
            tenantId: e.tenantId
          },
          o = e.header || {},
          s = {},
          p = ["oauth2"],
          c = [],
          l = ["application/json", "text/json", "text/plain"],
          y = [T];
        return this.apiClient.callApi("/api/eaf-cache/tenant-menu-cache", "GET", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "getTenantMenuCacha",
      value: function getTenantMenuCacha(e) {
        return this.getTenantMenuCachaWithHttpInfo(e);
      }
    }]);
  }();
  D(xe, "Methods", {
    clearMenuCacha: {
      desc: "清理元菜单缓存数据",
      method: "POST",
      path: "/api/eaf-cache/clear-meta-menu-cache"
    },
    clearTenantIdentityClientCacha: {
      desc: "清理租户客户端缓存",
      method: "POST",
      path: "/api/eaf-cache/clear-identity-client-cache"
    },
    clearTenantMenuCacha: {
      desc: "清理租户菜单缓存",
      method: "POST",
      path: "/api/eaf-cache/clear-tenant-menu-cache"
    },
    getIdentityClientCacha: {
      desc: "获取租户的客户端缓存",
      method: "GET",
      path: "/api/eaf-cache/identity-client-cache"
    },
    getMenuCacha: {
      desc: "获取元菜单缓存数据",
      method: "GET",
      path: "/api/eaf-cache/meta-menu-cache"
    },
    getTenantMenuCacha: {
      desc: "获取租户菜单缓存",
      method: "GET",
      path: "/api/eaf-cache/tenant-menu-cache"
    }
  });
  var De = /*#__PURE__*/function () {
    function De(e) {
      _classCallCheck(this, De);
      this.apiClient = e || n.GetInstance("auth-server", "EafLoginApi");
    }
    return _createClass(De, [{
      key: "connectCodeWithHttpInfo",
      value: function connectCodeWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          i = {},
          r = {},
          o = e.header || {},
          s = {},
          p = ["oauth2"],
          c = ["application/_*+json", "application/json", "text/json"],
          l = ["application/json", "text/json", "text/plain"],
          y = G;
        return this.apiClient.callApi("/api/eaf-login/connect-token", "POST", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "connectCode",
      value: function connectCode(e) {
        return this.connectCodeWithHttpInfo(e);
      }
    }, {
      key: "getValidateCodeWithHttpInfo",
      value: function getValidateCodeWithHttpInfo(e) {
        e = e || {};
        var t = null,
          i = {},
          r = {
            codeId: e.codeId
          },
          o = e.header || {},
          s = {},
          p = ["oauth2"],
          c = [],
          l = ["application/json", "text/json", "text/plain"],
          y = re;
        return this.apiClient.callApi("/api/eaf-login/validate-code", "GET", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "getValidateCode",
      value: function getValidateCode(e) {
        return this.getValidateCodeWithHttpInfo(e);
      }
    }, {
      key: "loginWithHttpInfo",
      value: function loginWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          i = {},
          r = {},
          o = e.header || {},
          s = {},
          p = ["oauth2"],
          c = ["application/_*+json", "application/json", "text/json"],
          l = ["application/json", "text/json", "text/plain"],
          y = j;
        return this.apiClient.callApi("/api/eaf-login/login", "POST", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "login",
      value: function login(e) {
        return this.loginWithHttpInfo(e);
      }
    }, {
      key: "logoutWithHttpInfo",
      value: function logoutWithHttpInfo() {
        var e = null,
          t = {},
          i = {},
          r = {},
          o = {},
          s = ["oauth2"],
          p = [],
          c = ["application/json", "text/json", "text/plain"],
          l = null;
        return this.apiClient.callApi("/api/eaf-login/logout", "GET", t, i, r, o, e, s, p, c, l);
      }
    }, {
      key: "logout",
      value: function logout() {
        return this.logoutWithHttpInfo();
      }
    }, {
      key: "rSAEncryptWithHttpInfo",
      value: function rSAEncryptWithHttpInfo() {
        var e = null,
          t = {},
          i = {},
          r = {},
          o = {},
          s = ["oauth2"],
          p = [],
          c = ["application/json", "text/json", "text/plain"],
          l = de;
        return this.apiClient.callApi("/api/eaf-login/rsa-public-key", "GET", t, i, r, o, e, s, p, c, l);
      }
    }, {
      key: "rSAEncrypt",
      value: function rSAEncrypt() {
        return this.rSAEncryptWithHttpInfo();
      }
    }, {
      key: "takeCodeWithHttpInfo",
      value: function takeCodeWithHttpInfo(e) {
        e = e || {};
        var t = null,
          i = {},
          r = {
            clientId: e.clientId,
            redirectUri: e.redirectUri
          },
          o = e.header || {},
          s = {},
          p = ["oauth2"],
          c = [],
          l = ["application/json", "text/json", "text/plain"],
          y = J;
        return this.apiClient.callApi("/api/eaf-login/eaf-code", "GET", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "takeCode",
      value: function takeCode(e) {
        return this.takeCodeWithHttpInfo(e);
      }
    }, {
      key: "takeOidcCodeWithHttpInfo",
      value: function takeOidcCodeWithHttpInfo(e, t, i, r) {
        var o = null;
        if (e == null) throw new Error("Missing the required parameter 'clientId' when calling takeOidcCode");
        if (t == null) throw new Error("Missing the required parameter 'redirectUri' when calling takeOidcCode");
        if (i == null) throw new Error("Missing the required parameter 'responseType' when calling takeOidcCode");
        if (r == null) throw new Error("Missing the required parameter 'scope' when calling takeOidcCode");
        var s = {},
          p = {
            client_id: e,
            redirect_uri: t,
            response_type: i,
            scope: r
          },
          c = {},
          l = {},
          y = ["oauth2"],
          S = [],
          we = ["application/json", "text/json", "text/plain"],
          I = J;
        return this.apiClient.callApi("/api/eaf-login/oidc-code", "GET", s, p, c, l, o, y, S, we, I);
      }
    }, {
      key: "takeOidcCode",
      value: function takeOidcCode(e, t, i, r) {
        return this.takeOidcCodeWithHttpInfo(e, t, i, r);
      }
    }, {
      key: "visitorLoginWithHttpInfo",
      value: function visitorLoginWithHttpInfo() {
        var e = null,
          t = {},
          i = {},
          r = {},
          o = {},
          s = ["oauth2"],
          p = [],
          c = ["application/json", "text/json", "text/plain"],
          l = j;
        return this.apiClient.callApi("/api/eaf-login/visitor-login", "POST", t, i, r, o, e, s, p, c, l);
      }
    }, {
      key: "visitorLogin",
      value: function visitorLogin() {
        return this.visitorLoginWithHttpInfo();
      }
    }]);
  }();
  D(De, "Methods", {
    connectCode: {
      desc: "获取Token",
      method: "POST",
      path: "/api/eaf-login/connect-token"
    },
    getValidateCode: {
      desc: "获取验证码",
      method: "GET",
      path: "/api/eaf-login/validate-code"
    },
    login: {
      method: "POST",
      path: "/api/eaf-login/login"
    },
    logout: {
      method: "GET",
      path: "/api/eaf-login/logout"
    },
    rSAEncrypt: {
      desc: "获取Rsa公钥",
      method: "GET",
      path: "/api/eaf-login/rsa-public-key"
    },
    takeCode: {
      desc: "创建SSO单点登录Code",
      method: "GET",
      path: "/api/eaf-login/eaf-code"
    },
    takeOidcCode: {
      desc: "自定义当前登录用户的token AuthCode生成",
      method: "GET",
      path: "/api/eaf-login/oidc-code"
    },
    visitorLogin: {
      desc: "游客登录",
      method: "POST",
      path: "/api/eaf-login/visitor-login"
    }
  });
  var Be = /*#__PURE__*/function () {
    function Be(e) {
      _classCallCheck(this, Be);
      this.apiClient = e || n.GetInstance("auth-server", "IdentityResourceApi");
    }
    return _createClass(Be, [{
      key: "callDeleteWithHttpInfo",
      value: function callDeleteWithHttpInfo(e) {
        var t = null;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling callDelete");
        var i = {
            id: e
          },
          r = {},
          o = {},
          s = {},
          p = ["oauth2"],
          c = [],
          l = ["application/json", "text/json", "text/plain"],
          y = null;
        return this.apiClient.callApi("/api/identity-server/identity-resources/{id}", "DELETE", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "callDelete",
      value: function callDelete(e) {
        return this.callDeleteWithHttpInfo(e);
      }
    }, {
      key: "createWithHttpInfo",
      value: function createWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          i = {},
          r = {},
          o = e.header || {},
          s = {},
          p = ["oauth2"],
          c = ["application/_*+json", "application/json", "text/json"],
          l = ["application/json", "text/json", "text/plain"],
          y = v;
        return this.apiClient.callApi("/api/identity-server/identity-resources", "POST", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "create",
      value: function create(e) {
        return this.createWithHttpInfo(e);
      }
    }, {
      key: "findByNameWithHttpInfo",
      value: function findByNameWithHttpInfo(e) {
        e = e || {};
        var t = null,
          i = {},
          r = {
            name: e.name
          },
          o = e.header || {},
          s = {},
          p = ["oauth2"],
          c = [],
          l = ["application/json", "text/json", "text/plain"],
          y = v;
        return this.apiClient.callApi("/api/identity-server/identity-resources/by-name", "GET", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "findByName",
      value: function findByName(e) {
        return this.findByNameWithHttpInfo(e);
      }
    }, {
      key: "getWithHttpInfo",
      value: function getWithHttpInfo(e) {
        var t = null;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling get");
        var i = {
            id: e
          },
          r = {},
          o = {},
          s = {},
          p = ["oauth2"],
          c = [],
          l = ["application/json", "text/json", "text/plain"],
          y = v;
        return this.apiClient.callApi("/api/identity-server/identity-resources/{id}", "GET", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "get",
      value: function get(e) {
        return this.getWithHttpInfo(e);
      }
    }, {
      key: "getListWithHttpInfo",
      value: function getListWithHttpInfo(e) {
        e = e || {};
        var t = null,
          i = {},
          r = {
            Filter: e.filter,
            Sorting: e.sorting,
            SkipCount: e.skipCount,
            MaxResultCount: e.maxResultCount
          },
          o = e.header || {},
          s = {},
          p = ["oauth2"],
          c = [],
          l = ["application/json", "text/json", "text/plain"],
          y = pe;
        return this.apiClient.callApi("/api/identity-server/identity-resources", "GET", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "getList",
      value: function getList(e) {
        return this.getListWithHttpInfo(e);
      }
    }, {
      key: "updateWithHttpInfo",
      value: function updateWithHttpInfo(e, t) {
        t = t || {};
        var i = t.body;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling update");
        var r = {
            id: e
          },
          o = {},
          s = t.header || {},
          p = {},
          c = ["oauth2"],
          l = ["application/_*+json", "application/json", "text/json"],
          y = ["application/json", "text/json", "text/plain"],
          S = v;
        return this.apiClient.callApi("/api/identity-server/identity-resources/{id}", "PUT", r, o, s, p, i, c, l, y, S);
      }
    }, {
      key: "update",
      value: function update(e, t) {
        return this.updateWithHttpInfo(e, t);
      }
    }]);
  }();
  D(Be, "Methods", {
    callDelete: {
      desc: "删除身份资源",
      method: "DELETE",
      path: "/api/identity-server/identity-resources/{id}"
    },
    create: {
      desc: "新增身份资源",
      method: "POST",
      path: "/api/identity-server/identity-resources"
    },
    findByName: {
      desc: "根据名称查找身份资源",
      method: "GET",
      path: "/api/identity-server/identity-resources/by-name"
    },
    get: {
      desc: "获取身份资源",
      method: "GET",
      path: "/api/identity-server/identity-resources/{id}"
    },
    getList: {
      desc: "查找身份资源列表",
      method: "GET",
      path: "/api/identity-server/identity-resources"
    },
    update: {
      desc: "编辑身份资源",
      method: "PUT",
      path: "/api/identity-server/identity-resources/{id}"
    }
  });
  var qe = /*#__PURE__*/function () {
    function qe(e) {
      _classCallCheck(this, qe);
      this.apiClient = e || n.GetInstance("auth-server", "PersistedGrantApi");
    }
    return _createClass(qe, [{
      key: "callDeleteWithHttpInfo",
      value: function callDeleteWithHttpInfo(e) {
        var t = null;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling callDelete");
        var i = {
            id: e
          },
          r = {},
          o = {},
          s = {},
          p = ["oauth2"],
          c = [],
          l = ["application/json", "text/json", "text/plain"],
          y = null;
        return this.apiClient.callApi("/api/identity-server/persisted-grants/{id}", "DELETE", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "callDelete",
      value: function callDelete(e) {
        return this.callDeleteWithHttpInfo(e);
      }
    }, {
      key: "getWithHttpInfo",
      value: function getWithHttpInfo(e) {
        var t = null;
        if (e == null) throw new Error("Missing the required parameter 'id' when calling get");
        var i = {
            id: e
          },
          r = {},
          o = {},
          s = {},
          p = ["oauth2"],
          c = [],
          l = ["application/json", "text/json", "text/plain"],
          y = A;
        return this.apiClient.callApi("/api/identity-server/persisted-grants/{id}", "GET", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "get",
      value: function get(e) {
        return this.getWithHttpInfo(e);
      }
    }, {
      key: "getListWithHttpInfo",
      value: function getListWithHttpInfo(e) {
        e = e || {};
        var t = null,
          i = {},
          r = {
            SkipCount: e.skipCount,
            MaxResultCount: e.maxResultCount
          },
          o = e.header || {},
          s = {},
          p = ["oauth2"],
          c = [],
          l = ["application/json", "text/json", "text/plain"],
          y = ce;
        return this.apiClient.callApi("/api/identity-server/persisted-grants", "GET", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "getList",
      value: function getList(e) {
        return this.getListWithHttpInfo(e);
      }
    }]);
  }();
  D(qe, "Methods", {
    callDelete: {
      desc: "删除授权",
      method: "DELETE",
      path: "/api/identity-server/persisted-grants/{id}"
    },
    get: {
      desc: "获取授权",
      method: "GET",
      path: "/api/identity-server/persisted-grants/{id}"
    },
    getList: {
      desc: "分页获取授权列表",
      method: "GET",
      path: "/api/identity-server/persisted-grants"
    }
  });
  var Ee = /*#__PURE__*/function () {
    function Ee(e) {
      _classCallCheck(this, Ee);
      this.apiClient = e || n.GetInstance("auth-server", "QyWechatApi");
    }
    return _createClass(Ee, [{
      key: "bindQyWxUserByCodeWithHttpInfo",
      value: function bindQyWxUserByCodeWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          i = {},
          r = {},
          o = e.header || {},
          s = {},
          p = ["oauth2"],
          c = ["application/_*+json", "application/json", "text/json"],
          l = ["application/json", "text/json", "text/plain"],
          y = "Boolean";
        return this.apiClient.callApi("/api/qy-wechat/bind-user-wxid-by-qrcode", "POST", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "bindQyWxUserByCode",
      value: function bindQyWxUserByCode(e) {
        return this.bindQyWxUserByCodeWithHttpInfo(e);
      }
    }, {
      key: "bindQyWxUserByWxUserIdWithHttpInfo",
      value: function bindQyWxUserByWxUserIdWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          i = {},
          r = {},
          o = e.header || {},
          s = {},
          p = ["oauth2"],
          c = ["application/_*+json", "application/json", "text/json"],
          l = ["application/json", "text/json", "text/plain"],
          y = "Boolean";
        return this.apiClient.callApi("/api/qy-wechat/bind-user-wxid-by-wxuserid", "POST", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "bindQyWxUserByWxUserId",
      value: function bindQyWxUserByWxUserId(e) {
        return this.bindQyWxUserByWxUserIdWithHttpInfo(e);
      }
    }, {
      key: "getAccessTokenWithHttpInfo",
      value: function getAccessTokenWithHttpInfo() {
        var e = null,
          t = {},
          i = {},
          r = {},
          o = {},
          s = ["oauth2"],
          p = [],
          c = ["application/json", "text/json", "text/plain"],
          l = M;
        return this.apiClient.callApi("/api/qy-wechat/access-token", "GET", t, i, r, o, e, s, p, c, l);
      }
    }, {
      key: "getAccessToken",
      value: function getAccessToken() {
        return this.getAccessTokenWithHttpInfo();
      }
    }, {
      key: "getCorpUserInfoByCodeWithHttpInfo",
      value: function getCorpUserInfoByCodeWithHttpInfo(e) {
        e = e || {};
        var t = null,
          i = {},
          r = {
            code: e.code
          },
          o = e.header || {},
          s = {},
          p = ["oauth2"],
          c = [],
          l = ["application/json", "text/json", "text/plain"],
          y = U;
        return this.apiClient.callApi("/api/qy-wechat/wx-user-id-by-qrcode", "GET", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "getCorpUserInfoByCode",
      value: function getCorpUserInfoByCode(e) {
        return this.getCorpUserInfoByCodeWithHttpInfo(e);
      }
    }, {
      key: "getCorpUserInfoByUserIdWithHttpInfo",
      value: function getCorpUserInfoByUserIdWithHttpInfo(e) {
        e = e || {};
        var t = null,
          i = {},
          r = {
            wxuserId: e.wxuserId
          },
          o = e.header || {},
          s = {},
          p = ["oauth2"],
          c = [],
          l = ["application/json", "text/json", "text/plain"],
          y = F;
        return this.apiClient.callApi("/api/qy-wechat/wx-user-detail", "GET", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "getCorpUserInfoByUserId",
      value: function getCorpUserInfoByUserId(e) {
        return this.getCorpUserInfoByUserIdWithHttpInfo(e);
      }
    }, {
      key: "setUserQyWxUserByWxUserIdWithHttpInfo",
      value: function setUserQyWxUserByWxUserIdWithHttpInfo(e) {
        e = e || {};
        var t = null,
          i = {},
          r = {
            userId: e.userId
          },
          o = e.header || {},
          s = {},
          p = ["oauth2"],
          c = [],
          l = ["application/json", "text/json", "text/plain"],
          y = "Boolean";
        return this.apiClient.callApi("/api/qy-wechat/unbind-user-wxid", "POST", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "setUserQyWxUserByWxUserId",
      value: function setUserQyWxUserByWxUserId(e) {
        return this.setUserQyWxUserByWxUserIdWithHttpInfo(e);
      }
    }]);
  }();
  D(Ee, "Methods", {
    bindQyWxUserByCode: {
      desc: "绑定用户关联的企业微信id(通过扫码的回调马)",
      method: "POST",
      path: "/api/qy-wechat/bind-user-wxid-by-qrcode"
    },
    bindQyWxUserByWxUserId: {
      desc: "绑定用户关联的企业微信id(通过企业微信id)",
      method: "POST",
      path: "/api/qy-wechat/bind-user-wxid-by-wxuserid"
    },
    getAccessToken: {
      desc: "获取企业微信配置的Token",
      method: "GET",
      path: "/api/qy-wechat/access-token"
    },
    getCorpUserInfoByCode: {
      desc: "获取企业微信回调的用户id",
      method: "GET",
      path: "/api/qy-wechat/wx-user-id-by-qrcode"
    },
    getCorpUserInfoByUserId: {
      desc: "获取企业微信用户详细信息",
      method: "GET",
      path: "/api/qy-wechat/wx-user-detail"
    },
    setUserQyWxUserByWxUserId: {
      desc: "解绑用户关联的企业微信",
      method: "POST",
      path: "/api/qy-wechat/unbind-user-wxid"
    }
  });
  var Me = /*#__PURE__*/function () {
    function Me(e) {
      _classCallCheck(this, Me);
      this.apiClient = e || n.GetInstance("auth-server", "SubTenantTokenApi");
    }
    return _createClass(Me, [{
      key: "changeTokenToSubTenantWithHttpInfo",
      value: function changeTokenToSubTenantWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          i = {},
          r = {},
          o = e.header || {},
          s = {},
          p = ["oauth2"],
          c = ["application/_*+json", "application/json", "text/json"],
          l = ["application/json", "text/json", "text/plain"],
          y = ye;
        return this.apiClient.callApi("/api/sub-tenant-token/change-token", "POST", i, r, o, s, t, p, c, l, y);
      }
    }, {
      key: "changeTokenToSubTenant",
      value: function changeTokenToSubTenant(e) {
        return this.changeTokenToSubTenantWithHttpInfo(e);
      }
    }]);
  }();
  D(Me, "Methods", {
    changeTokenToSubTenant: {
      desc: "切换子租户token",
      method: "POST",
      path: "/api/sub-tenant-token/change-token"
    }
  }), a.AbpAbpLoginResult = j, a.AbpApiScopeDto = g, a.AbpAuditLogActionDto = B, a.AbpAuditLogDto = m, a.AbpClientClaimDto = ee, a.AbpClientDto = u, a.AbpCreateApiResourceInputDto = K, a.AbpCreateApiScopeDto = q, a.AbpCreateClientInputDto = h, a.AbpCreateIdentityResourceInputDto = E, a.AbpCreateSecretDto = X, a.AbpEntityChangeDto = x, a.AbpEntityChangeType = ve, a.AbpEntityPropertyChangeDto = _, a.AbpIdentityResourceDto = v, a.AbpLoginResultType = ge, a.AbpPersistedGrantDto = A, a.AbpPropertyDto = z, a.AbpRemoteServiceErrorInfo = Q, a.AbpRemoteServiceErrorResponse = me, a.AbpRemoteServiceValidationErrorInfo = ne, a.AbpSecretDto = V, a.AbpUpdateApiResourceInputDto = R, a.AbpUpdateApiScopeDto = W, a.AbpUpdateClientInputDto = w, a.AbpUpdateIdentityResourceInputDto = H, a.ApiClient = n, a.ApiResourceApi = Ae, a.ApiScopeApi = ke, a.AuditLogApi = Ne, a.AuthServerApiResourceDto = P, a.AuthServerEafAuthCodeResult = J, a.AuthServerEafConnectTokenInput = Y, a.AuthServerEafTokenResult = G, a.AuthServerEafUserLoginInfo = Z, a.AuthServerEafUserQyWxUserBindDto = ue, a.AuthServerLoginValidatorCodeDto = re, a.AuthServerQyWxTokenResultDto = M, a.AuthServerQyWxUserDetailDto = F, a.AuthServerQyWxUserInfoDto = U, a.AuthServerRsaPublicKeyDto = de, a.ClientApi = Le, a.EafCacheApi = xe, a.EafLoginApi = De, a.IdentityResourceApi = Be, a.MenuManagementMenuDto = f, a.MenuManagementMenuOperationDto = L, a.MenuManagementMenuType = Oe, a.ModelsAccessTokenType = Se, a.ModelsClient = d, a.ModelsClientClaim = te, a.ModelsSecret = b, a.ModelsTokenExpiration = Ie, a.ModelsTokenUsage = Ce, a.NetHttpStatusCode = He, a.PagedResultDtoAbpApiScopeDto = ie, a.PagedResultDtoAbpAuditLogDto = oe, a.PagedResultDtoAbpClientDto = se, a.PagedResultDtoAbpIdentityResourceDto = pe, a.PagedResultDtoAbpPersistedGrantDto = ce, a.PagedResultDtoAuthServerApiResourceDto = le, a.PersistedGrantApi = qe, a.QyWechatApi = Ee, a.SubTenantTokenApi = Me, a.TenantManagementChangeToSubTenantTokenInputDto = fe, a.TenantManagementChangeToSubTenantTokenOutputDto = ye, a.TenantManagementOriginMenuMeta = $, a.TenantManagementTenantMenuDto = T, a.TenantManagementTenantMenuOperationDto = k, Object.defineProperty(a, Symbol.toStringTag, {
    value: "Module"
  });
});
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__("b639").Buffer, __webpack_require__("62e4")(module)))

/***/ }),

/***/ "9911":
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var $ = __webpack_require__("23e7");
var createHTML = __webpack_require__("857a");
var forcedStringHTMLMethod = __webpack_require__("af03");

// `String.prototype.link` method
// https://tc39.es/ecma262/#sec-string.prototype.link
$({ target: 'String', proto: true, forced: forcedStringHTMLMethod('link') }, {
  link: function link(url) {
    return createHTML(this, 'a', 'href', url);
  }
});


/***/ }),

/***/ "99af":
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var $ = __webpack_require__("23e7");
var fails = __webpack_require__("d039");
var isArray = __webpack_require__("e8b5");
var isObject = __webpack_require__("861d");
var toObject = __webpack_require__("7b0b");
var lengthOfArrayLike = __webpack_require__("07fa");
var doesNotExceedSafeInteger = __webpack_require__("3511");
var createProperty = __webpack_require__("8418");
var arraySpeciesCreate = __webpack_require__("65f0");
var arrayMethodHasSpeciesSupport = __webpack_require__("1dde");
var wellKnownSymbol = __webpack_require__("b622");
var V8_VERSION = __webpack_require__("1212");

var IS_CONCAT_SPREADABLE = wellKnownSymbol('isConcatSpreadable');

// We can't use this feature detection in V8 since it causes
// deoptimization and serious performance degradation
// https://github.com/zloirock/core-js/issues/679
var IS_CONCAT_SPREADABLE_SUPPORT = V8_VERSION >= 51 || !fails(function () {
  var array = [];
  array[IS_CONCAT_SPREADABLE] = false;
  return array.concat()[0] !== array;
});

var isConcatSpreadable = function (O) {
  if (!isObject(O)) return false;
  var spreadable = O[IS_CONCAT_SPREADABLE];
  return spreadable !== undefined ? !!spreadable : isArray(O);
};

var FORCED = !IS_CONCAT_SPREADABLE_SUPPORT || !arrayMethodHasSpeciesSupport('concat');

// `Array.prototype.concat` method
// https://tc39.es/ecma262/#sec-array.prototype.concat
// with adding support of @@isConcatSpreadable and @@species
$({ target: 'Array', proto: true, arity: 1, forced: FORCED }, {
  // eslint-disable-next-line no-unused-vars -- required for `.length`
  concat: function concat(arg) {
    var O = toObject(this);
    var A = arraySpeciesCreate(O, 0);
    var n = 0;
    var i, k, length, len, E;
    for (i = -1, length = arguments.length; i < length; i++) {
      E = i === -1 ? O : arguments[i];
      if (isConcatSpreadable(E)) {
        len = lengthOfArrayLike(E);
        doesNotExceedSafeInteger(n + len);
        for (k = 0; k < len; k++, n++) if (k in E) createProperty(A, n, E[k]);
      } else {
        doesNotExceedSafeInteger(n + 1);
        createProperty(A, n++, E);
      }
    }
    A.length = n;
    return A;
  }
});


/***/ }),

/***/ "9c3a":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(Buffer) {/* unused harmony export CameraMode */
/* unused harmony export CreateExternalPaymentType */
/* unused harmony export EntryType */
/* unused harmony export EnvVersion */
/* unused harmony export IS_WECOM_SDK */
/* unused harmony export InTalkType */
/* unused harmony export InputCorpGroupContactMode */
/* unused harmony export InputCorpGroupContactType */
/* unused harmony export LiveType */
/* unused harmony export LocationType */
/* unused harmony export NetworkType */
/* unused harmony export OAType */
/* unused harmony export OaExtDataType */
/* unused harmony export OpenUserProfileType */
/* unused harmony export PrintFileIdType */
/* unused harmony export ProductViewType */
/* unused harmony export Proximity */
/* unused harmony export SDK_VERSION */
/* unused harmony export ScanQRCodeType */
/* unused harmony export SelectEnterpriseContactMode */
/* unused harmony export SelectEnterpriseContactType */
/* unused harmony export SelectExternalContactType */
/* unused harmony export SelectPrivilegedContactMode */
/* unused harmony export SizeType */
/* unused harmony export SourceType */
/* unused harmony export WWLoginLangType */
/* unused harmony export WWLoginPanelSizeType */
/* unused harmony export WWLoginRedirectType */
/* unused harmony export WWLoginType */
/* unused harmony export addCard */
/* unused harmony export addDevice */
/* unused harmony export checkJsApi */
/* unused harmony export checkSchedule */
/* unused harmony export chooseCard */
/* unused harmony export chooseImage */
/* unused harmony export chooseInvoice */
/* unused harmony export chooseWXPay */
/* unused harmony export claimClassAdmin */
/* unused harmony export closeBLEConnection */
/* unused harmony export closeBluetoothAdapter */
/* unused harmony export closeWindow */
/* unused harmony export connectWifi */
/* unused harmony export consumeAndShareCard */
/* unused harmony export createBLEConnection */
/* unused harmony export createChatWithMsg */
/* unused harmony export createCorpGroupChat */
/* unused harmony export createExternalPayment */
/* unused harmony export createJSAPIPanel */
/* unused harmony export createSchoolPayment */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return createWWLoginPanel; });
/* unused harmony export discoverDevice */
/* unused harmony export downloadImage */
/* unused harmony export downloadLivingReplay */
/* unused harmony export downloadVoice */
/* unused harmony export ensureAgentConfigReady */
/* unused harmony export ensureConfigReady */
/* unused harmony export ensureCorpConfigReady */
/* unused harmony export enterHWOpenTalk */
/* unused harmony export enterpriseVerify */
/* unused harmony export env */
/* unused harmony export getApprovalSelectedItems */
/* unused harmony export getBLEDeviceCharacteristics */
/* unused harmony export getBLEDeviceServices */
/* unused harmony export getBeacons */
/* unused harmony export getBluetoothAdapterState */
/* unused harmony export getBluetoothDevices */
/* unused harmony export getClipboardData */
/* unused harmony export getConnectedBluetoothDevices */
/* unused harmony export getConnectedWifi */
/* unused harmony export getContext */
/* unused harmony export getCurCorpGroupChat */
/* unused harmony export getCurCorpGroupContact */
/* unused harmony export getCurExternalChat */
/* unused harmony export getCurExternalContact */
/* unused harmony export getLocalImgData */
/* unused harmony export getLocation */
/* unused harmony export getNetworkType */
/* unused harmony export getShareInfo */
/* unused harmony export getSignature */
/* unused harmony export getVerifyParams */
/* unused harmony export getWifiList */
/* unused harmony export hideAllNonBaseMenuItem */
/* unused harmony export hideChatAttachmentMenu */
/* unused harmony export hideMenuItems */
/* unused harmony export hideOptionMenu */
/* unused harmony export initOpenData */
/* unused harmony export invoke */
/* unused harmony export isWeixinJSBridgeReady */
/* unused harmony export launchMiniprogram */
/* unused harmony export navigateToAddCustomer */
/* unused harmony export navigateToKfChat */
/* unused harmony export notifyBLECharacteristicValueChange */
/* unused harmony export on */
/* unused harmony export onBLECharacteristicValueChange */
/* unused harmony export onBLEConnectionStateChange */
/* unused harmony export onBeaconServiceChange */
/* unused harmony export onBeaconUpdate */
/* unused harmony export onBluetoothAdapterStateChange */
/* unused harmony export onBluetoothDeviceFound */
/* unused harmony export onGetWifiList */
/* unused harmony export onHistoryBack */
/* unused harmony export onLocationChange */
/* unused harmony export onMenuShareAppMessage */
/* unused harmony export onMenuShareQQ */
/* unused harmony export onMenuShareQZone */
/* unused harmony export onMenuShareTimeline */
/* unused harmony export onMenuShareWechat */
/* unused harmony export onMenuShareWeibo */
/* unused harmony export onNetworkStatusChange */
/* unused harmony export onSearchBeacons */
/* unused harmony export onUserCaptureScreen */
/* unused harmony export onVoicePlayEnd */
/* unused harmony export onVoiceRecordEnd */
/* unused harmony export onWeixinJSBridgeReady */
/* unused harmony export onWifiConnected */
/* unused harmony export openAddress */
/* unused harmony export openAppComment */
/* unused harmony export openAppDeviceDataAuth */
/* unused harmony export openAppManage */
/* unused harmony export openBluetoothAdapter */
/* unused harmony export openBusinessView */
/* unused harmony export openCard */
/* unused harmony export openDefaultBrowser */
/* unused harmony export openDeviceProfile */
/* unused harmony export openEnterpriseChat */
/* unused harmony export openEnterpriseRedPacket */
/* unused harmony export openExistedChatWithMsg */
/* unused harmony export openLocation */
/* unused harmony export openProductSpecificView */
/* unused harmony export openThirdAppServiceChat */
/* unused harmony export openUserProfile */
/* unused harmony export pauseVoice */
/* unused harmony export playVoice */
/* unused harmony export previewFile */
/* unused harmony export previewImage */
/* unused harmony export printFile */
/* unused harmony export queryCurrHWOpenTalk */
/* unused harmony export readBLECharacteristicValue */
/* unused harmony export refundExternalPayment */
/* unused harmony export register */
/* unused harmony export replayLiving */
/* unused harmony export saveApprovalSelectedItems */
/* unused harmony export scanQRCode */
/* unused harmony export selectCorpGroupContact */
/* unused harmony export selectEnterpriseContact */
/* unused harmony export selectExternalContact */
/* unused harmony export selectPrivilegedContact */
/* unused harmony export sendChatMessage */
/* unused harmony export setClipboardData */
/* unused harmony export setShareAttr */
/* unused harmony export shareAppMessage */
/* unused harmony export shareToExternalChat */
/* unused harmony export shareToExternalContact */
/* unused harmony export shareToExternalMoments */
/* unused harmony export shareWechatMessage */
/* unused harmony export showAllNonBaseMenuItem */
/* unused harmony export showMenuItems */
/* unused harmony export showOptionMenu */
/* unused harmony export showSecurityGatewayConfirmModal */
/* unused harmony export startAutoLBS */
/* unused harmony export startBeaconDiscovery */
/* unused harmony export startBluetoothDevicesDiscovery */
/* unused harmony export startLiving */
/* unused harmony export startMeeting */
/* unused harmony export startRecord */
/* unused harmony export startSearchBeacons */
/* unused harmony export startWecast */
/* unused harmony export startWifi */
/* unused harmony export stopAutoLBS */
/* unused harmony export stopBeaconDiscovery */
/* unused harmony export stopBluetoothDevicesDiscovery */
/* unused harmony export stopRecord */
/* unused harmony export stopSearchBeacons */
/* unused harmony export stopVoice */
/* unused harmony export stopWifi */
/* unused harmony export thirdPartyOpenPage */
/* unused harmony export translateVoice */
/* unused harmony export updateAppMessageShareData */
/* unused harmony export updateCorpGroupChat */
/* unused harmony export updateEnterpriseChat */
/* unused harmony export updateMomentsSetting */
/* unused harmony export updateTimelineShareData */
/* unused harmony export uploadImage */
/* unused harmony export uploadVoice */
/* unused harmony export wedocSelectDoc */
/* unused harmony export wedriveSelectDir */
/* unused harmony export wedriveSelectFileForDownload */
/* unused harmony export wedriveSelectFileForShare */
/* unused harmony export writeBLECharacteristicValue */
var win = typeof window !== "undefined" ? window : undefined;
var doc = typeof document !== "undefined" ? document : undefined;
var nav = typeof navigator !== "undefined" ? navigator : undefined;
var loc = typeof location !== "undefined" ? location : undefined;
function getHref() {
    return (loc == null ? void 0 : loc.href) || "";
}
function getTitle() {
    return (doc == null ? void 0 : doc.title) || "";
}

var _ua_match;
var ua = (nav == null ? void 0 : nav.userAgent) || "";
var platform = (nav == null ? void 0 : nav.platform) || "";
var wecomVersion = (_ua_match = ua == null ? void 0 : ua.match(/wxwork\/([\d.]+)/i)) == null ? void 0 : _ua_match[1];
var isWeCom = !!wecomVersion;
var isWeChat = !isWeCom && /micromessenger/i.test(ua);
var isAndroid = /\bAndroid\b/i.test(ua);
var isWindows = /Win/i.test(platform);
var _getAppleDeviceType = getAppleDeviceType();
var isIOS = _getAppleDeviceType.isIOS, isMac = _getAppleDeviceType.isMac;
function getAppleDeviceType() {
    var _nav_maxTouchPoints;
    var maxTouchPoints = (_nav_maxTouchPoints = nav == null ? void 0 : nav.maxTouchPoints) != null ? _nav_maxTouchPoints : 1;
    var isMac = /Mac/i.test(platform);
    // https://stackoverflow.com/questions/56934826/distinguish-between-ipad-and-mac-on-ipad-with-ipados
    if (isMac && maxTouchPoints > 2) {
        return {
            isMac: false,
            isIOS: true
        };
    }
    return {
        isMac: isMac,
        isIOS: /\b(iPhone|iPad|iPod)\b/i.test(ua)
    };
}

var registerOptions;
var corpConfigTask;
var agentConfigTask;
function setRegisterOptions(options) {
    registerOptions = options;
}
function getRegisterOptions() {
    return registerOptions;
}
function getCorpConfigTask() {
    return corpConfigTask;
}
function setCorpConfigTask(task) {
    corpConfigTask = task;
}
function getCorpConfigParams() {
    var _corpConfigTask_getResult;
    return (_corpConfigTask_getResult = corpConfigTask == null ? void 0 : corpConfigTask.getResult()) == null ? void 0 : _corpConfigTask_getResult.params;
}
function getAgentConfigTask() {
    return agentConfigTask;
}
function setAgentConfigTask(task) {
    agentConfigTask = task;
}
function getAgentConfigParams() {
    var _agentConfigTask_getResult;
    return (_agentConfigTask_getResult = agentConfigTask == null ? void 0 : agentConfigTask.getResult()) == null ? void 0 : _agentConfigTask_getResult.params;
}
function getConfigParams() {
    var registerOptions = getRegisterOptions();
    if (isWeCom && (registerOptions == null ? void 0 : registerOptions.getAgentConfigSignature)) {
        return getAgentConfigParams();
    }
    return getCorpConfigParams();
}
function getConfigCorpId() {
    var registerOptions = getRegisterOptions();
    if (isWeCom && (registerOptions == null ? void 0 : registerOptions.getAgentConfigSignature)) {
        var params = getAgentConfigParams();
        return params == null ? void 0 : params.corpid;
    }
    var params1 = getCorpConfigParams();
    return params1 == null ? void 0 : params1.appId;
}
/**
 * 获取 config 或 agentConfig 传入的相关参数
 *
 * 用于外部 sdk 调用私有方法
 */ function getVerifyParams() {
    var verifyParams = getConfigParams();
    if (!verifyParams) {
        return;
    }
    var corpId = getConfigCorpId();
    return {
        appId: corpId,
        verifyAppId: corpId,
        verifySignType: "sha1",
        verifyTimestamp: verifyParams.timestamp,
        verifyNonceStr: verifyParams.nonceStr,
        verifySignature: verifyParams.signature
    };
}

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) resolve(value);
    else Promise.resolve(value).then(_next, _throw);
}
function _async_to_generator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}

function __generator(thisArg, body) {
    var verb = function verb(n) {
        return function(v) {
            return step([
                n,
                v
            ]);
        };
    };
    var step = function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while(g && (g = 0, op[0] && (_ = 0)), _)try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [
                op[0] & 2,
                t.value
            ];
            switch(op[0]){
                case 0:
                case 1:
                    t = op;
                    break;
                case 4:
                    _.label++;
                    return {
                        value: op[1],
                        done: false
                    };
                case 5:
                    _.label++;
                    y = op[1];
                    op = [
                        0
                    ];
                    continue;
                case 7:
                    op = _.ops.pop();
                    _.trys.pop();
                    continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                        _ = 0;
                        continue;
                    }
                    if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
                        _.label = op[1];
                        break;
                    }
                    if (op[0] === 6 && _.label < t[1]) {
                        _.label = t[1];
                        t = op;
                        break;
                    }
                    if (t && _.label < t[2]) {
                        _.label = t[2];
                        _.ops.push(op);
                        break;
                    }
                    if (t[2]) _.ops.pop();
                    _.trys.pop();
                    continue;
            }
            op = body.call(thisArg, _);
        } catch (e) {
            op = [
                6,
                e
            ];
            y = 0;
        } finally{
            f = t = 0;
        }
        if (op[0] & 5) throw op[1];
        return {
            value: op[0] ? op[1] : void 0,
            done: true
        };
    };
    var _ = {
        label: 0,
        sent: function sent() {
            if (t[0] & 1) throw t[1];
            return t[1];
        },
        trys: [],
        ops: []
    }, f, y, t, g;
    return g = {
        next: verb(0),
        "throw": verb(1),
        "return": verb(2)
    }, typeof Symbol === "function" && (g[Symbol.iterator] = function() {
        return this;
    }), g;
}

function _extends() {
    _extends = Object.assign || function assign(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source)if (Object.prototype.hasOwnProperty.call(source, key)) target[key] = source[key];
        }
        return target;
    };
    return _extends.apply(this, arguments);
}

function _array_like_to_array(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for(var i = 0, arr2 = new Array(len); i < len; i++)arr2[i] = arr[i];
    return arr2;
}

function _unsupported_iterable_to_array(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _array_like_to_array(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(n);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _array_like_to_array(o, minLen);
}

function _create_for_of_iterator_helper_loose(o, allowArrayLike) {
    var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
    if (it) return (it = it.call(o)).next.bind(it);
    // Fallback for engines without symbol support
    if (Array.isArray(o) || (it = _unsupported_iterable_to_array(o)) || allowArrayLike && o && typeof o.length === "number") {
        if (it) o = it;
        var i = 0;
        return function() {
            if (i >= o.length) return {
                done: true
            };
            return {
                done: false,
                value: o[i++]
            };
        };
    }
    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

var webToClientJsApiMap = {
    config: "preVerifyJsApi",
    onMenuShareTimeline: "menu:share:timeline",
    onMenuShareAppMessage: "menu:share:appmessage",
    onMenuShareWechat: "menu:share:wechat",
    onMenuShareQQ: "menu:share:qq",
    onMenuShareWeibo: "menu:share:weiboApp",
    onMenuShareQZone: "menu:share:QZone",
    previewImage: "imagePreview",
    getLocation: "geoLocation",
    openProductSpecificView: "openProductViewWithPid",
    addCard: "batchAddCard",
    openCard: "batchViewCard",
    chooseWXPay: "getBrandWCPayRequest",
    openEnterpriseRedPacket: "getRecevieBizHongBaoRequest",
    startSearchBeacons: "startMonitoringBeacons",
    stopSearchBeacons: "stopMonitoringBeacons",
    onSearchBeacons: "onBeaconsInRange",
    consumeAndShareCard: "consumedShareCard",
    openAddress: "editAddress",
    getBrandWCPayRequest: "getBrandWCPayRequest"
};
var clientToWebJsApiMap = {};
for(var _iterator = _create_for_of_iterator_helper_loose(Object.keys(webToClientJsApiMap)), _step; !(_step = _iterator()).done;){
    var key = _step.value;
    clientToWebJsApiMap[webToClientJsApiMap[key]] = key;
}
function mapJsApiNameToClient(name) {
    return webToClientJsApiMap[name] || name;
}
function mapJsApiNameToWeb(name) {
    return clientToWebJsApiMap[name] || name;
}
function mapJsApiListToClient(list) {
    return list.map(mapJsApiNameToClient);
}

function _array_without_holes(arr) {
    if (Array.isArray(arr)) return _array_like_to_array(arr);
}

function _iterable_to_array(iter) {
    if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) {
        return Array.from(iter);
    }
}

function _non_iterable_spread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _to_consumable_array(arr) {
    return _array_without_holes(arr) || _iterable_to_array(arr) || _unsupported_iterable_to_array(arr) || _non_iterable_spread();
}

function error() {
    for(var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++){
        args[_key] = arguments[_key];
    }
    var _console;
    (_console = console).error.apply(_console, [
        "[wwsdk]"
    ].concat(_to_consumable_array(args))); // eslint-disable-line no-console
}

var originalHref = getHref();
/**
 * 两个 SemVer 相减，取差的符号
 */ function semverSubtract(v1, v2) {
    var v1Seg = (v1 == null ? void 0 : v1.split(".")) || [];
    var v2Seg = (v2 == null ? void 0 : v2.split(".")) || [];
    for(var i = 0, ii = Math.max(v1Seg.length, v2Seg.length); i < ii; i++){
        var v1Num = parseInt(v1Seg[i]) || 0;
        var v2Num = parseInt(v2Seg[i]) || 0;
        if (v1Num > v2Num) {
            return 1;
        }
        if (v1Num < v2Num) {
            return -1;
        }
    }
    return 0;
}
function arrayBufferToBase64(buffer) {
    if (typeof Buffer !== "undefined") {
        return Buffer.from(buffer).toString("base64");
    }
    var binary = "";
    var bytes = new Uint8Array(buffer);
    var len = bytes.byteLength;
    for(var i = 0; i < len; i++){
        binary += String.fromCharCode(bytes[i]);
    }
    return btoa(binary);
}
function base64ToArrayBuffer(base64) {
    if (typeof Buffer !== "undefined") {
        return Buffer.from(base64, "base64").buffer;
    }
    var binary = atob(base64);
    var length = binary.length;
    var bytes = new Uint8Array(length);
    for(var i = 0; i < length; i++){
        bytes[i] = binary.charCodeAt(i);
    }
    return bytes.buffer;
}
function safeRun(fn, param) {
    if (!isFunction(fn)) {
        return;
    }
    try {
        return fn(param);
    } catch (error$1) {
        error(error$1);
    }
}
function startsWith(str, search) {
    return str.slice(0, search.length) === search;
}
function getSignURL(original) {
    if (original) {
        return originalHref.split("#")[0];
    }
    return getHref().split("#")[0];
}
function extractErrMsgKeyword(errMsg) {
    if (!isString(errMsg)) {
        return "";
    }
    return errMsg.slice(errMsg.indexOf(":") + 1);
}
function isFalsy(val) {
    return val === false || val === 0;
}
// eslint-disable-next-line @typescript-eslint/ban-types
function isObject(val) {
    if (!val) {
        return false;
    }
    return typeof val === "object";
}
function isFunction(val) {
    return typeof val === "function";
}
function isString(val) {
    return typeof val === "string";
}
function joinList(list) {
    if (!list) {
        return list;
    }
    if (isString(list)) {
        return list;
    }
    return list.join(";");
}

/**
 * WeixinJSBridge 是否已注入到 window
 */ var isWeixinJSBridgeReady = !!(win == null ? void 0 : win.WeixinJSBridge);
/**
 * 等待 WeixinJSBridge 注入到 window
 */ var onWeixinJSBridgeReady = Promise.resolve();
if (!isWeixinJSBridgeReady) {
    onWeixinJSBridgeReady = new Promise(function(resolve) {
        doc == null ? void 0 : doc.addEventListener("WeixinJSBridgeReady", function() {
            isWeixinJSBridgeReady = true;
            resolve();
        });
    });
}
/**
 * 监听 JSSDK 未定义的事件
 *
 * @example
 * ```ts
 * ww.on('onBeaconsInRange', res => {
 *   console.log(res)
 * })
 * ```
 *
 * @param name 事件名称
 * @param callback 监听回调
 */ function on(name, callback) {
    return _on.apply(this, arguments);
}
function _on() {
    _on = _async_to_generator(function(name, callback) {
        return __generator(this, function(_state) {
            switch(_state.label){
                case 0:
                    if (!!isWeixinJSBridgeReady) return [
                        3,
                        2
                    ];
                    return [
                        4,
                        onWeixinJSBridgeReady
                    ];
                case 1:
                    _state.sent();
                    _state.label = 2;
                case 2:
                    win.WeixinJSBridge.on(name, callback);
                    return [
                        2
                    ];
            }
        });
    });
    return _on.apply(this, arguments);
}
/**
 * 调用 JSSDK 未定义的 JSAPI
 *
 * @example
 * ```ts
 * ww.invoke('openEnterpriseChat', params, res => {
 *   console.log(res)
 * })
 * ```
 *
 * @param name JSAPI 名称
 * @param params JSAPI 参数
 * @param callback 回调函数
 * @returns JSAPI 返回值
 */ function invoke(name) {
    return _invoke.apply(this, arguments);
}
function _invoke() {
    _invoke = _async_to_generator(function(name, params, callback) {
        var result, keyword;
        return __generator(this, function(_state) {
            switch(_state.label){
                case 0:
                    if (params === void 0) params = {};
                    if (!!isWeixinJSBridgeReady) return [
                        3,
                        2
                    ];
                    return [
                        4,
                        onWeixinJSBridgeReady
                    ];
                case 1:
                    _state.sent();
                    _state.label = 2;
                case 2:
                    return [
                        4,
                        new Promise(function(resolve) {
                            var fullParams = _extends({}, params, getVerifyParams());
                            win.WeixinJSBridge.invoke(name, fullParams, resolve);
                        })
                    ];
                case 3:
                    result = _state.sent();
                    if (!result.errMsg) {
                        result.errMsg = formatErrMsg(name, result.err_msg || result.errmsg);
                    }
                    keyword = extractErrMsgKeyword(result.errMsg);
                    if (result.errCode == null) {
                        if (result.err_code != null) {
                            result.errCode = result.err_code;
                        } else {
                            result.errCode = keyword === "ok" ? 0 : -1;
                        }
                    }
                    safeRun(callback, result);
                    if (keyword !== "ok") {
                        throw result;
                    }
                    return [
                        2,
                        result
                    ];
            }
        });
    });
    return _invoke.apply(this, arguments);
}
function formatErrMsg(name, errMsg) {
    var apiName = mapJsApiNameToWeb(name);
    if (!errMsg) {
        return "" + apiName + ":ok";
    }
    var keyword = extractErrMsgKeyword(errMsg);
    if (keyword === "confirm") {
        keyword = "ok";
    }
    if (keyword === "failed") {
        keyword = "fail";
    }
    if (startsWith(keyword, "failed_")) {
        keyword = keyword.slice(7);
    }
    if (startsWith(keyword, "fail_")) {
        keyword = keyword.slice(5);
    }
    keyword = keyword.replace(/_/g, "").toLowerCase();
    if (keyword === "access denied" || keyword === "no permission to execute") {
        keyword = "permission denied";
    }
    if (apiName === "config" && keyword === "function not exist") {
        keyword = "ok";
    }
    if (!keyword) {
        keyword = "fail";
    }
    return apiName + ":" + keyword;
}

function _set_prototype_of(o, p) {
    _set_prototype_of = Object.setPrototypeOf || function setPrototypeOf(o, p) {
        o.__proto__ = p;
        return o;
    };
    return _set_prototype_of(o, p);
}

function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
    }
    subClass.prototype = Object.create(superClass && superClass.prototype, {
        constructor: {
            value: subClass,
            writable: true,
            configurable: true
        }
    });
    if (superClass) _set_prototype_of(subClass, superClass);
}

function _is_native_reflect_construct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;
    try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {}));
        return true;
    } catch (e) {
        return false;
    }
}

function _construct(Parent, args, Class) {
    if (_is_native_reflect_construct()) _construct = Reflect.construct;
    else {
        _construct = function construct(Parent, args, Class) {
            var a = [
                null
            ];
            a.push.apply(a, args);
            var Constructor = Function.bind.apply(Parent, a);
            var instance = new Constructor();
            if (Class) _set_prototype_of(instance, Class.prototype);
            return instance;
        };
    }
    return _construct.apply(null, arguments);
}

function _get_prototype_of(o) {
    _get_prototype_of = Object.setPrototypeOf ? Object.getPrototypeOf : function getPrototypeOf(o) {
        return o.__proto__ || Object.getPrototypeOf(o);
    };
    return _get_prototype_of(o);
}

function _is_native_function(fn) {
    return Function.toString.call(fn).indexOf("[native code]") !== -1;
}

function _wrap_native_super(Class) {
    var _cache = typeof Map === "function" ? new Map() : undefined;
    _wrap_native_super = function _wrap_native_super(Class) {
        var Wrapper = function Wrapper() {
            return _construct(Class, arguments, _get_prototype_of(this).constructor);
        };
        if (Class === null || !_is_native_function(Class)) return Class;
        if (typeof Class !== "function") throw new TypeError("Super expression must either be null or a function");
        if (typeof _cache !== "undefined") {
            if (_cache.has(Class)) return _cache.get(Class);
            _cache.set(Class, Wrapper);
        }
        Wrapper.prototype = Object.create(Class.prototype, {
            constructor: {
                value: Wrapper,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        return _set_prototype_of(Wrapper, Class);
    };
    return _wrap_native_super(Class);
}

var SDKError = /*#__PURE__*/ function(Error1) {
    _inherits(SDKError, Error1);
    function SDKError(message) {
        return Error1.call(this, "SDK Error: " + message);
    }
    return SDKError;
}(_wrap_native_super(Error));
var AbortError = /*#__PURE__*/ function(SDKError) {
    _inherits(AbortError, SDKError);
    function AbortError() {
        return SDKError.call(this, "Aborted");
    }
    return AbortError;
}(SDKError);

var CONFIG_TYPE_CORP = 1;
var CONFIG_TYPE_AGENT = 2;
var ConfigTask = /*#__PURE__*/ function() {
    function ConfigTask(type, factory) {
        this.type = type;
        this.useOriginalURL = isWeChat && !isWindows && !isMac && type === CONFIG_TYPE_CORP;
        this.url = getSignURL(this.useOriginalURL);
        this.promise = this.awaitPromise(factory(this.url));
    }
    var _proto = ConfigTask.prototype;
    _proto.checkValid = function checkValid() {
        if (isWeCom && this.url !== getSignURL(this.useOriginalURL)) {
            this.error = new AbortError();
        }
        return !this.error;
    };
    _proto.getResult = function getResult() {
        if (this.checkValid()) {
            return this.result;
        }
    };
    _proto.awaitPromise = function awaitPromise(promise) {
        var _this = this;
        return _async_to_generator(function() {
            var error;
            return __generator(this, function(_state) {
                switch(_state.label){
                    case 0:
                        _state.trys.push([
                            0,
                            2,
                            ,
                            3
                        ]);
                        return [
                            4,
                            promise
                        ];
                    case 1:
                        _this.result = _state.sent();
                        return [
                            2,
                            _this.result
                        ];
                    case 2:
                        error = _state.sent();
                        _this.error = error;
                        throw error;
                    case 3:
                        return [
                            2
                        ];
                }
            });
        })();
    };
    return ConfigTask;
}();

/**
 * 触发或等待 config 返回
 */ function ensureCorpConfigReady() {
    return _ensureCorpConfigReady.apply(this, arguments);
}
function _ensureCorpConfigReady() {
    _ensureCorpConfigReady = _async_to_generator(function() {
        var originalTask, task;
        return __generator(this, function(_state) {
            originalTask = getCorpConfigTask();
            if (originalTask == null ? void 0 : originalTask.checkValid()) {
                return [
                    2,
                    originalTask.promise
                ];
            }
            task = new ConfigTask(CONFIG_TYPE_CORP, /*#__PURE__*/ _async_to_generator(function(url) {
                var registerOptions, data, params, result;
                return __generator(this, function(_state) {
                    switch(_state.label){
                        case 0:
                            registerOptions = getRegisterOptions();
                            if (!(registerOptions == null ? void 0 : registerOptions.getConfigSignature)) {
                                throw new SDKError("Missing getConfigSignature");
                            }
                            return [
                                4,
                                registerOptions.getConfigSignature(url)
                            ];
                        case 1:
                            data = _state.sent();
                            if (!task.checkValid()) {
                                throw new AbortError();
                            }
                            params = buildCorpConfigParams(registerOptions, data);
                            return [
                                4,
                                invoke("preVerifyJSAPI", {
                                    appId: params.appId,
                                    verifyJsApiList: params.jsApiList,
                                    verifyOpenTagList: params.openTagList,
                                    verifyAppId: params.appId,
                                    verifySignType: "sha1",
                                    verifyTimestamp: params.timestamp,
                                    verifyNonceStr: params.nonceStr,
                                    verifySignature: params.signature
                                })
                            ];
                        case 2:
                            result = _state.sent();
                            if (!task.checkValid()) {
                                throw new AbortError();
                            }
                            return [
                                2,
                                {
                                    params: params,
                                    result: result
                                }
                            ];
                    }
                });
            }));
            task.promise.then(function(res) {
                var registerOptions = getRegisterOptions();
                safeRun(registerOptions == null ? void 0 : registerOptions.onConfigSuccess, res.result);
                safeRun(registerOptions == null ? void 0 : registerOptions.onConfigComplete, res.result);
            }, function(error) {
                var registerOptions = getRegisterOptions();
                safeRun(registerOptions == null ? void 0 : registerOptions.onConfigFail, error);
                safeRun(registerOptions == null ? void 0 : registerOptions.onConfigComplete, error);
            });
            setCorpConfigTask(task);
            return [
                2,
                task.promise
            ];
        });
    });
    return _ensureCorpConfigReady.apply(this, arguments);
}
function buildCorpConfigParams(options, data) {
    return {
        appId: options.corpId,
        timestamp: "" + data.timestamp,
        nonceStr: data.nonceStr,
        signature: data.signature,
        jsApiList: mapJsApiListToClient(options.jsApiList || [
            "config"
        ]),
        openTagList: mapJsApiListToClient(options.openTagList || [])
    };
}

/**
 * 触发或等待 agentConfig 返回
 */ function ensureAgentConfigReady() {
    return _ensureAgentConfigReady.apply(this, arguments);
}
function _ensureAgentConfigReady() {
    _ensureAgentConfigReady = _async_to_generator(function() {
        var originalTask, task;
        return __generator(this, function(_state) {
            originalTask = getAgentConfigTask();
            if (originalTask == null ? void 0 : originalTask.checkValid()) {
                return [
                    2,
                    originalTask.promise
                ];
            }
            task = new ConfigTask(CONFIG_TYPE_AGENT, /*#__PURE__*/ _async_to_generator(function(url) {
                var configPromise, _ref, params, result;
                return __generator(this, function(_state) {
                    switch(_state.label){
                        case 0:
                            if (isWeCom && semverSubtract(wecomVersion, "3.0.24") < 0) {
                                configPromise = ensureCorpConfigReady();
                            }
                            return [
                                4,
                                Promise.all([
                                    resolveAgentConfigParams(url),
                                    configPromise
                                ])
                            ];
                        case 1:
                            _ref = _state.sent(), params = _ref[0];
                            if (!task.checkValid()) {
                                throw new AbortError();
                            }
                            return [
                                4,
                                invoke("agentConfig", params)
                            ];
                        case 2:
                            result = _state.sent();
                            if (!task.checkValid()) {
                                throw new AbortError();
                            }
                            return [
                                2,
                                {
                                    params: params,
                                    result: result
                                }
                            ];
                    }
                });
            }));
            task.promise.then(function(res) {
                var registerOptions = getRegisterOptions();
                safeRun(registerOptions == null ? void 0 : registerOptions.onAgentConfigSuccess, res.result);
                safeRun(registerOptions == null ? void 0 : registerOptions.onAgentConfigComplete, res.result);
            }, function(error) {
                var registerOptions = getRegisterOptions();
                safeRun(registerOptions == null ? void 0 : registerOptions.onAgentConfigFail, error);
                safeRun(registerOptions == null ? void 0 : registerOptions.onAgentConfigComplete, error);
            });
            setAgentConfigTask(task);
            return [
                2,
                task.promise
            ];
        });
    });
    return _ensureAgentConfigReady.apply(this, arguments);
}
function resolveAgentConfigParams(url) {
    return _resolveAgentConfigParams.apply(this, arguments);
}
function _resolveAgentConfigParams() {
    _resolveAgentConfigParams = _async_to_generator(function(url) {
        var registerOptions, data;
        return __generator(this, function(_state) {
            switch(_state.label){
                case 0:
                    registerOptions = getRegisterOptions();
                    if (!(registerOptions == null ? void 0 : registerOptions.getAgentConfigSignature)) {
                        throw new SDKError("Missing getAgentConfigSignature");
                    }
                    return [
                        4,
                        registerOptions.getAgentConfigSignature(url)
                    ];
                case 1:
                    data = _state.sent();
                    return [
                        2,
                        {
                            corpid: registerOptions.corpId,
                            agentid: "" + registerOptions.agentId,
                            timestamp: "" + data.timestamp,
                            nonceStr: data.nonceStr,
                            signature: data.signature,
                            jsApiList: mapJsApiListToClient(registerOptions.jsApiList || [
                                "agentConfig"
                            ])
                        }
                    ];
            }
        });
    });
    return _resolveAgentConfigParams.apply(this, arguments);
}

/**
 * 触发或等待 config、agentConfig 完成
 *
 * @example
 * ```ts
 * await ww.ensureConfigReady()
 * ```
 */ function ensureConfigReady() {
    var registerOptions = getRegisterOptions();
    if (isWeCom && (registerOptions == null ? void 0 : registerOptions.getAgentConfigSignature)) {
        return ensureAgentConfigReady();
    }
    return ensureCorpConfigReady();
}
/**
 * 在提供了 registerOptions 的情况下保证 config、agentConfig 完成
 *
 * @private
 */ function tryEnsureConfigReady() {
    var registerOptions = getRegisterOptions();
    if (registerOptions) {
        return ensureConfigReady();
    }
}

/**
 * 注册应用信息。
 *
 * @example
 * ```ts
 * ww.register({
 *   corpId: 'ww7ca4776b2a70000',
 *   jsApiList: ['getExternalContact'],
 *   getConfigSignature
 * })
 * ```
 */ function register(options) {
    setRegisterOptions(options);
    if (isWeChat || isWeCom) {
        ensureConfigReady();
    }
}

/**
 * 透传 JSAPI 调用
 */ function passthrough(name, params) {
    return _passthrough.apply(this, arguments);
}
function _passthrough() {
    _passthrough = _async_to_generator(function(name, params, jsapiParams) {
        return __generator(this, function(_state) {
            if (jsapiParams === void 0) jsapiParams = params;
            return [
                2,
                promiseToCallback(params, /*#__PURE__*/ _async_to_generator(function() {
                    return __generator(this, function(_state) {
                        switch(_state.label){
                            case 0:
                                return [
                                    4,
                                    tryEnsureConfigReady()
                                ];
                            case 1:
                                _state.sent();
                                return [
                                    2,
                                    invoke(name, jsapiParams)
                                ];
                        }
                    });
                }))
            ];
        });
    });
    return _passthrough.apply(this, arguments);
}
/**
 * 绑定事件
 */ function bindShare(name, params, handler) {
    return _bindShare.apply(this, arguments);
}
function _bindShare() {
    _bindShare = _async_to_generator(function(name, params, handler) {
        return __generator(this, function(_state) {
            switch(_state.label){
                case 0:
                    return [
                        4,
                        tryEnsureConfigReady()
                    ];
                case 1:
                    _state.sent();
                    on(name, function() {
                        promiseToCallback(params, handler);
                    });
                    return [
                        2
                    ];
            }
        });
    });
    return _bindShare.apply(this, arguments);
}
/**
 * 把 promise 转为 success/fail callbacak 回调
 */ function promiseToCallback(params, factory) {
    return factory(params).then(function(result) {
        safeRun(params == null ? void 0 : params.success, result);
        safeRun(params == null ? void 0 : params.complete, result);
        return result;
    }, function(error) {
        var keyword = extractErrMsgKeyword(error.errMsg);
        if (keyword === "cancel") {
            safeRun(params == null ? void 0 : params.cancel, error);
        } else {
            safeRun(params == null ? void 0 : params.fail, error);
        }
        safeRun(params == null ? void 0 : params.complete, error);
        throw error;
    });
}

var Proximity;
(function(Proximity) {
    Proximity[/**
   * CLProximityUnknown
   */ "CLProximityUnknown"] = "0";
    Proximity[/**
   * CLProximityImmediate
   */ "CLProximityImmediate"] = "1";
    Proximity[/**
   * CLProximityNear
   */ "CLProximityNear"] = "2";
    Proximity[/**
   * CLProximityFar
   */ "CLProximityFar"] = "3";
})(Proximity || (Proximity = {}));
/**
 * 开启查找周边 iBeacon 设备
 *
 * @see https://developers.weixin.qq.com/doc/offiaccount/OA_Web_Apps/JS-SDK.html
 * @compat WeChat
 */ function startSearchBeacons(params) {
    if (params === void 0) params = {};
    return passthrough("startMonitoringBeacons", params);
}
/**
 * 关闭查找周边 iBeacon 设备
 *
 * @see https://developers.weixin.qq.com/doc/offiaccount/OA_Web_Apps/JS-SDK.html
 * @compat WeChat
 */ function stopSearchBeacons(params) {
    if (params === void 0) params = {};
    return passthrough("stopMonitoringBeacons", params);
}
/**
 * 监听周边 iBeacon 设备接口
 *
 * @see https://developers.weixin.qq.com/doc/offiaccount/OA_Web_Apps/JS-SDK.html
 * @compat WeChat
 */ function onSearchBeacons(callback) {
    on("onBeaconsInRange", callback);
}

/**
 * 初始化蓝牙模块。
 *
 * @compat WeCom
 *
 * @example
 * ```ts
 * ww.openBluetoothAdapter()
 * ```
 */ function openBluetoothAdapter(params) {
    if (params === void 0) params = {};
    return passthrough("openBluetoothAdapter", params);
}
/**
 * 关闭蓝牙模块。
 *
 * 调用该方法将断开所有已建立的链接并释放系统资源。
 *
 * @compat WeCom
 *
 * @example
 * ```ts
 * ww.closeBluetoothAdapter()
 * ```
 */ function closeBluetoothAdapter(params) {
    if (params === void 0) params = {};
    return passthrough("closeBluetoothAdapter", params);
}
/**
 * 获取本机蓝牙适配器状态。
 *
 * @compat WeCom
 *
 * @example
 * ```ts
 * ww.getBluetoothAdapterState()
 * ```
 */ function getBluetoothAdapterState(params) {
    if (params === void 0) params = {};
    return passthrough("getBluetoothAdapterState", params);
}
/**
 * 监听蓝牙适配器状态变化。
 *
 * @compat WeCom
 *
 * @example
 * ```ts
 * ww.onBluetoothAdapterStateChange(function(event) {
 *   console.log(event)
 * })
 * ```
 */ function onBluetoothAdapterStateChange(callback) {
    on("onBluetoothAdapterStateChange", callback);
}
/**
 * 开始搜寻附近的蓝牙外围设备。
 *
 * @compat WeCom
 *
 * @example
 * ```ts
ww.startBluetoothDevicesDiscovery({
  services: ['FEE7']
})
 * ```
 */ function startBluetoothDevicesDiscovery(params) {
    if (params === void 0) params = {};
    return passthrough("startBluetoothDevicesDiscovery", params);
}
/**
 * 停止搜寻附近的蓝牙外围设备。
 *
 * 若已经找到需要的蓝牙设备并不需要继续搜索时，建议调用该接口停止蓝牙搜索。
 *
 * @compat WeCom
 *
 * @example
 * ```ts
 * ww.stopBluetoothDevicesDiscovery()
 * ```
 */ function stopBluetoothDevicesDiscovery(params) {
    if (params === void 0) params = {};
    return passthrough("stopBluetoothDevicesDiscovery", params);
}
/**
 * 获取在蓝牙模块生效期间所有已发现的蓝牙设备。
 *
 * @note
 * - 该接口获取到的设备列表为蓝牙模块生效期间所有搜索到的蓝牙设备，若在蓝牙模块使用流程结束后未及时调用 closeBluetoothAdapter 释放资源，
 *   调用该接口可能会返回之前蓝牙使用流程中搜索到的蓝牙设备，可能设备已经不在用户身边，无法连接
 * - 蓝牙设备在被搜索到时，系统返回的 name 字段一般为广播包中的 LocalName 字段中的设备名称，而如果与蓝牙设备建立连接，系统返回的 name
 *   字段会改为从蓝牙设备上获取到的 GattName。若需要动态改变设备名称并展示，建议使用 localName 字段
 *
 * @compat WeCom
 *
 * @example
 * ```ts
 * ww.getBluetoothDevices()
 * ```
 */ function getBluetoothDevices(params) {
    if (params === void 0) params = {};
    return promiseToCallback(params, /*#__PURE__*/ _async_to_generator(function() {
        var res, _iterator, _step, device;
        return __generator(this, function(_state) {
            switch(_state.label){
                case 0:
                    return [
                        4,
                        tryEnsureConfigReady()
                    ];
                case 1:
                    _state.sent();
                    return [
                        4,
                        invoke("getBluetoothDevices")
                    ];
                case 2:
                    res = _state.sent();
                    for(_iterator = _create_for_of_iterator_helper_loose(res.devices || []); !(_step = _iterator()).done;){
                        device = _step.value;
                        device.advertisData = base64ToArrayBuffer(device.advertisData);
                        device.serviceData = base64ToArrayBuffer(device.serviceData);
                    }
                    return [
                        2,
                        res
                    ];
            }
        });
    }));
}
/**
 * 监听寻找到新设备。
 *
 * @note
 * - 若在该接口中回调了某个设备，则此设备会添加到 getBluetoothDevices 接口返回的设备列表中
 *
 * @compat WeCom
 *
 * @example
 * ```ts
 * ww.onBluetoothDeviceFound(function(event) {
 *   console.log(event)
 * })
 * ```
 */ function onBluetoothDeviceFound(callback) {
    on("onBluetoothDeviceFound", callback);
}
/**
 * 根据 uuid 获取处于已连接状态的设备。
 *
 * @compat WeCom
 *
 * @example
 * ```ts
 * ww.getConnectedBluetoothDevices({
 *   services: ['FEE7']
 * })
 * ```
 */ function getConnectedBluetoothDevices(params) {
    return passthrough("getConnectedBluetoothDevices", params);
}
/**
 * 连接低功耗蓝牙设备。
 *
 * @note
 * - 安卓手机上如果多次调用 createBLEConnection 创建连接，有可能导致系统持有同一设备多个连接的实例，导致调用 closeBLEConnection 的时候并不能真正的断开与设备的连接。因此请保证尽量成对的调用 create 和 close 接口
 * - 蓝牙链接随时可能断开，建议监听 onBLEConnectionStateChange 回调事件，当蓝牙设备断开时按需执行重连操作
 * - 若对未连接的设备或已断开连接的设备调用数据读写操作的接口，会返回 10006 错误，建议进行重连操作
 *
 * @compat WeCom
 *
 * @example
 * ```ts
 * ww.createBLEConnection({
 *   deviceId: deviceId
 * })
 * ```
 */ function createBLEConnection(params) {
    return passthrough("createBLEConnection", params);
}
/**
 * 断开与低功耗蓝牙设备的连接。
 *
 * @compat WeCom
 *
 * @example
 * ```ts
 * ww.closeBLEConnection({
 *   deviceId: deviceId
 * })
 * ```
 */ function closeBLEConnection(params) {
    return passthrough("closeBLEConnection", params);
}
/**
 * 监听低功耗蓝牙连接状态的改变事件，包括开发者主动连接或断开连接，设备丢失，连接异常断开等等。
 *
 * @compat WeCom
 *
 * @example
 * ```ts
 * ww.onBLEConnectionStateChange(function(event) {
 *   console.log(event)
 * })
 * ```
 */ function onBLEConnectionStateChange(callback) {
    on("onBLEConnectionStateChange", callback);
}
/**
 * 获取蓝牙设备所有 service（服务）。
 *
 * @compat WeCom
 *
 * @example
 * ```ts
 * ww.getBLEDeviceServices({
 *   deviceId: deviceId
 * })
 * ```
 */ function getBLEDeviceServices(params) {
    return passthrough("getBLEDeviceServices", params);
}
/**
 * 获取蓝牙设备某个服务中的所有 characteristic（特征值）。
 *
 * @compat WeCom
 *
 * @example
 * ```ts
 * ww.getBLEDeviceCharacteristics({
 *   deviceId: deviceId,
 *   serviceId: serviceId
 * })
 * ```
 */ function getBLEDeviceCharacteristics(params) {
    return passthrough("getBLEDeviceCharacteristics", params);
}
/**
 * 读取低功耗蓝牙设备的特征值的二进制数据值。
 *
 * @note
 * - 设备的特征值必须支持 read 才可以成功调用，具体参照 characteristic 的 properties 属性
 * - 并行调用多次读写接口存在读写失败的可能性
 * - 接口读取到的信息需要在 onBLECharacteristicValueChange 的回调中获取
 *
 * @compat WeCom
 *
 * @example
 * ```ts
 * ww.readBLECharacteristicValue({
 *   deviceId: deviceId,
 *   serviceId: serviceId,
 *   characteristicId: characteristicId
 * })
 * ```
 */ function readBLECharacteristicValue(params) {
    return passthrough("readBLECharacteristicValue", params);
}
/**
 * 向低功耗蓝牙设备特征值中写入二进制数据。
 *
 * @note
 * - 设备的特征值必须支持 write 才可以成功调用，具体参照 characteristic 的 properties 属性
 * - 并行调用多次读写接口存在读写失败的可能性
 * - 接口不会对写入数据包大小做限制，但系统与蓝牙设备会确定蓝牙 4.0 单次传输的数据大小，超过最大字节数后会发生写入错误，建议每次写入不超过 20 字节
 * - 安卓平台上，在调用 notify 成功后立即调用 write 接口，在部分机型上会发生 10008 系统错误
 * - 若单次写入数据过长，iOS 平台上存在系统不会有任何回调的情况（包括错误回调）
 *
 * @compat WeCom
 *
 * @example
 * ```ts
 * ww.writeBLECharacteristicValue({
 *   deviceId: deviceId,
 *   serviceId: serviceId,
 *   characteristicId: characteristicId,
 *   value: arrayBufferValue
 * })
 * ```
 */ function writeBLECharacteristicValue(params) {
    return passthrough("writeBLECharacteristicValue", params, {
        deviceId: params.deviceId,
        serviceId: params.serviceId,
        characteristicId: params.characteristicId,
        value: arrayBufferToBase64(params.value)
    });
}
/**
 * 启用低功耗蓝牙设备特征值变化时的 notify 功能，订阅特征值。
 *
 * @note
 * - 设备的特征值必须支持 notify 或者 indicate 才可以成功调用，具体参照 characteristic 的 properties 属性
 * - 订阅操作成功后需要设备主动更新特征值的 value 才会触发 onBLECharacteristicValueChange 回调
 * - 安卓平台上，在调用 notify 成功后立即调用 write 接口，在部分机型上会发生 10008 系统错误
 *
 * @compat WeCom
 *
 * @example
 * ```ts
 * ww.notifyBLECharacteristicValueChange({
 *   deviceId: deviceId,
 *   serviceId: serviceId,
 *   characteristicId: characteristicId,
 *   state: true
 * })
 * ```
 */ function notifyBLECharacteristicValueChange(params) {
    return passthrough("notifyBLECharacteristicValueChange", params);
}
/**
 * 监听低功耗蓝牙设备的特征值变化。
 *
 * 必须先启用 notify 才能接收到设备推送的 notification。
 *
 * @compat WeCom
 *
 * @example
 * ```ts
 * ww.onBLECharacteristicValueChange(function(event) {
 *   console.log(event)
 * })
 * ```
 */ function onBLECharacteristicValueChange(callback) {
    on("onBLECharacteristicValueChange", function(event) {
        if (event == null ? void 0 : event.value) {
            event.value = base64ToArrayBuffer(event.value);
        }
        callback(event);
    });
}

/**
 * 设置系统剪贴板的内容。
 *
 * @compat WeCom iOS, Android >= 2.4.16; WeCom PC, Mac >= 3.1.2
 *
 * @example
 * ```ts
 * ww.setClipboardData({
 *   data: 'data'
 * })
 * ```
 */ function setClipboardData(params) {
    return passthrough("setClipboardData", params);
}
/**
 * 获取系统剪贴板内容。
 *
 * @compat WeCom >= 3.1.2
 *
 * @example
 * ```ts
 * ww.getClipboardData()
 * ```
 */ function getClipboardData(params) {
    if (params === void 0) params = {};
    return passthrough("getClipboardData", params);
}

/**
 * 开始搜索附近的 iBeacon 设备。
 *
 * @compat WeCom
 *
 * @example
 * ```ts
 * ww.startBeaconDiscovery({
 *   uuids: ['uuid']
 * })
 * ```
 */ function startBeaconDiscovery(params) {
    return passthrough("startBeaconDiscovery", params);
}
/**
 * 停止搜索附近的 iBeacon 设备。
 *
 * @compat WeCom
 *
 * @example
 * ```ts
 * ww.stopBeaconDiscovery()
 * ```
 */ function stopBeaconDiscovery(params) {
    if (params === void 0) params = {};
    return passthrough("stopBeaconDiscovery", params);
}
/**
 * 获取所有已搜索到的 iBeacon 设备。
 *
 * @compat WeCom
 *
 * @example
 * ```ts
 * ww.getBeacons()
 * ```
 */ function getBeacons(params) {
    if (params === void 0) params = {};
    return passthrough("getBeacons", params);
}
/**
 * 监听 iBeacon 设备的更新事件。
 *
 * @compat WeCom
 *
 * @example
 * ```ts
 * ww.onBeaconUpdate(function(event) {
 *   console.log(event)
 * })
 * ```
 */ function onBeaconUpdate(callback) {
    on("onBeaconUpdate", callback);
}
/**
 * 监听 iBeacon 服务的状态变化。
 *
 * @compat WeCom
 *
 * @example
 * ```ts
 * ww.onBeaconServiceChange(function(event) {
 *   console.log(event)
 * })
 * ```
 */ function onBeaconServiceChange(callback) {
    on("onBeaconServiceChange", callback);
}

var LocationType;
(function(LocationType) {
    LocationType[/**
   * gps 坐标
   */ "wgs84"] = "wgs84";
    LocationType[/**
   * 火星坐标
   */ "gcj02"] = "gcj02";
})(LocationType || (LocationType = {}));
/**
 * 使用企业微信内置地图查看位置。
 *
 * @example
 * ```ts
 * ww.openLocation({
 *   latitude: 0,
 *   longitude: 0,
 *   name: 'name',
 *   address: 'address',
 *   scale: 1
 * })
 * ```
 */ function openLocation(params) {
    return passthrough("openLocation", params, {
        latitude: params.latitude,
        longitude: params.longitude,
        name: params.name || "",
        address: params.address || "",
        scale: params.scale || 28,
        infoUrl: params.infoUrl || ""
    });
}
/**
 * 获取地理位置。
 *
 * @example
 * ```ts
 * ww.getLocation({
 *   type: 'wgs84'
 * })
 * ```
 */ function getLocation(params) {
    if (params === void 0) params = {};
    return promiseToCallback(params, /*#__PURE__*/ _async_to_generator(function() {
        var res;
        return __generator(this, function(_state) {
            switch(_state.label){
                case 0:
                    return [
                        4,
                        tryEnsureConfigReady()
                    ];
                case 1:
                    _state.sent();
                    return [
                        4,
                        invoke("geoLocation", {
                            type: params.type || "wgs84"
                        })
                    ];
                case 2:
                    res = _state.sent();
                    delete res.type;
                    return [
                        2,
                        res
                    ];
            }
        });
    }));
}
/**
 * 打开持续定位。
 *
 * @compat WeCom >= 2.4.20
 *
 * @example
 * ```ts
 * ww.startAutoLBS({
 *   type: 'gcj02'
 * })
 * ```
 */ function startAutoLBS(params) {
    return passthrough("startAutoLBS", params);
}
/**
 * 停止持续定位。
 *
 * @compat WeCom >= 2.4.20
 *
 * @example
 * ```ts
 * ww.stopAutoLBS()
 * ```
 */ function stopAutoLBS(params) {
    if (params === void 0) params = {};
    return passthrough("stopAutoLBS", params);
}
/**
 * 监听地理位置的变化。
 *
 * @limit
 * - 需要提前调用 startAutoLBS
 * - 需要用户停留在当前页面
 *
 * @compat WeCom >= 2.4.20
 *
 * @example
 * ```ts
 * ww.onLocationChange(function(event) {
 *   console.log(event)
 * })
 * ```
 */ function onLocationChange(callback) {
    on("auto:location:report", callback);
}

var NetworkType;
(function(NetworkType) {
    NetworkType[/**
   * wifi
   */ "wifi"] = "wifi";
    NetworkType[/**
   * 2g
   */ "network2g"] = "2g";
    NetworkType[/**
   * 3g
   */ "network3g"] = "3g";
    NetworkType[/**
   * 4g
   */ "network4g"] = "4g";
    NetworkType[/**
   * 无网络
   */ "none"] = "none";
    NetworkType[/**
   * Android下不常见的网络类型
   */ "unknown"] = "unknown";
})(NetworkType || (NetworkType = {}));
/**
 * 获取网络状态。
 *
 * @compat WeCom iOS, Android; WeChat
 *
 * @example
 * ```ts
 * ww.getNetworkType()
 * ```
 */ function getNetworkType(params) {
    if (params === void 0) params = {};
    return passthrough("getNetworkType", params);
}
/**
 * 监听网络状态变化。
 *
 * @compat WeCom iOS, Android
 *
 * @example
 * ```ts
 * ww.onNetworkStatusChange(function(event) {
 *   console.log(event)
 * })
 * ```
 */ function onNetworkStatusChange(callback) {
    on("onNetworkStatusChange", callback);
}

/**
 * 初始化 Wi-Fi 模块。
 *
 * @compat WeCom iOS, Android >= 2.4.16
 *
 * @example
 * ```ts
 * ww.startWifi()
 * ```
 */ function startWifi(params) {
    if (params === void 0) params = {};
    return passthrough("startWifi", params);
}
/**
 * 关闭 Wi-Fi 模块。
 *
 * @compat WeCom iOS, Android >= 2.4.16
 *
 * @example
 * ```ts
 * ww.stopWifi()
 * ```
 */ function stopWifi(params) {
    if (params === void 0) params = {};
    return passthrough("stopWifi", params);
}
/**
 * 连接 Wi-Fi。
 *
 * @compat WeCom iOS, Android >= 2.4.16
 *
 * @example
 * ```ts
 * ww.connectWifi({
 *   SSID: 'vincenthome',
 *   BSSID: '8c:a6:df:c8:f7:4b',
 *   password: 'test1234',
 * })
 * ```
 */ function connectWifi(params) {
    return passthrough("connectWifi", params);
}
/**
 * 获取 Wi-Fi 列表。
 *
 * @compat WeCom iOS, Android >= 2.4.16
 *
 * @example
 * ```ts
 * ww.getWifiList()
 * ```
 */ function getWifiList(params) {
    if (params === void 0) params = {};
    return passthrough("getWifiList", params);
}
/**
 * 监听 Wi-Fi 列表更新。
 *
 * @compat WeCom iOS, Android >= 2.4.16
 *
 * @example
 * ```ts
 * ww.onGetWifiList(function(event) {
 *   console.log(event)
 * })
 * ```
 */ function onGetWifiList(callback) {
    on("onGetWifiList", callback);
}
/**
 * 监听 Wi-Fi 连接成功。
 *
 * @compat WeCom iOS, Android >= 2.4.16
 *
 * @example
 * ```ts
 * ww.onWifiConnected(function(event) {
 *   console.log(event)
 * })
 * ```
 */ function onWifiConnected(callback) {
    on("onWifiConnected", callback);
}
/**
 * 获取已连接中的 Wi-Fi 信息。
 *
 * @compat WeCom iOS, Android >= 2.4.16
 *
 * @example
 * ```ts
 * ww.getConnectedWifi()
 * ```
 */ function getConnectedWifi(params) {
    if (params === void 0) params = {};
    return passthrough("getConnectedWifi", params);
}

/**
 * 预览文件。
 *
 * @compat WeCom iOS, Android
 *
 * @example
 * ```ts
 * wx.previewFile({
 *   url: 'http://open.work.weixin.qq.com/wwopen/downloadfile/wwapi.zip',
 *   name: 'Android开发工具包集合',
 *   size: 22189
 * })
 * ```
 */ function previewFile(params) {
    return passthrough("previewFile", params);
}

var SizeType;
(function(SizeType) {
    SizeType[/**
   * 原图
   */ "original"] = "original";
    SizeType[/**
   * 压缩后的图片
   */ "compressed"] = "compressed";
})(SizeType || (SizeType = {}));
var SourceType;
(function(SourceType) {
    SourceType[/**
   * 相册
   */ "album"] = "album";
    SourceType[/**
   * 相机
   */ "camera"] = "camera";
})(SourceType || (SourceType = {}));
var CameraMode;
(function(CameraMode) {
    CameraMode[/**
   * 单拍
   */ "normal"] = "normal";
    CameraMode[/**
   * 连拍
   *
   * @compat WeCom >= 2.3.0
   */ "batch"] = "batch";
    CameraMode[/**
   * 前置摄像头单拍
   *
   * @compat WeCom >= 3.0.26
   */ "front"] = "front";
    CameraMode[/**
   * 前置摄像头连拍
   *
   * @compat WeCom >= 3.0.26
   */ "batch_front"] = "batch_front";
})(CameraMode || (CameraMode = {}));
/**
 * 拍照或从手机相册中选图。
 *
 * @example
 * ```ts
 * ww.chooseImage({
 *   count: 1,
 *   sizeType: ['original', 'compressed'],
 *   sourceType: ['album', 'camera'],
 *   defaultCameraMode: 'batch',
 *   isSaveToAlbum: true
 * })
 * ```
 */ function chooseImage(params) {
    if (params === void 0) params = {};
    return promiseToCallback(params, /*#__PURE__*/ _async_to_generator(function() {
        var res;
        return __generator(this, function(_state) {
            switch(_state.label){
                case 0:
                    return [
                        4,
                        tryEnsureConfigReady()
                    ];
                case 1:
                    _state.sent();
                    return [
                        4,
                        invoke("chooseImage", {
                            scene: "1|2",
                            count: params.count || 9,
                            sizeType: params.sizeType || [
                                "original",
                                "compressed"
                            ],
                            sourceType: params.sourceType || [
                                "album",
                                "camera"
                            ],
                            defaultCameraMode: params.defaultCameraMode || "normal",
                            isSaveToAlbum: isFalsy(params.isSaveToAlbum) ? 0 : 1
                        })
                    ];
                case 2:
                    res = _state.sent();
                    if (isAndroid && res.localIds) {
                        res.localIds = res.localIds || "[]";
                        try {
                            res.localIds = JSON.parse(res.localIds);
                        } catch (error) {
                        // noop
                        }
                    }
                    return [
                        2,
                        res
                    ];
            }
        });
    }));
}
/**
 * 预览图片。
 *
 * @example
 * ```ts
 * ww.previewImage({
 *   current: imgURL,
 *   urls: [imgURL]
 * });
 * ```
 */ function previewImage(params) {
    return passthrough("imagePreview", params);
}
/**
 * 上传图片。
 *
 * 上传的图片有效期 3 天，可用[素材管理](#90253)接口下载图片到自己的服务器，此处获得的 serverId 即 media_id。
 *
 * @example
 * ```ts
 * ww.uploadImage({
 *   localId: localId,
 *   isShowProgressTips: true
 * })
 * ```
 */ function uploadImage(params) {
    return passthrough("uploadImage", params, {
        localId: params.localId,
        isShowProgressTips: isFalsy(params.isShowProgressTips) ? 0 : 1
    });
}
/**
 * 下载图片。
 *
 * @example
 * ```ts
 * ww.downloadImage({
 *   serverId: serverId,
 *   isShowProgressTips: true
 * })
 * ```
 */ function downloadImage(params) {
    return passthrough("downloadImage", params, {
        serverId: params.serverId,
        isShowProgressTips: isFalsy(params.isShowProgressTips) ? 0 : 1
    });
}
/**
 * 获取本地图片内容。
 *
 * 仅在 iOS WKWebView 下支持。
 *
 * @compat WeCom iOS >= 2.4.6
 *
 * @example
 * ```ts
 * ww.getLocalImgData({
 *   localId: localId
 * })
 * ```
 */ function getLocalImgData(params) {
    return passthrough("getLocalImgData", params);
}

/**
 * 开始录音。
 *
 * @example
 * ```ts
 * ww.startRecord()
 * ```
 */ function startRecord(params) {
    if (params === void 0) params = {};
    return passthrough("startRecord", params);
}
/**
 * 停止录音。
 *
 * @example
 * ```ts
 * ww.stopRecord()
 * ```
 */ function stopRecord(params) {
    if (params === void 0) params = {};
    return passthrough("stopRecord", params);
}
/**
 * 监听录音自动停止。
 *
 * @example
 * ```ts
 * ww.onVoiceRecordEnd({
 *   localId: localId
 * })
 * ```
 */ function onVoiceRecordEnd(callback) {
    on("onVoiceRecordEnd", callback);
}
/**
 * 播放语音。
 *
 * @example
 * ```ts
 * ww.playVoice({
 *   localId: localId
 * })
 * ```
 */ function playVoice(params) {
    return passthrough("playVoice", params);
}
/**
 * 暂停播放。
 *
 * @example
 * ```ts
 * ww.pauseVoice({
 *   localId: localId
 * })
 * ```
 */ function pauseVoice(params) {
    return passthrough("pauseVoice", params);
}
/**
 * 停止播放。
 *
 * @example
 * ```ts
 * ww.stopVoice({
 *   localId: localId
 * })
 * ```
 */ function stopVoice(params) {
    return passthrough("stopVoice", params);
}
/**
 * 监听语音播放完毕。
 *
 * @example
 * ```ts
 * ww.onVoicePlayEnd(function(event) {
 *   console.log(event)
 * })
 * ```
 */ function onVoicePlayEnd(callback) {
    on("onVoicePlayEnd", callback);
}
/**
 * 上传语音。
 *
 * 上传语音有效期 3 天，可以通过[素材管理](https://developer.work.weixin.qq.com/document/path/91054)接口下载语音到自己的服务器，接口返回的的 `serverId` 即 `media_id`。
 *
 * @example
 * ```ts
 * ww.uploadVoice({
 *   localId: localId,
 *   isShowProgressTips: true
 * })
 * ```
 */ function uploadVoice(params) {
    return passthrough("uploadVoice", params, {
        localId: params.localId,
        isShowProgressTips: isFalsy(params.isShowProgressTips) ? 0 : 1
    });
}
/**
 * 下载语音。
 *
 * @example
 * ```ts
 * ww.downloadVoice({
 *   serverId: serverId,
 *   isShowProgressTips: true
 * })
 * ```
 */ function downloadVoice(params) {
    return passthrough("downloadVoice", params, {
        serverId: params.serverId,
        isShowProgressTips: isFalsy(params.isShowProgressTips) ? 0 : 1
    });
}
/**
 * 语音转文字。
 *
 * @compat WeCom iOS, Android >= 2.7.5
 *
 * @example
 * ```ts
 * ww.translateVoice({
 *   localId: localId,
 *   isShowProgressTips: true
 * })
 * ```
 */ function translateVoice(params) {
    return passthrough("translateVoice", params, {
        localId: params.localId,
        isShowProgressTips: isFalsy(params.isShowProgressTips) ? 0 : 1
    });
}

var LiveType;
(function(LiveType) {
    LiveType[LiveType[/**
   * 通用直播
   */ "common"] = 0] = "common";
    LiveType[LiveType[/**
   * 企业培训
   */ "corp_training"] = 1] = "corp_training";
    LiveType[LiveType[/**
   * 大班课
   */ "edu_normal_class"] = 2] = "edu_normal_class";
    LiveType[LiveType[/**
   * 小班课
   */ "edu_small_class"] = 3] = "edu_small_class";
})(LiveType || (LiveType = {}));
function startLiving(params) {
    if (params === void 0) params = {};
    return passthrough("startLiving", params);
}
/**
 * 调起直播间回放页面。
 *
 * @limit
 * - 应用需具有直播使用权限，见[配置可使用直播的应用](#25967/配置可使用直播的应用)
 *
 * @compat WeCom >= 3.1.0
 *
 * @example
 * ```ts
 * ww.replayLiving({
 *   livingId: 'LIVINGID'
 * })
 * ```
 */ function replayLiving(params) {
    return passthrough("replayLiving", params);
}
/**
 * 调起直播回放下载页面。
 *
 * @limit
 * - 应用需具有直播使用权限，见[配置可使用直播的应用](#25967/配置可使用直播的应用)
 * - 只允许直播的发起人下载直播回放
 *
 * @compat WeCom PC >= 3.1.0
 *
 * @example
 * ```ts
 * ww.downloadLivingReplay({
 *   livingId: 'LIVINGID'
 * })
 * ```
 */ function downloadLivingReplay(params) {
    return passthrough("downloadLivingReplay", params);
}

function startMeeting(params) {
    if (params === void 0) params = {};
    return passthrough("startMeeting", params);
}

/**
 * 选择可分享的在线文档
 *
 * @compat WeCom >= 4.0.12
 */ function wedocSelectDoc(params) {
    if (params === void 0) params = {};
    return passthrough("wedocSelectDoc", params);
}

/**
 * 选择可上传的目录/空间
 *
 * 选中一个具有可上传权限的目录/空间，返回选中目录/空间对应的 selectedTicket
 *
 * @compat WeCom >= 4.0.12
 */ function wedriveSelectDir(params) {
    if (params === void 0) params = {};
    return passthrough("wedriveSelectDir", params);
}
/**
 * 选择可分享的文件
 *
 * 选中一个或多个具有可分享权限的微盘文件或在线文档，返回选中文件的 url
 *
 * @compat WeCom >= 4.0.12
 */ function wedriveSelectFileForShare(params) {
    return passthrough("wedriveSelectFileForShare", params);
}
/**
 * 选择可下载的文件
 *
 * 选中一个或多个具有下载权限的文件（只能是微盘文件，不支持在线文档），返回选中文件对应的 selectedTickets 列表
 *
 * @compat WeCom >= 4.0.12
 */ function wedriveSelectFileForDownload(params) {
    return passthrough("wedriveSelectFileForDownload", params);
}

/**
 * 监听页面返回事件。
 *
 * @param callback 回调函数，返回 false 则表示中断此次返回操作
 *
 * @limit
 * - 当页面左上角没有关闭按钮，不产生该事件
 * - iOS 系统下使用手势返回时，不产生该事件
 *
 * @compat WeCom iOS, Android >= 2.2.0; WeCom PC, Mac >= 2.4.5
 *
 * @example
 * ```ts
 * ww.onHistoryBack(function() {
 *   return confirm('确定放弃当前页面的修改？')
 * })
 * ```
 */ function onHistoryBack(callback) {
    on("historyBack", callback);
}
/**
 * 隐藏右上角菜单。
 *
 * @example
 * ```ts
 * ww.hideOptionMenu()
 * ```
 */ function hideOptionMenu(params) {
    if (params === void 0) params = {};
    return passthrough("hideOptionMenu", params);
}
/**
 * 显示右上角菜单。
 *
 * @example
 * ```ts
 * ww.showOptionMenu()
 * ```
 */ function showOptionMenu(params) {
    if (params === void 0) params = {};
    return passthrough("showOptionMenu", params);
}
/**
 * 关闭当前网页窗口。
 *
 * @example
 * ```ts
 * ww.closeWindow()
 * ```
 */ function closeWindow(params) {
    if (params === void 0) params = {};
    return passthrough("closeWindow", params);
}
/**
 * 批量隐藏功能按钮。
 *
 * @example
 * ```ts
 * ww.hideMenuItems({
 *   menuList: ['menuItem:setFont']
 * })
 * ```
 */ function hideMenuItems(params) {
    return passthrough("hideMenuItems", params);
}
/**
 * 批量显示功能按钮。
 *
 * @example
 * ```ts
ww.showMenuItems({
  menuList: ['menuItem:setFont']
})
 * ```
 */ function showMenuItems(params) {
    return passthrough("showMenuItems", params);
}
/**
 * 隐藏所有非基础按钮。
 *
 * @example
 * ```ts
 * ww.hideAllNonBaseMenuItem()
 * ```
 */ function hideAllNonBaseMenuItem(params) {
    if (params === void 0) params = {};
    return passthrough("hideAllNonBaseMenuItem", params);
}
/**
 * 显示所有功能按钮。
 *
 * @example
 * ```ts
 * ww.showAllNonBaseMenuItem()
 * ```
 */ function showAllNonBaseMenuItem(params) {
    if (params === void 0) params = {};
    return passthrough("showAllNonBaseMenuItem", params);
}
/**
 * 打开系统默认浏览器。
 *
 * @compat WeCom PC >= 2.3.0
 *
 * @example
 * ```ts
 * ww.openDefaultBrowser({
 *   url: 'https://work.weixin.qq.com/'
 * })
 * ```
 */ function openDefaultBrowser(params) {
    return passthrough("openDefaultBrowser", params);
}
/**
 * 监听用户截屏事件。
 *
 * @compat WeCom iOS, Android >= 2.5.0
 *
 * @example
 * ```ts
 * ww.onUserCaptureScreen(function() {
 *   console.log('用户截屏了')
 * })
 * ```
 */ function onUserCaptureScreen(callback) {
    on("onUserCaptureScreen", callback);
}

/**
 * 获取「转发」按钮点击状态并自定义分享内容。
 *
 * @note
 * - 微信客户端即将废弃该接口
 *
 * @limit
 * - 仅激活成员数超过 200 人且已经认证的企业才可在微信上调用
 *
 * @example
 * ```ts
 * ww.onMenuShareAppMessage({
 *   title: '企业微信',
 *   desc: '让每个企业都有自己的微信',
 *   link: 'https://work.weixin.qq.com/',
 *   imgUrl: 'https://res.mail.qq.com/node/ww/wwmng/style/images/index_share_logo$13c64306.png',
 *   success() {
 *     // 用户确认分享后回调
 *   },
 *   cancel() {
 *     // 用户取消分享后回调
 *   }
 * })
 * ```
 */ function onMenuShareAppMessage(params) {
    bindShare("menu:share:appmessage", params, function() {
        return invoke("sendAppMessage", {
            title: params.title || getTitle(),
            desc: params.desc || "",
            link: params.link || getHref(),
            img_url: params.imgUrl || "",
            type: params.type || "link",
            data_url: params.dataUrl || ""
        });
    });
}
/**
 * 获取「分享到朋友圈」按钮点击状态并自定义分享内容。
 *
 * @note
 * - 微信客户端即将废弃该接口
 *
 * @example
 * ```ts
 * ww.onMenuShareTimeline({
 *   title: '企业微信',
 *   link: 'https://work.weixin.qq.com/',
 *   imgUrl: 'https://res.mail.qq.com/node/ww/wwmng/style/images/index_share_logo$13c64306.png',
 *   success() {
 *     // 用户确认分享后回调
 *   },
 *   cancel() {
 *     // 用户取消分享后回调
 *   }
 * })
 * ```
 */ function onMenuShareTimeline(params) {
    bindShare("menu:share:timeline", params, function() {
        return invoke("shareTimeline", {
            title: params.title || getTitle(),
            desc: params.title || getTitle(),
            img_url: params.imgUrl || "",
            link: params.link || getHref(),
            type: params.type || "link",
            data_url: params.dataUrl || ""
        });
    });
}
/**
 * 获取「微信」按钮点击状态并自定义分享内容。
 *
 * @compat WeCom
 *
 * @example
 * ```ts
 * ww.onMenuShareWechat({
 *   title: '企业微信',
 *   desc: '让每个企业都有自己的微信',
 *   link: 'https://work.weixin.qq.com/',
 *   imgUrl: 'https://res.mail.qq.com/node/ww/wwmng/style/images/index_share_logo$13c64306.png',
 *   success() {
 *     // 用户确认分享后回调
 *   },
 *   cancel() {
 *     // 用户取消分享后回调
 *   }
 * })
 * ```
 */ function onMenuShareWechat(params) {
    bindShare("menu:share:wechat", params, function() {
        return invoke("shareWechat", {
            title: params.title || getTitle(),
            desc: params.desc || "",
            link: params.link || getHref(),
            img_url: params.imgUrl || "",
            type: params.type || "link",
            data_url: params.dataUrl || ""
        });
    });
}
/**
 * 获取「分享到QQ」按钮点击状态并自定义分享内容。
 *
 * @note
 * 微信客户端即将废弃该接口
 *
 * @compat WeChat
 */ function onMenuShareQQ(params) {
    bindShare("menu:share:qq", params, function() {
        return invoke("shareQQ", {
            title: params.title || getTitle(),
            desc: params.desc || "",
            img_url: params.imgUrl || "",
            link: params.link || getHref()
        });
    });
}
/**
 * 获取「分享到微博」按钮点击状态并自定义分享内容。
 *
 * @compat WeChat
 */ function onMenuShareWeibo(params) {
    bindShare("menu:share:weiboApp", params, function() {
        return invoke("shareWeiboApp", {
            title: params.title || getTitle(),
            desc: params.desc || "",
            img_url: params.imgUrl || "",
            link: params.link || getHref()
        });
    });
}
/**
 * 获取「分享到QQ空间」按钮点击状态并自定义分享内容。
 *
 * @note
 * 微信客户端即将废弃该接口
 *
 * @compat WeChat
 */ function onMenuShareQZone(params) {
    bindShare("menu:share:QZone", params, function() {
        return invoke("shareQZone", {
            title: params.title || getTitle(),
            desc: params.desc || "",
            img_url: params.imgUrl || "",
            link: params.link || getHref()
        });
    });
}
/**
 * 自定义转发到会话。
 *
 * @compat WeCom >= 2.4.5
 *
 * @example
 * ```ts
 * ww.shareAppMessage({
 *   title: '企业微信',
 *   desc: '让每个企业都有自己的微信',
 *   link: 'https://work.weixin.qq.com/',
 *   imgUrl: 'https://res.mail.qq.com/node/ww/wwmng/style/images/index_share_logo$13c64306.png',
 * })
 * ```
 */ function shareAppMessage(params) {
    return passthrough("shareAppMessage", params);
}
/**
 * 自定义转发到微信。
 *
 * @compat WeCom >= 2.4.5
 *
 * @example
 * ```ts
 * ww.shareWechatMessage({
 *   title: '企业微信',
 *   desc: '让每个企业都有自己的微信',
 *   link: 'https://work.weixin.qq.com/',
 *   imgUrl: 'https://res.mail.qq.com/node/ww/wwmng/style/images/index_share_logo$13c64306.png',
 * })
 * ```
 */ function shareWechatMessage(params) {
    return passthrough("shareWechatMessage", params);
}
/**
 * 自定义「分享到朋友圈」及「分享到QQ空间」按钮的分享内容。
 *
 * @compat WeChat
 */ function updateTimelineShareData(params) {
    if (params === void 0) params = {};
    return passthrough("updateTimelineShareData", params);
}
/**
 * 自定义「分享给朋友」及「分享到QQ」按钮的分享内容。
 *
 * @compat WeChat
 */ function updateAppMessageShareData(params) {
    if (params === void 0) params = {};
    return passthrough("updateAppMessageShareData", params);
}

/**
 * 批量添加卡券
 *
 * @see https://developers.weixin.qq.com/doc/offiaccount/OA_Web_Apps/JS-SDK.html#批量添加卡券接口
 */ function addCard(params) {
    return promiseToCallback(params, /*#__PURE__*/ _async_to_generator(function() {
        var res, _iterator, _step, card;
        return __generator(this, function(_state) {
            switch(_state.label){
                case 0:
                    return [
                        4,
                        tryEnsureConfigReady()
                    ];
                case 1:
                    _state.sent();
                    return [
                        4,
                        invoke("batchAddCard", {
                            card_list: params.cardList.map(function(card) {
                                return {
                                    card_id: card.cardId,
                                    card_ext: card.cardExt
                                };
                            })
                        })
                    ];
                case 2:
                    res = _state.sent();
                    if (!res.card_list) {
                        return [
                            2,
                            res
                        ];
                    }
                    for(_iterator = _create_for_of_iterator_helper_loose(res.card_list); !(_step = _iterator()).done;){
                        card = _step.value;
                        card.cardId = card.card_id;
                        delete card.card_id;
                        card.cardExt = card.card_ext;
                        delete card.card_ext;
                        card.isSuccess = !!card.is_succ;
                        delete card.is_succ;
                    }
                    res.cardList = res.card_list;
                    delete res.card_list;
                    return [
                        2,
                        res
                    ];
            }
        });
    }));
}
/**
 * 拉取适用卡券列表并获取用户选择信息
 *
 * @see https://developers.weixin.qq.com/doc/offiaccount/OA_Web_Apps/JS-SDK.html#拉取适用卡券列表并获取用户选择信息
 */ function chooseCard(params) {
    return promiseToCallback(params, /*#__PURE__*/ _async_to_generator(function() {
        var res;
        return __generator(this, function(_state) {
            switch(_state.label){
                case 0:
                    return [
                        4,
                        tryEnsureConfigReady()
                    ];
                case 1:
                    _state.sent();
                    return [
                        4,
                        invoke("chooseCard", {
                            app_id: getConfigCorpId(),
                            location_id: params.shopId || "",
                            sign_type: params.signType || "SHA1",
                            card_id: params.cardId || "",
                            card_type: params.cardType || "",
                            card_sign: params.cardSign,
                            time_stamp: "" + params.timestamp,
                            nonce_str: params.nonceStr
                        })
                    ];
                case 2:
                    res = _state.sent();
                    res.cardList = res.choose_card_info;
                    delete res.choose_card_info;
                    return [
                        2,
                        res
                    ];
            }
        });
    }));
}
/**
 * 查看微信卡包中的卡券
 *
 * @see https://developers.weixin.qq.com/doc/offiaccount/OA_Web_Apps/JS-SDK.html#查看微信卡包中的卡券接口
 */ function openCard(params) {
    return passthrough("batchViewCard", params, {
        card_list: params.cardList.map(function(card) {
            return {
                card_id: card.cardId,
                code: card.code
            };
        })
    });
}
/**
 * 核销并分享卡券
 *
 * @deprecated
 */ function consumeAndShareCard(params) {
    return passthrough("consumedShareCard", params, {
        consumedCardId: params.cardId,
        consumedCode: params.code
    });
}

var ProductViewType;
(function(ProductViewType) {
    ProductViewType[ProductViewType["normal"] = 0] = "normal";
    ProductViewType[ProductViewType["scan"] = 1] = "scan";
})(ProductViewType || (ProductViewType = {}));
/**
 * 跳转微信商品页
 *
 * @see https://developers.weixin.qq.com/doc/offiaccount/OA_Web_Apps/JS-SDK.html#跳转微信商品页接口
 */ function openProductSpecificView(params) {
    return passthrough("openProductViewWithPid", params, {
        pid: params.productId,
        view_type: params.viewType || 0,
        ext_info: params.extInfo
    });
}

/**
 * 发起一个微信支付请求
 *
 * @see https://developers.weixin.qq.com/doc/offiaccount/OA_Web_Apps/JS-SDK.html#发起一个微信支付请求
 */ function chooseWXPay(params) {
    return passthrough("getBrandWCPayRequest", params, normalizeParams(params));
}
/**
 * 领取企业红包
 */ function openEnterpriseRedPacket(params) {
    return passthrough("getRecevieBizHongBaoRequest", params, normalizeParams(params));
}
function normalizeParams(params) {
    return {
        timeStamp: "" + params.timestamp,
        nonceStr: params.nonceStr,
        package: params.package,
        paySign: params.paySign,
        signType: params.signType || "SHA1"
    };
}

/**
 * 添加设备。
 *
 * @limit
 * - 发起用户需要有设备添加权限（超级管理员/设备管理员）
 *
 * @compat WeCom iOS, Android >= 4.0.18
 *
 * @example
 * ```ts
 * ww.addDevice({
 *   type: 'qrcode',
 *   qrcode_url: 'https://open.work.weixin.qq.com/connect?xxx'
 * })
 * ```
 */ function addDevice(params) {
    return passthrough("addDevice", params);
}

/**
 * 判断当前客户端版本是否支持指定 JS 接口。
 *
 * @example
 * ```ts
 * ww.checkJsApi({
 *   jsApiList: ['chooseImage']
 * })
 * ```
 */ function checkJsApi(params) {
    return _checkJsApi.apply(this, arguments);
}
function _checkJsApi() {
    _checkJsApi = _async_to_generator(function(params) {
        return __generator(this, function(_state) {
            return [
                2,
                promiseToCallback(params, /*#__PURE__*/ _async_to_generator(function() {
                    var res;
                    return __generator(this, function(_state) {
                        switch(_state.label){
                            case 0:
                                return [
                                    4,
                                    tryEnsureConfigReady()
                                ];
                            case 1:
                                _state.sent();
                                return [
                                    4,
                                    invoke("checkJsApi", {
                                        jsApiList: mapJsApiListToClient(params.jsApiList)
                                    })
                                ];
                            case 2:
                                res = _state.sent();
                                res.checkResult = normalize(flatten(res.checkResult));
                                return [
                                    2,
                                    res
                                ];
                        }
                    });
                }))
            ];
        });
    });
    return _checkJsApi.apply(this, arguments);
}
function normalize(data) {
    var result = _extends({}, data);
    for(var _iterator = _create_for_of_iterator_helper_loose(Object.keys(data)), _step; !(_step = _iterator()).done;){
        var key = _step.value;
        result[mapJsApiNameToWeb(key)] = data[key];
    }
    return result;
}
function flatten(data) {
    var result = {};
    for(var _iterator = _create_for_of_iterator_helper_loose(Object.keys(data)), _step; !(_step = _iterator()).done;){
        var key = _step.value;
        if (!isObject(data[key])) {
            result[key] = data[key];
            continue;
        }
        var child = flatten(data[key]);
        for(var _iterator1 = _create_for_of_iterator_helper_loose(Object.keys(child)), _step1; !(_step1 = _iterator1()).done;){
            var childKey = _step1.value;
            result[key + "." + childKey] = child[childKey];
        }
    }
    return result;
}

/**
 * 查看日程闲忙状态。
 *
 * 查看其他成员某段时间内日程中的闲忙状态。
 *
 * @limit
 * - 当前成员必须在应用可见范围内
 * - 应用需具有日程使用权限
 *
 * @compat WeCom >= 4.0.20
 *
 * @example
 * ```ts
 * ww.checkSchedule({
 *   start_time: 1667232000,
 *   end_time: 1667318400,
 *   users: ['jack', 'jason']
 * })
 * ```
 */ function checkSchedule(params) {
    return passthrough("checkSchedule", params);
}

/**
 * 拉起电子发票列表。
 *
 * @compat WeCom iOS, Android >= 2.1.0
 *
 * @example
 * ```ts
 * ww.chooseInvoice({
 *   timestamp: timestamp,
 *   nonceStr: nonceStr,
 *   signType: signType,
 *   cardSign: cardSign
 * })
 * ```
 */ function chooseInvoice(params) {
    return passthrough("chooseInvoice", params);
}

/**
 * 认领老师班级
 *
 * 跳转到认领班级的界面
 *
 * @compat WeCom >= 3.1.8
 */ function claimClassAdmin(params) {
    if (params === void 0) params = {};
    return passthrough("claimClassAdmin", params);
}

/**
 * 创建群聊并发送消息
 *
 * 向用户申请给指定范围发送消息。调用接口后，用户可在选人界面对群聊范围进行修改，当创建群聊成功时会返回新建的群聊 ID
 *
 * @limit
 * - 仅第三方应用（非通讯录应用）可调用
 *
 * @compat WeCom >= 3.1.8
 *
 * @example
 * ```ts
 * ww.createChatWithMsg({
 *   selectedOpenUserIds: ['zhangsan','lisi'],
 *   selectedTickets: ['tick1','token2'],
 *   chatName: 'discussName',
 *   msg: {
 *     msgtype: 'link',
 *     link: {
 *       title: 'title1',
 *       desc: 'desc1',
 *       url: 'link1',
 *       imgUrl: 'imgurl1'
 *     }
 *   }
 * })
 * ```
 */ function createChatWithMsg(params) {
    return passthrough("createChatWithMsg", params);
}

/**
 * 创建企业互联/上下游会话
 *
 * @limit
 * - 企业必须开启互联群功能
 * - 仅局校互联和上下游企业可调用
 * - 当前成员必须在应用的可见范围
 * - 群成员人数不能超过 2000 人
 * - 如果创建的会话有外部联系人，群成员人数不能超过 40 人
 *
 * @compat WeCom >= 3.1.8
 *
 * @example
 * ```ts
 * ww.createCorpGroupChat({
 *   groupName: '讨论组',
 *   userIds: ['lisi', 'lisi2'],
 *   openUserIds: ['wabc3', 'wbcde'],
 *   externalUserIds: ['exid1', 'exid2'],
 *   corpGroupUserIds: [
 *     {
 *       corpId: 'ww3333',
 *       userId: 'userid123',
 *       openUserId: 'wx1111'
 *     },
 *     {
 *       corpId: 'ww4444',
 *       userId: 'userid123',
 *       openUserId: 'wx1111'
 *     }
 *   ]
 * })
 * ```
 */ function createCorpGroupChat(params) {
    return passthrough("createCorpGroupChat", params, {
        groupName: params.groupName || "",
        userIds: params.userIds,
        openUserIds: params.openUserIds,
        corpGroupUserIds: params.corpGroupUserIds
    });
}

var CreateExternalPaymentType;
(function(CreateExternalPaymentType) {
    CreateExternalPaymentType[CreateExternalPaymentType[/**
   * 在聊天中收款
   */ "chat"] = 0] = "chat";
    CreateExternalPaymentType[CreateExternalPaymentType[/**
   * 收款码收款
   */ "qrcode"] = 1] = "qrcode";
})(CreateExternalPaymentType || (CreateExternalPaymentType = {}));
/**
 * 发起对外收款
 *
 * @limit
 * - 应用需要具有对外收款权限
 * - 发起的用户必须在应用可见范围并实名
 * - 允许第三方应用、代开发应用和自建应用调用
 *
 * @compat WeCom >= 4.0.12
 *
 * @example
 * ```ts
 * ww.createExternalPayment({
 *   paymentType: 0,
 *   totalFee: 300,
 *   description: '可乐一罐'
 * })
 * ```
 */ function createExternalPayment(params) {
    if (params === void 0) params = {};
    return passthrough("createExternalPayment", params);
}

/**
 * 发起班级收款
 *
 * 用于老师对学生家长发起付款请求，接口调用成功后会通过家校通知发送付款小程序给家长
 *
 * @limit
 * - 仅支持配置在家长可使用范围内的应用
 * - 企业必须已验证或者已认证
 * - 发起的用户必须在应用可见范围并实名
 * - 发起的用户需在个人微信零钱账户的可用范围内
 *
 * @compat WeCom iOS, Android, PC >= 3.1.10
 *
 * @example
 * ```ts
 * ww.createSchoolPayment({
 *   projectName: '1班班费',
 *   amount: 100,
 *   payers: {
 *     students: ['zhagnshan', 'lisi'],
 *     departments: [1, 2]
 *   }
 * })
 * ```
 */ function createSchoolPayment(params) {
    return passthrough("createSchoolPayment", params);
}

/**
 * 添加设备。
 *
 * @deprecated 请使用 addDevice 接口
 *
 * @limit
 * - 调用者必须为企业超级管理员
 *
 * @compat WeCom iOS, Android >= 2.5.8
 *
 * @example
 * ```ts
 * ww.discoverDevice({
 *   type: 'qrcode',
 *   qrcode_url: 'https://open.work.weixin.qq.com/connect?xxx'
 * })
 * ```
 */ function discoverDevice(params) {
    return passthrough("discoverDevice", params);
}

/**
 * 加入视频会议。
 *
 * @limit
 * - 只能加入同企业硬件创建的视频会议
 *
 * @compat WeCom >= 2.5.0
 *
 * @example
 * ```ts
 * ww.enterHWOpenTalk({
 *   code: code,
 *   ticket: ticket
 * })
 * ```
 */ function enterHWOpenTalk(params) {
    return passthrough("enterHWOpenTalk", params);
}

/**
 * 跳转认证界面。
 *
 * @compat WeCom iOS, Android >= 2.8.7
 *
 * @example
 * ```ts
 * ww.enterpriseVerify()
 * ```
 */ function enterpriseVerify(params) {
    if (params === void 0) params = {};
    return passthrough("enterpriseVerify", params);
}

/**
 * 获取已选择的选项。
 *
 * 当用户打开网页后，应该先调用一次该接口获取用户已经选择的数据作为初始数据。获取到初始数据后，应该恢复已经选择的选项。
 *
 * @limit
 * - 网页应该做好深色模式适配
 * - 接口仅用于审批设置外部选项场景，请勿用作其他场景
 *
 * @compat WeCom >= 4.0.18
 *
 * @example
 * ```ts
 * ww.getApprovalSelectedItems({
 *   key: 'key'
 * })
 * ```
 */ function getApprovalSelectedItems(params) {
    return promiseToCallback(params, /*#__PURE__*/ _async_to_generator(function() {
        var res;
        return __generator(this, function(_state) {
            switch(_state.label){
                case 0:
                    return [
                        4,
                        tryEnsureConfigReady()
                    ];
                case 1:
                    _state.sent();
                    return [
                        4,
                        invoke("getApprovalSelectedItems", {
                            key: params.key
                        })
                    ];
                case 2:
                    res = _state.sent();
                    if (!res.selectedData) {
                        return [
                            2,
                            res
                        ];
                    }
                    try {
                        res.selectedData = JSON.parse(res.selectedData);
                    } catch (error) {
                        res.selectedData = [];
                    }
                    return [
                        2,
                        res
                    ];
            }
        });
    }));
}

var EntryType;
(function(EntryType) {
    EntryType[/**
   * 从联系人详情进入
   */ "contact_profile"] = "contact_profile";
    EntryType[/**
   * 从单聊会话的工具栏进入
   */ "single_chat_tools"] = "single_chat_tools";
    EntryType[/**
   * 从群聊会话的工具栏进入
   */ "group_chat_tools"] = "group_chat_tools";
    EntryType[/**
   * 从会话的聊天附件栏进入
   *
   * @compat WeCom >= 3.1.6
   */ "chat_attachment"] = "chat_attachment";
    EntryType[/**
   * 从微信客服的工具栏进入
   *
   * @compat WeCom >= 3.1.10
   */ "single_kf_tools"] = "single_kf_tools";
    EntryType[/**
   * 上下游单聊会话的工具栏
   *
   * @compat WeCom >= 4.0.8
   */ "chain_single_chat_tools"] = "chain_single_chat_tools";
    EntryType[/**
   * 上下游群聊会话的工具栏
   *
   * @compat WeCom >= 4.0.8
   */ "chain_group_chat_tools"] = "chain_group_chat_tools";
    EntryType[/**
   * 除以上场景之外进入，例如工作台，聊天会话等
   */ "normal"] = "normal";
})(EntryType || (EntryType = {}));
/**
 * 调用该接口可以判断用户是从哪个入口打开页面，从而决定是否可以调用客户联系相关的接口。
 *
 * @compat WeCom >= 3.0.24
 *
 * @example
 * ```ts
 * ww.getContext()
 * ```
 */ function getContext(params) {
    if (params === void 0) params = {};
    return passthrough("getContext", params);
}

/**
 * 获取当前上下游互联群的群 ID
 *
 * @compat WeCom >= 4.0.12
 */ function getCurCorpGroupChat(params) {
    if (params === void 0) params = {};
    return passthrough("getCurCorpGroupChat", params);
}

/**
 * 获取当前上下游联系人用户 ID
 *
 * @compat WeCom >= 4.0.8
 */ function getCurCorpGroupContact(params) {
    return passthrough("getCurCorpGroupContact", params);
}

/**
 * 获取当前客户群的群 ID。
 *
 * @limit
 * - 不同的入口对应用及用户有相应的限制
 *   | getContext 接口返回的 entry 值 | 自建应用 | 第三方应用 | 用户 | 支持的最低版本 |
 *   | --- | --- | --- | --- | --- |
 *   | group_chat_tools | 需有客户联系功能权限 | 需有“企业客户权限->客户基础信息”权限 | 配置了客户联系功能 | 2.8.17 |
 *   | group_chat_tools | 所有 | 需有「家校沟通」使用权限 | 所有 | 3.0.36 |
 *   | group_chat_tools | 所有 | 需有「家校沟通」使用权限 | 所有 | 4.0.8 |
 *
 * @compat WeCom >= 2.8.17
 *
 * @example
 * ```ts
 * ww.getCurExternalChat()
 * ```
 */ function getCurExternalChat(params) {
    if (params === void 0) params = {};
    return passthrough("getCurExternalChat", params);
}

/**
 * 获取当前外部联系人 userId。
 *
 * @limit
 * - 不同的入口对应用及用户有相应的限制
 *   | getContext 接口返回的 entry 值 | 自建应用 | 第三方应用 | 用户 | 支持的最低版本 |
 *   | --- | --- | --- | --- | --- |
 *   | contact_profile | 需有客户联系功能权限 | 需有“企业客户权限->客户基础信息”权限 | 配置了客户联系功能 | 2.5.8 |
 *   | single_chat_tools | 需有客户联系功能权限 | 需有“企业客户权限->客户基础信息”权限 | 配置了客户联系功能 | 2.8.10 |
 *
 * @compat WeCom >= 2.5.8
 *
 * @example
 * ```ts
 * ww.getCurExternalContact()
 * ```
 */ function getCurExternalContact(params) {
    if (params === void 0) params = {};
    return passthrough("getCurExternalContact", params);
}

/**
 * 获取私密消息信息
 *
 * @compat WeCom >= 3.1.8
 *
 * @example
 * ```ts
 * ww.getShareInfo({
 *   shareTicket: 'xxx'
 * })
 * ```
 */ function getShareInfo(params) {
    return passthrough("getShareInfo", params);
}

/**
 * 隐藏聊天附件栏的发送按钮
 *
 * 隐藏从聊天附件栏打开页面时固定显示的发送按钮，开发者可以通过[分享消息到当前会话](#sendChatMessage)接口灵活适配对页面或页面中具体内容的转发
 *
 * @limit
 * - 需要从附件栏进入才允许调用
 *
 * @compat WeCom >= 3.1.6
 */ function hideChatAttachmentMenu(params) {
    return passthrough("hideChatAttachmentMenu", params);
}

/**
 * 跳转到小程序。
 *
 * @note
 * - 打开小程序时如果需要关闭页面，需同步调用 closeWindow，不推荐用 setTimeout 延迟关闭
 *
 * @limit
 * - 跳转的小程序必须属于页面所属的企业
 * - 跳转的小程序必须已关联到工作台
 *
 * @compat WeCom >= 3.0.36
 *
 * @example
 * ```ts
 * ww.launchMiniprogram({
 *   appid: 'wx062f7a5507909000',
 *   path: 'pages/home/index'
 * })
 * ```
 */ function launchMiniprogram(params) {
    return passthrough("launchMiniprogram", params, {
        appid: params.appid,
        path: addHTMLToPath(params.path),
        envVersion: params.envVersion
    });
}
function addHTMLToPath(url) {
    if (!url || !isString(url)) {
        return;
    }
    var _url_split = url.split("?"), path = _url_split[0], query = _url_split.slice(1);
    if (!query.length) {
        return "" + path + ".html";
    }
    return path + ".html?" + query.join("?");
}

/**
 * 在企业微信内快速跳转到添加客户的界面。
 *
 * @limit
 * - 当前成员必须配置了客户联系功能
 * - 第三方应用须配置客户联系功能权限
 *
 * @compat WeCom iOS, Android >= 3.0.36
 *
 * @example
 * ```ts
 * ww.navigateToAddCustomer()
 * ```
 */ function navigateToAddCustomer(params) {
    if (params === void 0) params = {};
    return passthrough("navigateToAddCustomer", params);
}

/**
 * 进入微信客服消息界面
 *
 * @limit
 * - 当前企业须已开启「微信客服」应用
 * - 当前成员须是指定客服账号的坐席
 *
 * @compat WeCom iOS, Android, PC >= 3.1.12
 *
 * @example
 * ```ts
 * ww.navigateToKfChat({
 *   openKfId: 'wkAJ2GCAAAZSfhHCt7IFSvLKtMPxyAAA',
 *   externalUserId: 'wmAJ2GCAAAZSfhHCt7IFSvLKtMPxyBBB'
 * })
 * ```
 */ function navigateToKfChat(params) {
    return passthrough("navigateToKfChat", params);
}

/**
 * 共享收货地址
 *
 * @see https://developers.weixin.qq.com/doc/offiaccount/OA_Web_Apps/JS-SDK.html#共享收货地址接口
 */ function openAddress(params) {
    if (params === void 0) params = {};
    return promiseToCallback(params, /*#__PURE__*/ _async_to_generator(function() {
        var res;
        return __generator(this, function(_state) {
            switch(_state.label){
                case 0:
                    return [
                        4,
                        tryEnsureConfigReady()
                    ];
                case 1:
                    _state.sent();
                    return [
                        4,
                        invoke("editAddress")
                    ];
                case 2:
                    res = _state.sent();
                    res.postalCode = res.addressPostalCode;
                    delete res.addressPostalCode;
                    res.provinceName = res.proviceFirstStageName;
                    delete res.proviceFirstStageName;
                    res.cityName = res.addressCitySecondStageName;
                    delete res.addressCitySecondStageName;
                    res.countryName = res.addressCountiesThirdStageName;
                    delete res.addressCountiesThirdStageName;
                    res.detailInfo = res.addressDetailInfo;
                    delete res.addressDetailInfo;
                    return [
                        2,
                        res
                    ];
            }
        });
    }));
}

/**
 * 打开应用评价页面
 *
 * 第三方应用可以使用该接口提供按钮，让用户快速打开应用评价页面。
 *
 * @compat WeCom iOS, Android, PC >= 4.0.2
 *
 * @limit
 * - 仅第三方应用可调用
 * - 当前用户可以进行应用评价
 * - 对成员授权的应用，当前用户需要在应用可见范围内
 * - 对管理员授权的应用，当前用户需要在应用可见范围内或具有应用管理权限
 */ function openAppComment(params) {
    if (params === void 0) params = {};
    return passthrough("openAppComment", params);
}

/**
 * 获取设备数据授权。
 *
 * 唤起设备选择列表，企业管理员选择设备后，应用可以通过云端接口获取到设备上报的数据。
 *
 * @limit
 * - 应用必须勾选了设备信息接口权限
 * - 仅第三方应用使用
 *
 * @compat WeCom >= 4.0.12
 *
 * @example
 * ```ts
 * ww.openAppDeviceDataAuth()
 * ```
 */ function openAppDeviceDataAuth(params) {
    if (params === void 0) params = {};
    return passthrough("openAppDeviceDataAuth", params);
}

/**
 * 打开应用管理页面
 *
 * 应用可以使用该接口提供按钮，让企业管理员快速打开应用的管理页面。
 *
 * @limit
 * - 当前用户必须具有应用管理权限
 *
 * @compat WeCom >= 4.0.2
 */ function openAppManage(params) {
    if (params === void 0) params = {};
    return passthrough("openAppManage", params);
}

var EnvVersion;
(function(EnvVersion) {
    EnvVersion["release"] = "release";
    EnvVersion["trial"] = "trial";
    EnvVersion["develop"] = "develop";
})(EnvVersion || (EnvVersion = {}));
/**
 * 商户小程序跳转微信支付分小程序
 *
 * @see https://pay.weixin.qq.com/wiki/doc/apiv3/payscore.php?chapter=29_3&index=3
 */ function openBusinessView(params) {
    return promiseToCallback(params, /*#__PURE__*/ _async_to_generator(function() {
        var res;
        return __generator(this, function(_state) {
            switch(_state.label){
                case 0:
                    return [
                        4,
                        tryEnsureConfigReady()
                    ];
                case 1:
                    _state.sent();
                    return [
                        4,
                        invoke("openBusinessView", {
                            businessType: params.businessType,
                            queryString: params.queryString || "",
                            envVersion: params.envVersion
                        })
                    ];
                case 2:
                    res = _state.sent();
                    if (!isAndroid || !res.extraData) {
                        return [
                            2,
                            res
                        ];
                    }
                    try {
                        res.extraData = JSON.parse(res.extraData);
                    } catch (error) {
                        res.extraData = {};
                    }
                    return [
                        2,
                        res
                    ];
            }
        });
    }));
}

/**
 * 查看设备。
 *
 * @limit
 * - 调用者必须拥有指定 deviceSn 的管理权限
 *
 * @note
 * - 若开发者需要在 web 端引导跳转设备管理，可以构造链接跳转：
 *   `https://work.weixin.qq.com/wework_admin/frame#hardware/device?sn=DEVICESN`
 *
 * @compat WeCom iOS, Android >= 2.8.2
 *
 * @example
 * ```ts
 * ww.openDeviceProfile({
 *   deviceSn: 'QYWX001'
 * })
 * ```
 */ function openDeviceProfile(params) {
    return passthrough("openDeviceProfile", params);
}

/**
 * 打开会话。
 *
 * @limit
 * - 内部群最多 2000 人，外部群最多 500 人
 * - 若创建的会话包含微信联系人，群成员人数不能超过 40 人
 *
 * @compat WeCom >= 2.0.0
 *
 * @example
 * ```ts
 * ww.openEnterpriseChat({
 *   groupName: '讨论组',
 *   userIds: [
 *     'zhangsan',
 *     'lisi'
 *   ],
 *   externalUserIds: [
 *     'wmEAlECwAAHrbWYDOK5u3Bf13xlYDAAA',
 *     'wmEAlECwAAHibWYDOK5u3Af13xlYDAAA'
 *   ]
 * })
 * ```
 */ function openEnterpriseChat(params) {
    if (params === void 0) params = {};
    return passthrough("openEnterpriseChat", params, {
        chatId: params.chatId || "",
        chatname: params.groupName || "",
        groupName: params.groupName || "",
        useridlist: joinList(params.userIds),
        userIds: joinList(params.userIds),
        openIds: joinList(params.openIds),
        externalUserIds: joinList(params.externalUserIds)
    });
}

/**
 * 打开已有群聊并发送消息
 *
 * 打开一个已有的群聊并可选发送一条链接消息。支持打开企业内部群、外部群、互联群
 *
 * @compat WeCom >= 3.1.8
 *
 * @example
 * ```ts
 * ww.openExistedChatWithMsg({
 *   chatId: 'chatId123',
 *   msg: {
 *     msgtype: 'link',
 *     link: {
 *       title: 'title1',
 *       desc: 'desc1',
 *       url: 'link1',
 *       imgUrl: 'imgurl1'
 *     }
 *   }
 * })
 * ```
 */ function openExistedChatWithMsg(params) {
    return passthrough("openExistedChatWithMsg", params);
}

/**
 * 进入应用客服会话
 *
 * 第三方应用可以使用该接口提供按钮，让用户快速打开应用客服的会话。
 *
 * @compat WeCom iOS, Android >= 3.1.18
 *
 * @limit
 * - 仅第三方应用可调用
 * - 第三方应用需要提前配置客服
 * - 当前用户需要有添加外部联系人权限
 */ function openThirdAppServiceChat(params) {
    if (params === void 0) params = {};
    return passthrough("openThirdAppServiceChat", params);
}

var OpenUserProfileType;
(function(OpenUserProfileType) {
    OpenUserProfileType[OpenUserProfileType[/**
   * 企业成员
   */ "internal"] = 1] = "internal";
    OpenUserProfileType[OpenUserProfileType[/**
   * 外部联系人
   */ "external"] = 2] = "external";
})(OpenUserProfileType || (OpenUserProfileType = {}));
/**
 * 唤起成员或外部联系人的个人信息页面。
 *
 * @compat WeCom >= 2.4.20
 *
 * @example
 * ```ts
 * ww.openUserProfile({
 *   type: 1,
 *   userid: 'zhangsan'
 * })
 * ```
 */ function openUserProfile(params) {
    return passthrough("openUserProfile", params);
}

var PrintFileIdType;
(function(PrintFileIdType) {
    PrintFileIdType[PrintFileIdType[/**
   * mediaid
   */ "mediaid"] = 1] = "mediaid";
    PrintFileIdType[PrintFileIdType[/**
   * url
   */ "url"] = 2] = "url";
    PrintFileIdType[PrintFileIdType[/**
   * localId
   */ "localId"] = 4] = "localId";
})(PrintFileIdType || (PrintFileIdType = {}));
/**
 * 发起文件打印。
 *
 * @limit
 * - 应用需要已获取设备信息 - 打印扫描设备 - 发起文件打印权限授权
 * - 当前触发调用人员身份需要在应用的可见范围内
 * - 当前企业有安装企业微信打印设备
 * - 仅第三方应用使用
 *
 * @compat WeCom >= 4.0.12
 *
 * @example
 * ```ts
 * ww.printFile({
 *   fileId: 'fileId',
 *   fileIdType: 1,
 *   fileName: 'fileName.jpg'
 * })
 * ```
 */ function printFile(params) {
    return passthrough("printFile", params);
}

var InTalkType;
(function(InTalkType) {
    InTalkType[/**
   * 当前不在任何通话中
   */ "None"] = "None";
    InTalkType[/**
   * 视频会议中
   */ "HWOpenTalk"] = "HWOpenTalk";
    InTalkType[/**
   * voip通话中
   */ "VoIP"] = "VoIP";
    InTalkType[/**
   * 系统通话中
   */ "SystemCall"] = "SystemCall";
})(InTalkType || (InTalkType = {}));
/**
 * 查询当前是否在视频会议。
 *
 * @compat WeCom >= 2.5.0
 *
 * @example
 * ```ts
 * ww.queryCurrHWOpenTalk()
 * ```
 */ function queryCurrHWOpenTalk(params) {
    if (params === void 0) params = {};
    return passthrough("queryCurrHWOpenTalk", params);
}

/**
 * 发起退款
 *
 * @limit
 * - 应用需要具有对外收款权限
 * - 发起的用户必须在应用可见范围并实名
 * - 只允许退款由应用本身发起的收款
 * - 允许第三方应用、代开发应用和自建应用调用
 *
 * @compat WeCom >= 4.0.12
 *
 * @example
 * ```ts
 * ww.refundExternalPayment({
 *   paymentId: 'xxxx',
 *   outTradeNo: 'yyyy',
 *   refundFee: 100,
 *   refundComment: '7天无理由退货'
 * })
 * ```
 */ function refundExternalPayment(params) {
    return passthrough("refundExternalPayment", params);
}

/**
 * 保存选择的选项。
 *
 * 用户在网页中进行选择时，调用该接口保存用户的选择。
 *
 * @note
 * - 接口仅用于审批设置外部选项场景，请勿用作其他场景
 * - 网页应该做好深色模式适配
 *
 * @compat WeCom >= 4.0.18
 *
 * @example
 * ```ts
 * ww.saveApprovalSelectedItems({
 *   key: 'key',
 *   selectedData: [
 *     {
 *       key: 'item-1',
 *       value: '选项1'
 *     },
 *     {
 *       key: 'item-2',
 *       value: '选项2'
 *     }
 *   ]
 * })
 * ```
 */ function saveApprovalSelectedItems(params) {
    return passthrough("saveApprovalSelectedItems", params, {
        key: params.key,
        selectedData: typeof params.selectedData === "string" ? params.selectedData : JSON.stringify(params.selectedData)
    });
}

var ScanQRCodeType;
(function(ScanQRCodeType) {
    ScanQRCodeType[/**
   * 扫描二维码
   */ "qrCode"] = "qrCode";
    ScanQRCodeType[/**
   * 扫描条形码
   */ "barCode"] = "barCode";
})(ScanQRCodeType || (ScanQRCodeType = {}));
/**
 * 调起企业微信扫一扫。
 *
 * @example
 * ```ts
 * ww.scanQRCode({
 *   needResult: true,
 *   scanType: ['qrCode']
 * })
 * ```
 */ function scanQRCode(params) {
    if (params === void 0) params = {};
    return promiseToCallback(params, /*#__PURE__*/ _async_to_generator(function() {
        var _data_scan_code, res, resultStr, data;
        return __generator(this, function(_state) {
            switch(_state.label){
                case 0:
                    return [
                        4,
                        tryEnsureConfigReady()
                    ];
                case 1:
                    _state.sent();
                    return [
                        4,
                        invoke("scanQRCode", {
                            needResult: params.needResult ? 1 : 0,
                            scanType: params.scanType || [
                                "qrCode",
                                "barCode"
                            ]
                        })
                    ];
                case 2:
                    res = _state.sent();
                    if (!isIOS) {
                        return [
                            2,
                            res
                        ];
                    }
                    resultStr = res.resultStr;
                    if (!resultStr) {
                        return [
                            2,
                            res
                        ];
                    }
                    try {
                        data = JSON.parse(resultStr);
                    } catch (error) {
                    // noop
                    }
                    res.resultStr = data == null ? void 0 : (_data_scan_code = data.scan_code) == null ? void 0 : _data_scan_code.scan_result;
                    return [
                        2,
                        res
                    ];
            }
        });
    }));
}

var InputCorpGroupContactMode;
(function(InputCorpGroupContactMode) {
    InputCorpGroupContactMode[/**
   * 单选
   */ "single"] = "single";
    InputCorpGroupContactMode[/**
   * 多选
   */ "multi"] = "multi";
})(InputCorpGroupContactMode || (InputCorpGroupContactMode = {}));
var InputCorpGroupContactType;
(function(InputCorpGroupContactType) {
    InputCorpGroupContactType["department"] = "department";
    InputCorpGroupContactType["user"] = "user";
})(InputCorpGroupContactType || (InputCorpGroupContactType = {}));
/**
 * 企业互联选人
 *
 * @limit
 * - 该接口仅可选择应用可见范围内的成员和部门
 *
 * @compat WeCom iOS, Android, PC >= 3.1.6
 *
 * @example
 * ```ts
 * ww.selectCorpGroupContact({
 *   fromDepartmentId: -1,
 *   mode: 'single',
 *   type: ['department', 'user'],
 *   selectedDepartmentIds: ['2','3'],
 *   selectedUserIds: ['lisi','lisi2'],
 *   selectedOpenUserIds: ['wabc3','wbcde'],
 *   selectedChainDepartmentIds: [
 *     {
 *       corpId: 'ww3333',
 *       departmentId: '2'
 *     },
 *     {
 *       corpId: 'ww4444',
 *       departmentId: '3'
 *     }
 *   ],
 *   selectedChainUserIds: [
 *     {
 *       corpId: 'ww3333',
 *       userId: 'userid123',
 *       openUserId: 'wx1111'
 *     },
 *     {
 *       corpId: 'ww4444',
 *       userId: 'userid123',
 *       openUserId: 'wx1111'
 *     }
 *   ],
 *   selectedCorpGroupDepartmentIds: [
 *     {
 *       corpId: 'ww3333',
 *       departmentId: '2'
 *     },
 *     {
 *       corpId: 'ww4444',
 *       departmentId: '3'
 *     }
 *   ],
 *   selectedCorpGroupUserIds: [
 *     {
 *       corpId: 'ww3333',
 *       userId: 'userid123',
 *       openUserId: 'wx1111'
 *     },
 *     {
 *       corpId: 'ww4444',
 *       userId: 'userid123',
 *       openUserId: 'wx1111'
 *     }
 *   ]
 * })
 * ```
 */ function selectCorpGroupContact(params) {
    return promiseToCallback(params, /*#__PURE__*/ _async_to_generator(function() {
        var res;
        return __generator(this, function(_state) {
            switch(_state.label){
                case 0:
                    return [
                        4,
                        tryEnsureConfigReady()
                    ];
                case 1:
                    _state.sent();
                    return [
                        4,
                        invoke("selectCorpGroupContact", params)
                    ];
                case 2:
                    res = _state.sent();
                    if (!isString(res.result)) {
                        return [
                            2,
                            res
                        ];
                    }
                    try {
                        res.result = JSON.parse(res.result);
                    } catch (error) {
                    // noop
                    }
                    return [
                        2,
                        res
                    ];
            }
        });
    }));
}

var SelectEnterpriseContactMode;
(function(SelectEnterpriseContactMode) {
    SelectEnterpriseContactMode[/**
   * 单选
   */ "single"] = "single";
    SelectEnterpriseContactMode[/**
   * 多选
   */ "multi"] = "multi";
})(SelectEnterpriseContactMode || (SelectEnterpriseContactMode = {}));
var SelectEnterpriseContactType;
(function(SelectEnterpriseContactType) {
    SelectEnterpriseContactType["department"] = "department";
    SelectEnterpriseContactType["user"] = "user";
})(SelectEnterpriseContactType || (SelectEnterpriseContactType = {}));
/**
 * 选择通讯录成员。
 *
 * @compat WeCom >= 1.3.11; WeChat iOS, Android >= 6.5.10
 *
 * @example
 * ```ts
 * ww.selectEnterpriseContact({
 *   fromDepartmentId: -1,
 *   mode: 'multi',
 *   type: ['department', 'user'],
 *   selectedDepartmentIds: ['2', '3'],
 *   selectedUserIds: ['lisi', 'lisi2']
 * })
 * ```
 */ function selectEnterpriseContact(params) {
    return promiseToCallback(params, /*#__PURE__*/ _async_to_generator(function() {
        var res;
        return __generator(this, function(_state) {
            switch(_state.label){
                case 0:
                    return [
                        4,
                        tryEnsureConfigReady()
                    ];
                case 1:
                    _state.sent();
                    return [
                        4,
                        invoke("selectEnterpriseContact", params)
                    ];
                case 2:
                    res = _state.sent();
                    if (!isString(res.result)) {
                        return [
                            2,
                            res
                        ];
                    }
                    try {
                        res.result = JSON.parse(res.result);
                    } catch (error) {
                    // noop
                    }
                    return [
                        2,
                        res
                    ];
            }
        });
    }));
}

var SelectExternalContactType;
(function(SelectExternalContactType) {
    SelectExternalContactType[SelectExternalContactType[/**
   * 展示全部外部联系人列表
   */ "all"] = 0] = "all";
    SelectExternalContactType[SelectExternalContactType[/**
   * 仅展示未曾选择过的外部联系人
   */ "unselected"] = 1] = "unselected";
})(SelectExternalContactType || (SelectExternalContactType = {}));
/**
 * 唤起该成员的外部联系人列表，并返回员工选择的外部联系人的 userId。
 *
 * @limit
 * - 当前成员必须配置了客户联系功能
 * - 第三方应用须配置客户联系功能权限
 *
 * @compat WeCom >= 2.4.20
 *
 * @example
 * ```ts
 * ww.selectExternalContact({
 *   filterType: 0
 * })
 * ```
 */ function selectExternalContact(params) {
    if (params === void 0) params = {};
    return passthrough("selectExternalContact", params);
}

var SelectPrivilegedContactMode;
(function(SelectPrivilegedContactMode) {
    SelectPrivilegedContactMode[/**
   * 单选
   */ "single"] = "single";
    SelectPrivilegedContactMode[/**
   * 多选
   */ "multi"] = "multi";
})(SelectPrivilegedContactMode || (SelectPrivilegedContactMode = {}));
/**
 * 返回 ticket 的选人接口
 *
 * 用于第三方应用唤起选择企业通讯录成员，用户选择的范围区分成两部分回传给第三方应用：
 *
 * 1. 过滤应用可见范围后的 openUserId 列表
 * 2. 用户选择完整列表的 ticket，ticket 后续可用于调用 createChatWithMsg 接口或者[发送模板消息](#94515)
 *
 * @limit
 * - 仅第三方应用（非通讯录应用）可调用
 *
 * @compat WeCom >= 3.1.8
 *
 * @example
 * ```ts
 * ww.selectPrivilegedContact({
 *   fromDepartmentId: -1,
 *   mode: 'multi',
 *   selectedContextContact: 1
 *   selectedOpenUserIds: ['xxx', 'yyy'],
 *   selectedTickets: ['ticket1', 'ticket2']
 * })
 * ```
 */ function selectPrivilegedContact(params) {
    return passthrough("selectPrivilegedContact", params);
}

/**
 * 从聊天工具栏或附件栏打开的页面中向当前会话发送消息。
 *
 * @limit
 * - 仅从特定入口进入页面才可调用
 * - 不同的入口对应用及用户有相应的限制
 *   | getContext 接口返回的 entry 值 | 自建应用 | 第三方应用 | 用户 | 支持的最低版本 |
 *   | --- | --- | --- | --- | --- |
 *   | single_chat_tools | 需有客户联系功能权限 | 需有“企业客户权限->客户基础信息”权限 | 配置了客户联系功能 | 2.8.10 |
 *   | group_chat_tools | 需有客户联系功能权限 | 需有“企业客户权限->客户基础信息”权限 | 配置了客户联系功能 | 2.8.10 |
 *   | group_chat_tools | 所有 | 需有「家校沟通」使用权限 | 所有 | 3.0.36 |
 *   | group_chat_tools | 所有 | 需有「家校沟通」使用权限 | 所有 | 4.0.8 |
 *   | chat_attachment | 所有 | 所有 | 所有 | 3.1.6（mac端暂不支持） |
 *
 * @compat WeCom >= 2.8.10
 *
 * @example
 * ```ts
 * ww.sendChatMessage({
 *   msgtype: 'text',
 *   text: {
 *     content: '你好'
 *   }
 * })
 * ```
 */ function sendChatMessage(params) {
    return passthrough("sendChatMessage", params);
}

/**
 * 设置私密消息
 *
 * @compat WeCom >= 3.1.8
 *
 * @example
 * ```ts
 * ww.setShareAttr({
 *   withShareTicket: true,
 *   state: 'STATE'
 * })
 * ```
 */ function setShareAttr(params) {
    if (params === void 0) params = {};
    return passthrough("setShareAttr", params);
}

/**
 * 具有客户联系权限的企业成员，可通过该接口将文本内容和附件传递到客户群群发、发送到客户群。
 *
 * @limit
 * - 为防止滥用，同一个成员每日向一个客户最多可群发一条消息，每次群发最多可选 200 个最近活跃的客户群
 * - 当前成员必须配置了客户联系功能
 * - 第三方应用须配置客户联系功能权限
 *
 * @compat WeCom >= 2.8.7
 *
 * @example
 * ```ts
 * ww.shareToExternalChat({
 *   text: {
 *     content: '企业微信'
 *   },
 *   attachments: [
 *     {
 *       msgtype: 'image',
 *       image: {
 *         imgUrl: 'https://res.mail.qq.com/node/ww/wwmng/style/images/index_share_logo$13c64306.png'
 *       }
 *     }
 *   ]
 * })
 * ```
 */ function shareToExternalChat(params) {
    return passthrough("shareToExternalChat", params);
}

/**
 * 具有客户联系权限的企业成员，可通过该接口将文本内容和附件传递到群发助手、发送给客户。
 *
 * @limit
 * - 为防止滥用，同一个成员每日向一个客户最多可群发一条消息，每次群发最多可选 200 个客户
 * - 当前成员必须配置了客户联系功能
 * - 第三方应用须配置客户联系功能权限
 *
 * @compat WeCom >= 2.8.7
 *
 * @example
 * ```ts
 * ww.shareToExternalContact({
 *   text: {
 *     content: '企业微信'
 *   },
 *   attachments: [
 *     {
 *       msgtype: 'image',
 *       image: {
 *         imgUrl: 'https://res.mail.qq.com/node/ww/wwmng/style/images/index_share_logo$13c64306.png'
 *       }
 *     }
 *   ]
 * })
 * ```
 */ function shareToExternalContact(params) {
    return passthrough("shareToExternalContact", params);
}

/**
 * 发表内容到客户朋友圈
 *
 * @limit
 * - 当前成员必须配置了客户联系功能
 * - 第三方应用须配置客户联系功能权限
 * - 当前成员必须在客户朋友圈使用范围
 * - 当前成员必须具备外部沟通管理成员使用权限
 *
 * @compat WeCom iOS, Android >= 3.1.12
 *
 * @example
 * ```ts
 * ww.shareToExternalMoments({
 *   text: {
 *     content: '企业微信'
 *   },
 *   attachments: [
 *     {
 *       msgtype: 'image',
 *       image: {
 *         imgUrl: 'https://res.mail.qq.com/node/ww/wwmng/style/images/index_share_logo$13c64306.png'
 *       }
 *     }
 *   ]
 * })
 * ```
 */ function shareToExternalMoments(params) {
    return passthrough("shareToExternalMoments", params);
}

/**
 * 发起无线投屏。
 *
 * @compat WeCom
 *
 * @example
 * ```ts
 * ww.startWecast()
 * ```
 */ function startWecast(params) {
    if (params === void 0) params = {};
    return passthrough("startWecast", params);
}

var OAType;
(function(OAType) {
    OAType[/**
   * 发起审批
   */ "create_approval"] = "10001";
    OAType[/**
   * 查看审批详情
   */ "view_approval"] = "10002";
})(OAType || (OAType = {}));
var OaExtDataType;
(function(OaExtDataType) {
    OaExtDataType[/**
   * 链接
   */ "link"] = "link";
    OaExtDataType[/**
   * 文本
   */ "text"] = "text";
})(OaExtDataType || (OaExtDataType = {}));
/**
 * 应用发起审批。
 *
 * 在应用页面中发起审批。之后审批流程的每次状态变化都会通知开发者，开发者可按需进行拓展开发。具体参见[审批流程引擎](#93798)。
 *
 * @limit
 * - 应用需具有审批权限
 *
 * @compat WeCom >= 2.5.0
 *
 * @example
 * ```ts
 * ww.thirdPartyOpenPage({
 *   oaType: '10001',
 *   templateId: '46af67a118a6ebf000002',
 *   thirdNo: 'thirdNo',
 *   extData: {
 *     fieldList: [
 *       {
 *         type: 'text',
 *         title: '采购类型',
 *         value: '市场活动'
 *       },
 *       {
 *         type: 'link',
 *         title: '订单链接',
 *         value: 'https://work.weixin.qq.com'
 *       }
 *     ]
 *   }
 * })
 * ```
 */ function thirdPartyOpenPage(params) {
    return passthrough("thirdPartyOpenPage", params);
}

/**
 * 变更企业互联群成员
 *
 * @limit
 * - 当前成员必须在应用的可见范围
 * - 仅支持往群里添加企业内部成员/企业互联成员
 * - 仅局校互联企业可调用
 *
 * @compat WeCom >= 3.1.8
 *
 * @example
 * ```ts
 * ww.updateCorpGroupChat({
 *   chatId: 'CHATID',
 *   userIdsToAdd: ['lisi', 'lisi2'],
 *   openUserIdsToAdd: ['wabc3', 'wbcde'],
 *   corpGroupUserIdsToAdd: [
 *     {
 *       corpId: 'ww3333',
 *       userId: 'userid123',
 *       openUserId: 'wx1111'
 *     },
 *     {
 *       corpId: 'ww4444',
 *       userId: 'userid123',
 *       openUserId: 'wx1111'
 *     }
 *   ]
 * })
 * ```
 */ function updateCorpGroupChat(params) {
    return passthrough("updateCorpGroupChat", params);
}

/**
 * 变更群成员。
 *
 * @limit
 * - 目前仅支持添加企业内成员
 * - 仅支持客户群调用
 *
 * @compat WeCom iOS, Android, PC >= 3.0.36
 *
 * @example
 * ```ts
 * ww.updateEnterpriseChat({
 *   chatId: 'CHATID',
 *   userIdsToAdd: [
 *     'zhangsan',
 *     'lisi'
 *   ]
 * })
 * ```
 */ function updateEnterpriseChat(params) {
    return passthrough("updateEnterpriseChat", params, {
        chatId: params.chatId,
        userIdsToAdd: joinList(params.userIdsToAdd)
    });
}

/**
 * 设置朋友圈封面与签名
 *
 * @compat WeCom iOS, Android >= 3.1.12
 *
 * @example
 * ```ts
 * ww.updateMomentSetting({
 *   signature: '个性签名',
 *   imgUrl: 'https://work.weixin.qq.com/'
 * })
 * ```
 */ function updateMomentsSetting(params) {
    return passthrough("updateMomentsSetting", params);
}

/**
 * **注意：页面上需要提前引入 `jwxwork-1.0.0.js`：**
 *
 * ```html
 * <script src="https://open.work.weixin.qq.com/wwopen/js/jwxwork-1.0.0.js" referrerpolicy="origin"></script>
 * ```
 *
 * 初始化[通讯录展示组件](#91958)。
 *
 * 在该接口返回成功后，可以直接调用通讯录展示组件的相关方法。
 *
 * @example
 * ```ts
 * ww.initOpenData()
 * ```
 */ function initOpenData(params) {
    if (params === void 0) params = {};
    return promiseToCallback(params, /*#__PURE__*/ _async_to_generator(function() {
        var result;
        return __generator(this, function(_state) {
            switch(_state.label){
                case 0:
                    if (!isWeCom) {
                        return [
                            2,
                            invokeOpenDataAgentConfig()
                        ];
                    }
                    return [
                        4,
                        ensureAgentConfigReady()
                    ];
                case 1:
                    result = _state.sent().result;
                    if (!isWindows && !(win == null ? void 0 : win.WeixinSandBox)) {
                        throw new SDKError("Missing WeixinSandBox");
                    }
                    if (!!(win == null ? void 0 : win.WWOpenData)) return [
                        3,
                        3
                    ];
                    return [
                        4,
                        invoke("wwapp.initWwOpenData")
                    ];
                case 2:
                    _state.sent();
                    _state.label = 3;
                case 3:
                    if (!(win == null ? void 0 : win.WWOpenData)) {
                        throw new SDKError("Init WWOpenData failed");
                    }
                    if (win.WWOpenData.initJSSDK) {
                        win.WWOpenData.initJSSDK({
                            invoke: invoke,
                            ensureAgentConfigReady: ensureAgentConfigReady
                        });
                    }
                    return [
                        2,
                        result
                    ];
            }
        });
    }));
}
function invokeOpenDataAgentConfig() {
    return _invokeOpenDataAgentConfig.apply(this, arguments);
}
function _invokeOpenDataAgentConfig() {
    _invokeOpenDataAgentConfig = _async_to_generator(function() {
        var _win_WWOpenData, params;
        return __generator(this, function(_state) {
            switch(_state.label){
                case 0:
                    if (!(win == null ? void 0 : (_win_WWOpenData = win.WWOpenData) == null ? void 0 : _win_WWOpenData.agentConfig)) {
                        throw new SDKError("Missing WWOpenData.agentConfig");
                    }
                    return [
                        4,
                        resolveAgentConfigParams(getSignURL())
                    ];
                case 1:
                    params = _state.sent();
                    return [
                        2,
                        new Promise(function(success, fail) {
                            win.WWOpenData.agentConfig(_extends({}, params, {
                                success: success,
                                fail: fail
                            }));
                        })
                    ];
            }
        });
    });
    return _invokeOpenDataAgentConfig.apply(this, arguments);
}

function createTransparentIFrame(width, height, el) {
    var iframeEl = document.createElement("iframe");
    var style = iframeEl.style;
    style.display = "block";
    style.border = "none";
    style.background = "transparent";
    style.width = width;
    style.height = height;
    iframeEl.referrerPolicy = "origin";
    iframeEl.setAttribute("frameborder", "0");
    iframeEl.setAttribute("allowtransparency", "true");
    var containerEl = resolveEl(el);
    if (containerEl) {
        containerEl.appendChild(iframeEl);
    }
    return iframeEl;
}
function resolveEl(el) {
    if (typeof el === "string") {
        return document.querySelector(el);
    }
    return el;
}

function genUid() {
    var rand = Math.random().toString(36).slice(2);
    return Date.now().toString(36) + "." + rand;
}
function normalizeError(error) {
    if (!error || typeof error !== "object") {
        return error;
    }
    return _extends({}, error, {
        message: error.message,
        stack: error.stack
    });
}

function useRemoteInvoke(postMessage, callback) {
    var invoke = function invoke(args) {
        return new Promise(function(resolve, reject) {
            var uid = genUid();
            messageMap.set(uid, {
                resolve: resolve,
                reject: reject
            });
            postMessage({
                type: "ww-iframe-handle:call",
                uid: uid,
                args: args
            });
        });
    };
    var handleResponseMessage = function handleResponseMessage(msg) {
        var handle = messageMap.get(msg.uid);
        if (!handle) {
            return;
        }
        handle[msg.kind](msg.args);
        messageMap.delete(msg.uid);
    };
    var messageMap = new Map();
    function handleCallMessage(msg) {
        return _handleCallMessage.apply(this, arguments);
    }
    function _handleCallMessage() {
        _handleCallMessage = _async_to_generator(function(msg) {
            var _tmp, error;
            return __generator(this, function(_state) {
                switch(_state.label){
                    case 0:
                        _state.trys.push([
                            0,
                            2,
                            ,
                            3
                        ]);
                        _tmp = {
                            type: "ww-iframe-handle:response",
                            uid: msg.uid,
                            kind: "resolve"
                        };
                        return [
                            4,
                            callback(msg.args)
                        ];
                    case 1:
                        postMessage.apply(void 0, [
                            (_tmp.args = _state.sent(), _tmp)
                        ]);
                        return [
                            3,
                            3
                        ];
                    case 2:
                        error = _state.sent();
                        postMessage({
                            type: "ww-iframe-handle:response",
                            uid: msg.uid,
                            kind: "reject",
                            args: normalizeError(error)
                        });
                        throw error;
                    case 3:
                        return [
                            2
                        ];
                }
            });
        });
        return _handleCallMessage.apply(this, arguments);
    }
    return {
        invoke: invoke,
        handleCallMessage: handleCallMessage,
        handleResponseMessage: handleResponseMessage
    };
}

var attached = false;
var listeners = [];
function sendRemoteMessage(target, message, origin) {
    var data = typeof message === "string" ? message : JSON.stringify(message);
    target == null ? void 0 : target.postMessage(data, origin);
}
function useRemoteMessage(listener) {
    if (!attached) {
        attached = true;
        window.addEventListener("message", onWindowMessage);
    }
    listeners.push(listener);
    return function() {
        var index = listeners.indexOf(listener);
        if (index >= 0) {
            listeners.splice(index, 1);
        }
    };
}
function onWindowMessage(event) {
    try {
        var msg = JSON.parse(event.data);
        if (!msg.type.startsWith("ww-iframe-handle:")) {
            return;
        }
        for(var _iterator = _create_for_of_iterator_helper_loose(listeners.slice()), _step; !(_step = _iterator()).done;){
            var listener = _step.value;
            listener(msg, event);
        }
    } catch (error) {
    // noop
    }
}

function useIframeClient(iframeEl, origin, callback) {
    var onIframeLoad = function onIframeLoad() {
        if (iframeReady) {
            return;
        }
        postMessage({
            type: "ww-iframe-handle:init"
        });
    };
    var handleReadyMessage = function handleReadyMessage() {
        if (iframeReady) {
            return;
        }
        iframeReady = true;
        for(var _iterator = _create_for_of_iterator_helper_loose(messageQueue), _step; !(_step = _iterator()).done;){
            var message = _step.value;
            postMessage(message);
        }
    };
    var enqueueMessage = function enqueueMessage(message) {
        var data = JSON.stringify(message);
        if (!iframeReady) {
            messageQueue.push(data);
        } else {
            postMessage(data);
        }
    };
    var postMessage = function postMessage(message) {
        sendRemoteMessage(iframeEl.contentWindow, message, origin);
    };
    var _useRemoteInvoke = useRemoteInvoke(enqueueMessage, callback), invoke = _useRemoteInvoke.invoke, handleCallMessage = _useRemoteInvoke.handleCallMessage, handleResponseMessage = _useRemoteInvoke.handleResponseMessage;
    var messageQueue = [];
    var iframeReady = false;
    var dispose = useRemoteMessage(function(msg, event) {
        if (event.origin !== origin || iframeEl.contentWindow !== event.source) {
            return;
        }
        switch(msg.type){
            case "ww-iframe-handle:ready":
                return handleReadyMessage();
            case "ww-iframe-handle:call":
                return handleCallMessage(msg);
            case "ww-iframe-handle:response":
                return handleResponseMessage(msg);
        }
    });
    iframeEl.addEventListener("load", onIframeLoad);
    return {
        el: iframeEl,
        invoke: invoke,
        dispose: dispose
    };
}

function resolveSuiteConfigParams(url) {
    return _resolveSuiteConfigParams.apply(this, arguments);
}
function _resolveSuiteConfigParams() {
    _resolveSuiteConfigParams = _async_to_generator(function(url) {
        var registerOptions, data;
        return __generator(this, function(_state) {
            switch(_state.label){
                case 0:
                    registerOptions = getRegisterOptions();
                    if (!(registerOptions == null ? void 0 : registerOptions.getSuiteConfigSignature)) {
                        throw new SDKError("Missing getSuiteConfigSignature");
                    }
                    return [
                        4,
                        registerOptions.getSuiteConfigSignature(url)
                    ];
                case 1:
                    data = _state.sent();
                    return [
                        2,
                        {
                            suiteid: registerOptions.suiteId,
                            timestamp: "" + data.timestamp,
                            nonceStr: data.nonceStr,
                            signature: data.signature,
                            jsApiList: mapJsApiListToClient(registerOptions.jsApiList || [
                                "agentConfig"
                            ])
                        }
                    ];
            }
        });
    });
    return _resolveSuiteConfigParams.apply(this, arguments);
}

function has(obj, key) {
    return Object.prototype.hasOwnProperty.call(obj, key);
}

function handleCallMsg(msg, options) {
    safeRun(options[msg.name], msg.payload || msg.data);
}

var disposeModalFrame;
function showModalFrame(url, callback) {
    var handleCloseMsg = function handleCloseMsg() {
        var _iframeEl_parentNode;
        client.dispose();
        (_iframeEl_parentNode = iframeEl.parentNode) == null ? void 0 : _iframeEl_parentNode.removeChild(iframeEl);
    };
    disposeModalFrame == null ? void 0 : disposeModalFrame();
    var iframeEl = createTransparentIFrame("100vw", "100vh", document.body);
    var style = iframeEl.style;
    style.position = "fixed";
    style.left = "0";
    style.top = "0";
    style.zIndex = "1000";
    iframeEl.classList.add("wecom-jssdk-modal");
    iframeEl.setAttribute("src", url);
    var origin = new URL(url).origin;
    var client = useIframeClient(iframeEl, origin, function(msg) {
        if (msg.type === "close") {
            handleCloseMsg();
        }
        return callback == null ? void 0 : callback(msg);
    });
    disposeModalFrame = handleCloseMsg;
    return client;
}

/**
 * 创建 JSAPI 触发面板
 *
 * 在非企业微信内置浏览器环境下，开发者可以创建 JSAPI 触发面板。当用户点击面板时，内置的 iframe 将调起用户本地的企业微信客户端并调用指定的 JSAPI
 *
 * @param name 要调用的 JSAPI 名称
 *
 * @limit
 * - 应用必须经过 SSO 登录获取 web_token
 * - 用户必须登录了企业微信桌面端且当前用户身份和页面身份一致
 */ function createJSAPIPanel(name, options) {
    var handleGetStaticOptionsMsg = function handleGetStaticOptionsMsg() {
        return {
            name: name,
            options: _extends({}, options, {
                el: undefined,
                params: undefined
            })
        };
    };
    var handleJsapiCallbackMsg = function handleJsapiCallbackMsg(msg) {
        if (!jsapiParamsMap.has(msg.seq)) {
            return;
        }
        var jsapiParams = jsapiParamsMap.get(msg.seq);
        jsapiParamsMap.delete(msg.seq);
        if (msg.kind === "success") {
            safeRun(jsapiParams == null ? void 0 : jsapiParams.success, msg.payload);
        } else {
            safeRun(jsapiParams == null ? void 0 : jsapiParams.fail, msg.payload);
        }
        safeRun(jsapiParams == null ? void 0 : jsapiParams.complete, msg.payload);
    };
    var handleOpenModalFrameMsg = function handleOpenModalFrameMsg(msg) {
        showModalFrame(msg.payload.url);
    };
    var iframeEl = createTransparentIFrame("100%", "100%", options.el);
    var jsapiParamsMap = new Map();
    var dispose = useIframeClient(iframeEl, "https://login.work.weixin.qq.com", function(msg) {
        switch(msg.type){
            case "getStaticOptions":
                return handleGetStaticOptionsMsg();
            case "getJSAPIParams":
                return handleGetJSAPIParams(msg);
            case "openModalFrame":
                return handleOpenModalFrameMsg(msg);
            case "jsapiCallback":
                return handleJsapiCallbackMsg(msg);
            case "call":
                return handleCallMsg(msg, options);
        }
    }).dispose;
    function handleGetJSAPIParams(msg) {
        return _handleGetJSAPIParams.apply(this, arguments);
    }
    function _handleGetJSAPIParams() {
        _handleGetJSAPIParams = _async_to_generator(function(msg) {
            var _msg_payload, _msg_payload1, jsapiParams, _tmp, signUrl, _tmp1, _tmp2;
            return __generator(this, function(_state) {
                switch(_state.label){
                    case 0:
                        if (!isFunction(options.params)) return [
                            3,
                            2
                        ];
                        return [
                            4,
                            options.params()
                        ];
                    case 1:
                        _tmp = _state.sent();
                        return [
                            3,
                            3
                        ];
                    case 2:
                        _tmp = options.params;
                        _state.label = 3;
                    case 3:
                        jsapiParams = _tmp;
                        signUrl = getSignURL();
                        jsapiParamsMap.set(msg.seq, jsapiParams);
                        _tmp1 = {
                            webToken: options.webToken,
                            url: signUrl
                        };
                        if (!((_msg_payload = msg.payload) == null ? void 0 : _msg_payload.skipSignature)) return [
                            3,
                            4
                        ];
                        _tmp2 = undefined;
                        return [
                            3,
                            6
                        ];
                    case 4:
                        return [
                            4,
                            resolveSignatureData(signUrl, ((_msg_payload1 = msg.payload) == null ? void 0 : _msg_payload1.preferSignatureTypeList) || [
                                "agentConfig"
                            ])
                        ];
                    case 5:
                        _tmp2 = _state.sent();
                        _state.label = 6;
                    case 6:
                        return [
                            2,
                            (_tmp1.configParams = _tmp2, _tmp1.jsapi = name, _tmp1.jsapiParams = jsapiParams, _tmp1)
                        ];
                }
            });
        });
        return _handleGetJSAPIParams.apply(this, arguments);
    }
    iframeEl.style.opacity = "0";
    iframeEl.src = "https://login.work.weixin.qq.com/wwopen/ww-jsapi-transparent-frame";
    return {
        /**
     * JSAPI 触发面板的 iframe 元素
     */ el: iframeEl,
        /**
     * 卸载 JSAPI 触发面板
     */ unmount: function unmount() {
            var _iframeEl_parentNode;
            dispose();
            (_iframeEl_parentNode = iframeEl.parentNode) == null ? void 0 : _iframeEl_parentNode.removeChild(iframeEl);
        }
    };
}
var resolveSignatureFnMap = {
    agentConfig: resolveAgentConfigParams,
    suiteConfig: resolveSuiteConfigParams
};
function resolveSignatureData(url, typeList) {
    return _resolveSignatureData.apply(this, arguments);
}
function _resolveSignatureData() {
    _resolveSignatureData = _async_to_generator(function(url, typeList) {
        var lastError, _iterator, _step, type, _tmp, error;
        return __generator(this, function(_state) {
            switch(_state.label){
                case 0:
                    lastError = new Error("Missing signature handler");
                    _iterator = _create_for_of_iterator_helper_loose(typeList);
                    _state.label = 1;
                case 1:
                    if (!!(_step = _iterator()).done) return [
                        3,
                        6
                    ];
                    type = _step.value;
                    _state.label = 2;
                case 2:
                    _state.trys.push([
                        2,
                        4,
                        ,
                        5
                    ]);
                    if (!has(resolveSignatureFnMap, type)) {
                        return [
                            3,
                            5
                        ];
                    }
                    _tmp = {
                        type: type
                    };
                    return [
                        4,
                        resolveSignatureFnMap[type](url)
                    ];
                case 3:
                    return [
                        2,
                        (_tmp.params = _state.sent(), _tmp)
                    ];
                case 4:
                    error = _state.sent();
                    lastError = error;
                    return [
                        3,
                        5
                    ];
                case 5:
                    return [
                        3,
                        1
                    ];
                case 6:
                    throw lastError;
            }
        });
    });
    return _resolveSignatureData.apply(this, arguments);
}

/**
 * 显示确认安全网关配置页面。
 *
 * 在桌面端页面以 iframe 弹窗的形式覆盖在页面上；在移动端页面将跳转至确认页面，返回后页面需要主动确认 confirm_id 的确认情况。
 */ function showSecurityGatewayConfirmModal(options) {
    var url = new URL("https://open.work.weixin.qq.com/wwopen/secureGateway/confirm");
    url.searchParams.set("confirm_id", options.confirmId);
    if (isIOS || isAndroid) {
        location.href = url.href;
        return;
    }
    url.searchParams.set("modal", "true");
    var client = showModalFrame(url.href, function(msg) {
        switch(msg.type){
            case "call":
                return handleCallMsg(msg, options);
            case "close":
                return;
            default:
                throw new Error("Unknown message type '" + msg.type + "'");
        }
    });
    return {
        /**
     * 弹窗面板的 iframe 元素
     */ el: client.el,
        /**
     * 卸载弹窗面板
     */ unmount: function unmount() {
            var _client_el_parentNode;
            client.dispose();
            (_client_el_parentNode = client.el.parentNode) == null ? void 0 : _client_el_parentNode.removeChild(client.el);
        }
    };
}

var SDK_VERSION = "1.4.5";

var WWLoginType;
(function(WWLoginType) {
    WWLoginType[/**
   * [第三方应用登录](#45846)
   */ "serviceApp"] = "ServiceApp";
    WWLoginType[/**
   * [企业自建应用登录](/document/path/98151)、[服务商代开发应用登录](/document/path/98173)
   */ "corpApp"] = "CorpApp";
})(WWLoginType || (WWLoginType = {}));
var WWLoginLangType;
(function(WWLoginLangType) {
    WWLoginLangType[/**
   * 中文
   */ "zh"] = "zh";
    WWLoginLangType[/**
   * 英文
   */ "en"] = "en";
})(WWLoginLangType || (WWLoginLangType = {}));
var WWLoginRedirectType;
(function(WWLoginRedirectType) {
    WWLoginRedirectType[/**
   * 默认 `top window` 顶层页面跳转
   */ "top"] = "top";
    WWLoginRedirectType[/**
   * 通过 `onLoginSuccess` 回调用户授权 `code`，开发者自行处理跳转
   */ "callback"] = "callback";
    WWLoginRedirectType[/**
   * 登录组件跳转
   */ "self"] = "self";
})(WWLoginRedirectType || (WWLoginRedirectType = {}));
var WWLoginPanelSizeType;
(function(WWLoginPanelSizeType) {
    WWLoginPanelSizeType[/**
   * 默认: 480x416px
   */ "middle"] = "middle";
    WWLoginPanelSizeType[/**
   * 小尺寸: 320x380px
   */ "small"] = "small";
})(WWLoginPanelSizeType || (WWLoginPanelSizeType = {}));

var _obj;
var PANEL_SIZE = (_obj = {}, _obj[WWLoginPanelSizeType.middle] = [
    "480px",
    "416px"
], _obj[WWLoginPanelSizeType.small] = [
    "320px",
    "380px"
], _obj);
/**
 * 初始化企业微信Web登录组件，创建登录面板。
 *
 * @example
 * ```ts
 * // 初始化
 * const wwLogin = ww.createWWLoginPanel({
 *   el: '#ww_login',
 *   params: {
 *     login_type: 'CorpApp',
 *     appid: 'wwbbb6a7b539f2xxxxx',
 *     agentid: '10000xx',
 *     redirect_uri: 'https://work.weixin.qq.com',
 *     state: 'loginState',
 *     redirect_type: 'callback',
 *   },
 *   onCheckWeComLogin({ isWeComLogin }) {
 *     console.log(isWeComLogin)
 *   },
 *   onLoginSuccess({ code }) {
 *     console.log({ code })
 *   },
 *   onLoginFail(err) {
 *     console.log(err)
 *   },
 * })
 *
 * // 卸载
 * wwLogin.unmount()
 * ```
 */ function createWWLoginPanel(options) {
    var _options_params;
    var _getPanelSize = getPanelSize((_options_params = options.params) == null ? void 0 : _options_params.panel_size), width = _getPanelSize.width, height = _getPanelSize.height;
    var iframeEl = createTransparentIFrame(width, height, options.el);
    var dispose = useIframeClient(iframeEl, "https://login.work.weixin.qq.com", function(msg) {
        if (msg.type === "call") {
            return handleCallMsg(msg, options);
        }
        throw new Error("Unknown message type '" + msg.type + "'");
    }).dispose;
    var url = new URL("https://login.work.weixin.qq.com/wwlogin/sso/login");
    for(var _iterator = _create_for_of_iterator_helper_loose(Object.keys(options.params || {})), _step; !(_step = _iterator()).done;){
        var key = _step.value;
        url.searchParams.set(key, options.params[key]);
    }
    url.searchParams.set("version", SDK_VERSION);
    iframeEl.src = url.href;
    return {
        el: iframeEl,
        unmount: function unmount() {
            var _iframeEl_parentNode;
            dispose();
            (_iframeEl_parentNode = iframeEl.parentNode) == null ? void 0 : _iframeEl_parentNode.removeChild(iframeEl);
        }
    };
}
function getPanelSize(panelSizeType) {
    if (panelSizeType === void 0) panelSizeType = WWLoginPanelSizeType.middle;
    var size = PANEL_SIZE[panelSizeType] || PANEL_SIZE[WWLoginPanelSizeType.middle];
    return {
        width: size[0],
        height: size[1]
    };
}

/**
 * From https://gist.github.com/schacon/12703
 */ function hex_sha1(s) {
    return rstr2hex(rstr_sha1(s));
}
/**
 * Calculate the SHA1 of a raw string
 */ function rstr_sha1(s) {
    return binb2rstr(binb_sha1(rstr2binb(s), s.length * 8));
}
/**
 * Convert a raw string to a hex string
 */ function rstr2hex(input) {
    var hex_tab = "0123456789abcdef";
    var output = "";
    var x;
    for(var i = 0; i < input.length; i++){
        x = input.charCodeAt(i);
        output += hex_tab.charAt(x >>> 4 & 0x0f) + hex_tab.charAt(x & 0x0f);
    }
    return output;
}
/**
 * Convert a raw string to an array of big-endian words
 * Characters >255 have their high-byte silently ignored.
 */ function rstr2binb(input) {
    var output = new Array(input.length >> 2);
    for(var i = 0; i < output.length; i++)output[i] = 0;
    for(var i1 = 0; i1 < input.length * 8; i1 += 8)output[i1 >> 5] |= (input.charCodeAt(i1 / 8) & 0xff) << 24 - i1 % 32;
    return output;
}
/**
 * Convert an array of little-endian words to a string
 */ function binb2rstr(input) {
    var output = "";
    for(var i = 0; i < input.length * 32; i += 8)output += String.fromCharCode(input[i >> 5] >>> 24 - i % 32 & 0xff);
    return output;
}
/**
 * Calculate the SHA-1 of an array of big-endian words, and a bit length
 */ function binb_sha1(x, len) {
    /* append padding */ x[len >> 5] |= 0x80 << 24 - len % 32;
    x[(len + 64 >> 9 << 4) + 15] = len;
    var w = new Array(80);
    var a = 1732584193;
    var b = -271733879;
    var c = -1732584194;
    var d = 271733878;
    var e = -1009589776;
    for(var i = 0; i < x.length; i += 16){
        var olda = a;
        var oldb = b;
        var oldc = c;
        var oldd = d;
        var olde = e;
        for(var j = 0; j < 80; j++){
            if (j < 16) w[j] = x[i + j];
            else w[j] = bit_rol(w[j - 3] ^ w[j - 8] ^ w[j - 14] ^ w[j - 16], 1);
            var t = safe_add(safe_add(bit_rol(a, 5), sha1_ft(j, b, c, d)), safe_add(safe_add(e, w[j]), sha1_kt(j)));
            e = d;
            d = c;
            c = bit_rol(b, 30);
            b = a;
            a = t;
        }
        a = safe_add(a, olda);
        b = safe_add(b, oldb);
        c = safe_add(c, oldc);
        d = safe_add(d, oldd);
        e = safe_add(e, olde);
    }
    return [
        a,
        b,
        c,
        d,
        e
    ];
}
/**
 * Perform the appropriate triplet combination function for the current
 * iteration
 */ function sha1_ft(t, b, c, d) {
    if (t < 20) return b & c | ~b & d;
    if (t < 40) return b ^ c ^ d;
    if (t < 60) return b & c | b & d | c & d;
    return b ^ c ^ d;
}
/**
 * Determine the appropriate additive constant for the current iteration
 */ function sha1_kt(t) {
    return t < 20 ? 1518500249 : t < 40 ? 1859775393 : t < 60 ? -1894007588 : -899497514;
}
/**
 * Add integers, wrapping at 2^32. This uses 16-bit operations internally
 * to work around bugs in some JS interpreters.
 */ function safe_add(x, y) {
    var lsw = (x & 0xffff) + (y & 0xffff);
    var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
    return msw << 16 | lsw & 0xffff;
}
/**
 * Bitwise rotate a 32-bit number to the left.
 */ function bit_rol(num, cnt) {
    return num << cnt | num >>> 32 - cnt;
}

function getSignature(options) {
    var normalized = options;
    if (typeof options === "string") {
        normalized = {
            ticket: options
        };
    }
    var nonceStr = normalized.nonceStr || Math.random().toString(36).slice(2);
    var timestamp = normalized.timestamp || Math.floor(Date.now() / 1000);
    var url = normalized.url || getHref().split("#")[0];
    var ticket = normalized.ticket;
    var signature = hex_sha1("jsapi_ticket=" + ticket + "&noncestr=" + nonceStr + "&timestamp=" + timestamp + "&url=" + url);
    return {
        timestamp: timestamp,
        nonceStr: nonceStr,
        signature: signature
    };
}

var env = {
    isWeChat: isWeChat,
    isWeCom: isWeCom
};
var IS_WECOM_SDK = true;



/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__("b639").Buffer))

/***/ }),

/***/ "aa1f":
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var DESCRIPTORS = __webpack_require__("83ab");
var fails = __webpack_require__("d039");
var anObject = __webpack_require__("825a");
var normalizeStringArgument = __webpack_require__("e391");

var nativeErrorToString = Error.prototype.toString;

var INCORRECT_TO_STRING = fails(function () {
  if (DESCRIPTORS) {
    // Chrome 32- incorrectly call accessor
    // eslint-disable-next-line es/no-object-create, es/no-object-defineproperty -- safe
    var object = Object.create(Object.defineProperty({}, 'name', { get: function () {
      return this === object;
    } }));
    if (nativeErrorToString.call(object) !== 'true') return true;
  }
  // FF10- does not properly handle non-strings
  return nativeErrorToString.call({ message: 1, name: 2 }) !== '2: 1'
    // IE8 does not properly handle defaults
    || nativeErrorToString.call({}) !== 'Error';
});

module.exports = INCORRECT_TO_STRING ? function toString() {
  var O = anObject(this);
  var name = normalizeStringArgument(O.name, 'Error');
  var message = normalizeStringArgument(O.message);
  return !name ? message : !message ? name : name + ': ' + message;
} : nativeErrorToString;


/***/ }),

/***/ "b6b6":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/**
 * Check if `obj` is an object.
 *
 * @param {Object} obj
 * @return {Boolean}
 * @api private
 */
var _typeof = __webpack_require__("7037").default;
function isObject(obj) {
  return null !== obj && 'object' === _typeof(obj);
}
module.exports = isObject;

/***/ }),

/***/ "b7ef":
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var $ = __webpack_require__("23e7");
var globalThis = __webpack_require__("cfe9");
var getBuiltIn = __webpack_require__("d066");
var createPropertyDescriptor = __webpack_require__("5c6c");
var defineProperty = __webpack_require__("9bf2").f;
var hasOwn = __webpack_require__("1a2d");
var anInstance = __webpack_require__("19aa");
var inheritIfRequired = __webpack_require__("7156");
var normalizeStringArgument = __webpack_require__("e391");
var DOMExceptionConstants = __webpack_require__("cf98");
var clearErrorStack = __webpack_require__("0d26");
var DESCRIPTORS = __webpack_require__("83ab");
var IS_PURE = __webpack_require__("c430");

var DOM_EXCEPTION = 'DOMException';
var Error = getBuiltIn('Error');
var NativeDOMException = getBuiltIn(DOM_EXCEPTION);

var $DOMException = function DOMException() {
  anInstance(this, DOMExceptionPrototype);
  var argumentsLength = arguments.length;
  var message = normalizeStringArgument(argumentsLength < 1 ? undefined : arguments[0]);
  var name = normalizeStringArgument(argumentsLength < 2 ? undefined : arguments[1], 'Error');
  var that = new NativeDOMException(message, name);
  var error = new Error(message);
  error.name = DOM_EXCEPTION;
  defineProperty(that, 'stack', createPropertyDescriptor(1, clearErrorStack(error.stack, 1)));
  inheritIfRequired(that, this, $DOMException);
  return that;
};

var DOMExceptionPrototype = $DOMException.prototype = NativeDOMException.prototype;

var ERROR_HAS_STACK = 'stack' in new Error(DOM_EXCEPTION);
var DOM_EXCEPTION_HAS_STACK = 'stack' in new NativeDOMException(1, 2);

// eslint-disable-next-line es/no-object-getownpropertydescriptor -- safe
var descriptor = NativeDOMException && DESCRIPTORS && Object.getOwnPropertyDescriptor(globalThis, DOM_EXCEPTION);

// Bun ~ 0.1.1 DOMException have incorrect descriptor and we can't redefine it
// https://github.com/Jarred-Sumner/bun/issues/399
var BUGGY_DESCRIPTOR = !!descriptor && !(descriptor.writable && descriptor.configurable);

var FORCED_CONSTRUCTOR = ERROR_HAS_STACK && !BUGGY_DESCRIPTOR && !DOM_EXCEPTION_HAS_STACK;

// `DOMException` constructor patch for `.stack` where it's required
// https://webidl.spec.whatwg.org/#es-DOMException-specialness
$({ global: true, constructor: true, forced: IS_PURE || FORCED_CONSTRUCTOR }, { // TODO: fix export logic
  DOMException: FORCED_CONSTRUCTOR ? $DOMException : NativeDOMException
});

var PolyfilledDOMException = getBuiltIn(DOM_EXCEPTION);
var PolyfilledDOMExceptionPrototype = PolyfilledDOMException.prototype;

if (PolyfilledDOMExceptionPrototype.constructor !== PolyfilledDOMException) {
  if (!IS_PURE) {
    defineProperty(PolyfilledDOMExceptionPrototype, 'constructor', createPropertyDescriptor(1, PolyfilledDOMException));
  }

  for (var key in DOMExceptionConstants) if (hasOwn(DOMExceptionConstants, key)) {
    var constant = DOMExceptionConstants[key];
    var constantName = constant.s;
    if (!hasOwn(PolyfilledDOMException, constantName)) {
      defineProperty(PolyfilledDOMException, constantName, createPropertyDescriptor(6, constant.c));
    }
  }
}


/***/ }),

/***/ "b917":
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var commonAlphabet = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
var base64Alphabet = commonAlphabet + '+/';
var base64UrlAlphabet = commonAlphabet + '-_';

var inverse = function (characters) {
  // TODO: use `Object.create(null)` in `core-js@4`
  var result = {};
  var index = 0;
  for (; index < 64; index++) result[characters.charAt(index)] = index;
  return result;
};

module.exports = {
  i2c: base64Alphabet,
  c2i: inverse(base64Alphabet),
  i2cUrl: base64UrlAlphabet,
  c2iUrl: inverse(base64UrlAlphabet)
};


/***/ }),

/***/ "c607":
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var DESCRIPTORS = __webpack_require__("83ab");
var UNSUPPORTED_DOT_ALL = __webpack_require__("fce3");
var classof = __webpack_require__("c6b6");
var defineBuiltInAccessor = __webpack_require__("edd0");
var getInternalState = __webpack_require__("69f3").get;

var RegExpPrototype = RegExp.prototype;
var $TypeError = TypeError;

// `RegExp.prototype.dotAll` getter
// https://tc39.es/ecma262/#sec-get-regexp.prototype.dotall
if (DESCRIPTORS && UNSUPPORTED_DOT_ALL) {
  defineBuiltInAccessor(RegExpPrototype, 'dotAll', {
    configurable: true,
    get: function dotAll() {
      if (this === RegExpPrototype) return;
      // We can't use InternalStateModule.getterFor because
      // we don't add metadata for regexps created by a literal.
      if (classof(this) === 'RegExp') {
        return !!getInternalState(this).dotAll;
      }
      throw new $TypeError('Incompatible receiver, RegExp required');
    }
  });
}


/***/ }),

/***/ "c8d2":
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var PROPER_FUNCTION_NAME = __webpack_require__("5e77").PROPER;
var fails = __webpack_require__("d039");
var whitespaces = __webpack_require__("5899");

var non = '\u200B\u0085\u180E';

// check that a method works with the correct list
// of whitespaces and has a correct name
module.exports = function (METHOD_NAME) {
  return fails(function () {
    return !!whitespaces[METHOD_NAME]()
      || non[METHOD_NAME]() !== non
      || (PROPER_FUNCTION_NAME && whitespaces[METHOD_NAME].name !== METHOD_NAME);
  });
};


/***/ }),

/***/ "cf98":
/***/ (function(module, exports, __webpack_require__) {

"use strict";

module.exports = {
  IndexSizeError: { s: 'INDEX_SIZE_ERR', c: 1, m: 1 },
  DOMStringSizeError: { s: 'DOMSTRING_SIZE_ERR', c: 2, m: 0 },
  HierarchyRequestError: { s: 'HIERARCHY_REQUEST_ERR', c: 3, m: 1 },
  WrongDocumentError: { s: 'WRONG_DOCUMENT_ERR', c: 4, m: 1 },
  InvalidCharacterError: { s: 'INVALID_CHARACTER_ERR', c: 5, m: 1 },
  NoDataAllowedError: { s: 'NO_DATA_ALLOWED_ERR', c: 6, m: 0 },
  NoModificationAllowedError: { s: 'NO_MODIFICATION_ALLOWED_ERR', c: 7, m: 1 },
  NotFoundError: { s: 'NOT_FOUND_ERR', c: 8, m: 1 },
  NotSupportedError: { s: 'NOT_SUPPORTED_ERR', c: 9, m: 1 },
  InUseAttributeError: { s: 'INUSE_ATTRIBUTE_ERR', c: 10, m: 1 },
  InvalidStateError: { s: 'INVALID_STATE_ERR', c: 11, m: 1 },
  SyntaxError: { s: 'SYNTAX_ERR', c: 12, m: 1 },
  InvalidModificationError: { s: 'INVALID_MODIFICATION_ERR', c: 13, m: 1 },
  NamespaceError: { s: 'NAMESPACE_ERR', c: 14, m: 1 },
  InvalidAccessError: { s: 'INVALID_ACCESS_ERR', c: 15, m: 1 },
  ValidationError: { s: 'VALIDATION_ERR', c: 16, m: 0 },
  TypeMismatchError: { s: 'TYPE_MISMATCH_ERR', c: 17, m: 1 },
  SecurityError: { s: 'SECURITY_ERR', c: 18, m: 1 },
  NetworkError: { s: 'NETWORK_ERR', c: 19, m: 1 },
  AbortError: { s: 'ABORT_ERR', c: 20, m: 1 },
  URLMismatchError: { s: 'URL_MISMATCH_ERR', c: 21, m: 1 },
  QuotaExceededError: { s: 'QUOTA_EXCEEDED_ERR', c: 22, m: 1 },
  TimeoutError: { s: 'TIMEOUT_ERR', c: 23, m: 1 },
  InvalidNodeTypeError: { s: 'INVALID_NODE_TYPE_ERR', c: 24, m: 1 },
  DataCloneError: { s: 'DATA_CLONE_ERR', c: 25, m: 1 }
};


/***/ }),

/***/ "d933":
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(Buffer, module) {var __WEBPACK_AMD_DEFINE_FACTORY__, __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;var _classCallCheck = __webpack_require__("970b").default;
var _createClass = __webpack_require__("5bc3").default;
var _typeof = __webpack_require__("7037").default;
__webpack_require__("a4d3");
__webpack_require__("e01a");
__webpack_require__("944a");
__webpack_require__("d9e2");
__webpack_require__("4de4");
__webpack_require__("caad");
__webpack_require__("a15b");
__webpack_require__("d81d");
__webpack_require__("b0c0");
__webpack_require__("6c57");
__webpack_require__("0c47");
__webpack_require__("23dc");
__webpack_require__("b64b");
__webpack_require__("d3b7");
__webpack_require__("e6cf");
__webpack_require__("ac1f");
__webpack_require__("25f0");
__webpack_require__("466d");
__webpack_require__("5319");
__webpack_require__("159b");
__webpack_require__("c73d");
(function (p, m) {
  ( false ? undefined : _typeof(exports)) == "object" && ( false ? undefined : _typeof(module)) < "u" ? m(exports, __webpack_require__("3262")) :  true ? !(__WEBPACK_AMD_DEFINE_ARRAY__ = [exports, __webpack_require__("3262")], __WEBPACK_AMD_DEFINE_FACTORY__ = (m),
				__WEBPACK_AMD_DEFINE_RESULT__ = (typeof __WEBPACK_AMD_DEFINE_FACTORY__ === 'function' ?
				(__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__)) : __WEBPACK_AMD_DEFINE_FACTORY__),
				__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__)) : (undefined);
})(this, function (p, m) {
  "use strict";

  var V = Object.defineProperty;
  var J = function J(p, m, r) {
    return m in p ? V(p, m, {
      enumerable: !0,
      configurable: !0,
      writable: !0,
      value: r
    }) : p[m] = r;
  };
  var E = function E(p, m, r) {
    return J(p, _typeof(m) != "symbol" ? m + "" : m, r), r;
  };
  var _h = /*#__PURE__*/function () {
    function h() {
      _classCallCheck(this, h);
      this.basePath = "/".replace(/\/+$/, ""), this.authentications = {
        oauth2: {
          type: "oauth2"
        }
      }, this.defaultHeaders = {}, this.timeout = 6e4, this.cache = !0, this.enableCookies = !1, (typeof window === "undefined" ? "undefined" : _typeof(window)) > "u" && (this.agent = new m.agent()), this.requestAgent = null;
    }
    return _createClass(h, [{
      key: "paramToString",
      value: function paramToString(e) {
        return e == null || e == null ? "" : e instanceof Date ? e.toJSON() : e.toString();
      }
    }, {
      key: "buildUrl",
      value: function buildUrl(e, t) {
        var _this = this;
        e.match(/^\//) || (e = "/" + e);
        var o = this.basePath + e;
        return o = o.replace(/\{([\w-]+)\}/g, function (n, i) {
          var s;
          return t.hasOwnProperty(i) ? s = _this.paramToString(t[i]) : s = n, encodeURIComponent(s);
        }), o;
      }
    }, {
      key: "isJsonMime",
      value: function isJsonMime(e) {
        return !!(e != null && e.match(/^application\/json(;.*)?$/i));
      }
    }, {
      key: "jsonPreferredMime",
      value: function jsonPreferredMime(e) {
        for (var t = 0; t < e.length; t++) if (this.isJsonMime(e[t])) return e[t];
        return e[0];
      }
    }, {
      key: "isFileParam",
      value: function isFileParam(e) {
        if (true) {
          var t;
          try {
            t = __webpack_require__(12);
          } catch (_unused) {}
          if (t && t.ReadStream && e instanceof t.ReadStream) return !0;
        }
        return typeof Buffer == "function" && e instanceof Buffer || typeof Blob == "function" && e instanceof Blob || typeof File == "function" && e instanceof File;
      }
    }, {
      key: "normalizeParams",
      value: function normalizeParams(e) {
        var t = {};
        for (var o in e) if (e.hasOwnProperty(o) && e[o] != null && e[o] != null) {
          var n = e[o];
          this.isFileParam(n) || Array.isArray(n) ? t[o] = n : t[o] = this.paramToString(n);
        }
        return t;
      }
    }, {
      key: "buildCollectionParam",
      value: function buildCollectionParam(e, t) {
        if (e == null) return null;
        switch (t) {
          case "csv":
            return e.map(this.paramToString).join(",");
          case "ssv":
            return e.map(this.paramToString).join(" ");
          case "tsv":
            return e.map(this.paramToString).join("	");
          case "pipes":
            return e.map(this.paramToString).join("|");
          case "multi":
            return e.map(this.paramToString);
          default:
            throw new Error("Unknown collection format: " + t);
        }
      }
    }, {
      key: "applyAuthToRequest",
      value: function applyAuthToRequest(e, t) {
        var _this2 = this;
        t.forEach(function (o) {
          var n = _this2.authentications[o];
          switch (n.type) {
            case "basic":
              (n.username || n.password) && e.auth(n.username || "", n.password || "");
              break;
            case "apiKey":
              if (n.apiKey) {
                var i = {};
                n.apiKeyPrefix ? i[n.name] = n.apiKeyPrefix + " " + n.apiKey : i[n.name] = n.apiKey, n.in === "header" ? e.set(i) : e.query(i);
              }
              break;
            case "oauth2":
              n.accessToken && e.set({
                Authorization: "Bearer " + n.accessToken
              });
              break;
            default:
              throw new Error("Unknown authentication type: " + n.type);
          }
        });
      }
    }, {
      key: "deserialize",
      value: function deserialize(e, t) {
        if (e == null || e.status == 204) return null;
        var o = e.body;
        if ((o == null || _typeof(o) == "object" && _typeof(o.length) > "u" && !Object.keys(o).length) && (o = e.text), t == null && ["easc3"].includes("abp-account")) return {
          data: o
        };
        var n = _h.convertToType(o.data, t);
        return {
          code: o.code,
          data: n
        };
      }
    }, {
      key: "callApi",
      value: function callApi(e, t, o, n, i, s, c, u, l, y, F) {
        var _this3 = this;
        var z = this.buildUrl(e, o),
          f = m(t, z);
        this.applyAuthToRequest(f, u), t.toUpperCase() === "GET" && this.cache === !1 && (n._ = new Date().getTime()), f.query(this.normalizeParams(n)), f.set(this.defaultHeaders).set(this.normalizeParams(i)), this.requestAgent && f.agent(this.requestAgent), f.timeout(this.timeout);
        var C = this.jsonPreferredMime(l);
        if (C ? C != "multipart/form-data" && f.type(C) : f.header["Content-Type"] || f.type("application/json"), C === "application/x-www-form-urlencoded") f.send(_h.stringify(this.normalizeParams(s)));else if (C == "multipart/form-data") {
          var x = this.normalizeParams(s);
          for (var N in x) x.hasOwnProperty(N) && (this.isFileParam(x[N]) ? f.attach(N, x[N]) : f.field(N, x[N]));
        } else c && f.send(c);
        var k = this.jsonPreferredMime(y);
        return k && f.accept(k), F === "Blob" ? f.responseType("blob") : F === "String" && f.responseType("string"), this.enableCookies && ((typeof window === "undefined" ? "undefined" : _typeof(window)) > "u" ? this.agent.attachCookies(f) : f.withCredentials()), new Promise(function (G, q) {
          f.end(function (b, H) {
            if (b) q(b);else try {
              var L = _this3.deserialize(H, F);
              _this3.enableCookies && (typeof window === "undefined" ? "undefined" : _typeof(window)) > "u" && _this3.agent.saveCookies(H), G({
                data: L,
                response: H
              });
            } catch (K) {
              q(K);
            }
          });
        });
      }
    }], [{
      key: "parseDate",
      value: function parseDate(e) {
        return new Date(e);
      }
    }, {
      key: "convertToType",
      value: function convertToType(e, t) {
        if (e == null) return e;
        switch (t) {
          case "Boolean":
            return !!e;
          case "Integer":
            return parseInt(e, 10);
          case "Number":
            return parseFloat(e);
          case "String":
            return String(e);
          case "Date":
            return _h.parseDate(String(e));
          case "Blob":
            return e;
          default:
            if (t === Object) return e;
            if (typeof t == "function") return t.constructFromObject(e);
            if (Array.isArray(t)) {
              var o = t[0];
              return e.map(function (y) {
                return _h.convertToType(y, o);
              });
            } else if (_typeof(t) == "object") {
              var n, i;
              for (var s in t) if (t.hasOwnProperty(s)) {
                n = s, i = t[s];
                break;
              }
              var c = {};
              for (var s in e) if (e.hasOwnProperty(s)) {
                var u = _h.convertToType(s, n),
                  l = _h.convertToType(e[s], i);
                c[u] = l;
              }
              return c;
            } else return e;
        }
      }
    }, {
      key: "constructFromObject",
      value: function constructFromObject(e, t, o) {
        if (Array.isArray(e)) for (var n = 0; n < e.length; n++) e.hasOwnProperty(n) && (t[n] = _h.convertToType(e[n], o));else for (var i in e) e.hasOwnProperty(i) && (t[i] = _h.convertToType(e[i], o));
      }
    }, {
      key: "GetInstance",
      value: function GetInstance(e, t) {
        return Wiz ? Wiz.GetApiClientInstance(e, t) : new _h();
      }
    }, {
      key: "stringifyPrimitive",
      value: function stringifyPrimitive(e) {
        switch (_typeof(e)) {
          case "string":
            return e;
          case "boolean":
            return e ? "true" : "false";
          case "number":
            return isFinite(e) ? e : "";
          default:
            return "";
        }
      }
    }, {
      key: "stringify",
      value: function stringify(e, t, o, n) {
        return t = t || "&", o = o || "=", e === null && (e = void 0), _typeof(e) == "object" ? Object.keys(e).map(function (i) {
          var s = encodeURIComponent(_h.stringifyPrimitive(i)) + o;
          return Array.isArray(e[i]) ? e[i].map(function (c) {
            return s + encodeURIComponent(_h.stringifyPrimitive(c));
          }).join(t) : s + encodeURIComponent(_h.stringifyPrimitive(e[i]));
        }).filter(Boolean).join(t) : n ? encodeURIComponent(_h.stringifyPrimitive(n)) + o + encodeURIComponent(_h.stringifyPrimitive(e)) : "";
      }
    }]);
  }();
  var r = _h;
  E(r, "CollectionFormatEnum", {
    CSV: ",",
    SSV: " ",
    TSV: "	",
    PIPES: "|",
    MULTI: "multi"
  });
  var R = {
    _1: 1,
    _2: 2,
    _3: 3,
    _4: 4,
    _5: 5,
    constructFromObject: function constructFromObject(U) {
      return U;
    }
  };
  var g = /*#__PURE__*/function () {
    function g() {
      _classCallCheck(this, g);
    }
    return _createClass(g, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new g(), e.hasOwnProperty("result") && (t.result = R.constructFromObject(e.result)), e.hasOwnProperty("description") && (t.description = r.convertToType(e.description, "String"))), t;
      }
    }]);
  }();
  g.prototype.result = void 0, g.prototype.description = void 0;
  var I = /*#__PURE__*/function () {
    function I(e) {
      _classCallCheck(this, I);
      this.newPassword = e;
    }
    return _createClass(I, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new I(), e.hasOwnProperty("currentPassword") && (t.currentPassword = r.convertToType(e.currentPassword, "String")), e.hasOwnProperty("newPassword") && (t.newPassword = r.convertToType(e.newPassword, "String"))), t;
      }
    }]);
  }();
  I.prototype.currentPassword = void 0, I.prototype.newPassword = void 0;
  var a = /*#__PURE__*/function () {
    function a() {
      _classCallCheck(this, a);
    }
    return _createClass(a, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new a(), e.hasOwnProperty("extraProperties") && (t.extraProperties = r.convertToType(e.extraProperties, {
          String: Object
        })), e.hasOwnProperty("id") && (t.id = r.convertToType(e.id, "String")), e.hasOwnProperty("creationTime") && (t.creationTime = r.convertToType(e.creationTime, "Date")), e.hasOwnProperty("creatorId") && (t.creatorId = r.convertToType(e.creatorId, "String")), e.hasOwnProperty("lastModificationTime") && (t.lastModificationTime = r.convertToType(e.lastModificationTime, "Date")), e.hasOwnProperty("lastModifierId") && (t.lastModifierId = r.convertToType(e.lastModifierId, "String")), e.hasOwnProperty("isDeleted") && (t.isDeleted = r.convertToType(e.isDeleted, "Boolean")), e.hasOwnProperty("deleterId") && (t.deleterId = r.convertToType(e.deleterId, "String")), e.hasOwnProperty("deletionTime") && (t.deletionTime = r.convertToType(e.deletionTime, "Date")), e.hasOwnProperty("tenantId") && (t.tenantId = r.convertToType(e.tenantId, "String")), e.hasOwnProperty("userName") && (t.userName = r.convertToType(e.userName, "String")), e.hasOwnProperty("name") && (t.name = r.convertToType(e.name, "String")), e.hasOwnProperty("surname") && (t.surname = r.convertToType(e.surname, "String")), e.hasOwnProperty("email") && (t.email = r.convertToType(e.email, "String")), e.hasOwnProperty("emailConfirmed") && (t.emailConfirmed = r.convertToType(e.emailConfirmed, "Boolean")), e.hasOwnProperty("phoneNumber") && (t.phoneNumber = r.convertToType(e.phoneNumber, "String")), e.hasOwnProperty("phoneNumberConfirmed") && (t.phoneNumberConfirmed = r.convertToType(e.phoneNumberConfirmed, "Boolean")), e.hasOwnProperty("isActive") && (t.isActive = r.convertToType(e.isActive, "Boolean")), e.hasOwnProperty("lockoutEnabled") && (t.lockoutEnabled = r.convertToType(e.lockoutEnabled, "Boolean")), e.hasOwnProperty("lockoutEnd") && (t.lockoutEnd = r.convertToType(e.lockoutEnd, "Date")), e.hasOwnProperty("concurrencyStamp") && (t.concurrencyStamp = r.convertToType(e.concurrencyStamp, "String"))), t;
      }
    }]);
  }();
  a.prototype.extraProperties = void 0, a.prototype.id = void 0, a.prototype.creationTime = void 0, a.prototype.creatorId = void 0, a.prototype.lastModificationTime = void 0, a.prototype.lastModifierId = void 0, a.prototype.isDeleted = void 0, a.prototype.deleterId = void 0, a.prototype.deletionTime = void 0, a.prototype.tenantId = void 0, a.prototype.userName = void 0, a.prototype.name = void 0, a.prototype.surname = void 0, a.prototype.email = void 0, a.prototype.emailConfirmed = void 0, a.prototype.phoneNumber = void 0, a.prototype.phoneNumberConfirmed = void 0, a.prototype.isActive = void 0, a.prototype.lockoutEnabled = void 0, a.prototype.lockoutEnd = void 0, a.prototype.concurrencyStamp = void 0;
  var d = /*#__PURE__*/function () {
    function d() {
      _classCallCheck(this, d);
    }
    return _createClass(d, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new d(), e.hasOwnProperty("extraProperties") && (t.extraProperties = r.convertToType(e.extraProperties, {
          String: Object
        })), e.hasOwnProperty("userName") && (t.userName = r.convertToType(e.userName, "String")), e.hasOwnProperty("email") && (t.email = r.convertToType(e.email, "String")), e.hasOwnProperty("name") && (t.name = r.convertToType(e.name, "String")), e.hasOwnProperty("surname") && (t.surname = r.convertToType(e.surname, "String")), e.hasOwnProperty("phoneNumber") && (t.phoneNumber = r.convertToType(e.phoneNumber, "String")), e.hasOwnProperty("isExternal") && (t.isExternal = r.convertToType(e.isExternal, "Boolean")), e.hasOwnProperty("hasPassword") && (t.hasPassword = r.convertToType(e.hasPassword, "Boolean")), e.hasOwnProperty("concurrencyStamp") && (t.concurrencyStamp = r.convertToType(e.concurrencyStamp, "String"))), t;
      }
    }]);
  }();
  d.prototype.extraProperties = void 0, d.prototype.userName = void 0, d.prototype.email = void 0, d.prototype.name = void 0, d.prototype.surname = void 0, d.prototype.phoneNumber = void 0, d.prototype.isExternal = void 0, d.prototype.hasPassword = void 0, d.prototype.concurrencyStamp = void 0;
  var w = /*#__PURE__*/function () {
    function w(e, t, o, n) {
      _classCallCheck(this, w);
      this.userName = e, this.emailAddress = t, this.password = o, this.appName = n;
    }
    return _createClass(w, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new w(), e.hasOwnProperty("extraProperties") && (t.extraProperties = r.convertToType(e.extraProperties, {
          String: Object
        })), e.hasOwnProperty("userName") && (t.userName = r.convertToType(e.userName, "String")), e.hasOwnProperty("emailAddress") && (t.emailAddress = r.convertToType(e.emailAddress, "String")), e.hasOwnProperty("password") && (t.password = r.convertToType(e.password, "String")), e.hasOwnProperty("appName") && (t.appName = r.convertToType(e.appName, "String"))), t;
      }
    }]);
  }();
  w.prototype.extraProperties = void 0, w.prototype.userName = void 0, w.prototype.emailAddress = void 0, w.prototype.password = void 0, w.prototype.appName = void 0;
  var v = /*#__PURE__*/function () {
    function v() {
      _classCallCheck(this, v);
    }
    return _createClass(v, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new v(), e.hasOwnProperty("message") && (t.message = r.convertToType(e.message, "String")), e.hasOwnProperty("members") && (t.members = r.convertToType(e.members, ["String"]))), t;
      }
    }]);
  }();
  v.prototype.message = void 0, v.prototype.members = void 0;
  var P = /*#__PURE__*/function () {
    function P() {
      _classCallCheck(this, P);
    }
    return _createClass(P, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new P(), e.hasOwnProperty("code") && (t.code = r.convertToType(e.code, "String")), e.hasOwnProperty("message") && (t.message = r.convertToType(e.message, "String")), e.hasOwnProperty("details") && (t.details = r.convertToType(e.details, "String")), e.hasOwnProperty("data") && (t.data = r.convertToType(e.data, {
          String: Object
        })), e.hasOwnProperty("validationErrors") && (t.validationErrors = r.convertToType(e.validationErrors, [v]))), t;
      }
    }]);
  }();
  P.prototype.code = void 0, P.prototype.message = void 0, P.prototype.details = void 0, P.prototype.data = void 0, P.prototype.validationErrors = void 0;
  var B = /*#__PURE__*/function () {
    function B() {
      _classCallCheck(this, B);
    }
    return _createClass(B, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new B(), e.hasOwnProperty("error") && (t.error = P.constructFromObject(e.error))), t;
      }
    }]);
  }();
  B.prototype.error = void 0;
  var S = /*#__PURE__*/function () {
    function S(e, t) {
      _classCallCheck(this, S);
      this.resetToken = e, this.password = t;
    }
    return _createClass(S, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new S(), e.hasOwnProperty("userId") && (t.userId = r.convertToType(e.userId, "String")), e.hasOwnProperty("resetToken") && (t.resetToken = r.convertToType(e.resetToken, "String")), e.hasOwnProperty("password") && (t.password = r.convertToType(e.password, "String"))), t;
      }
    }]);
  }();
  S.prototype.userId = void 0, S.prototype.resetToken = void 0, S.prototype.password = void 0;
  var O = /*#__PURE__*/function () {
    function O(e, t) {
      _classCallCheck(this, O);
      this.email = e, this.appName = t;
    }
    return _createClass(O, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new O(), e.hasOwnProperty("email") && (t.email = r.convertToType(e.email, "String")), e.hasOwnProperty("appName") && (t.appName = r.convertToType(e.appName, "String")), e.hasOwnProperty("returnUrl") && (t.returnUrl = r.convertToType(e.returnUrl, "String")), e.hasOwnProperty("returnUrlHash") && (t.returnUrlHash = r.convertToType(e.returnUrlHash, "String"))), t;
      }
    }]);
  }();
  O.prototype.email = void 0, O.prototype.appName = void 0, O.prototype.returnUrl = void 0, O.prototype.returnUrlHash = void 0;
  var T = /*#__PURE__*/function () {
    function T() {
      _classCallCheck(this, T);
    }
    return _createClass(T, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new T(), e.hasOwnProperty("extraProperties") && (t.extraProperties = r.convertToType(e.extraProperties, {
          String: Object
        })), e.hasOwnProperty("userName") && (t.userName = r.convertToType(e.userName, "String")), e.hasOwnProperty("email") && (t.email = r.convertToType(e.email, "String")), e.hasOwnProperty("name") && (t.name = r.convertToType(e.name, "String")), e.hasOwnProperty("surname") && (t.surname = r.convertToType(e.surname, "String")), e.hasOwnProperty("phoneNumber") && (t.phoneNumber = r.convertToType(e.phoneNumber, "String")), e.hasOwnProperty("concurrencyStamp") && (t.concurrencyStamp = r.convertToType(e.concurrencyStamp, "String"))), t;
      }
    }]);
  }();
  T.prototype.extraProperties = void 0, T.prototype.userName = void 0, T.prototype.email = void 0, T.prototype.name = void 0, T.prototype.surname = void 0, T.prototype.phoneNumber = void 0, T.prototype.concurrencyStamp = void 0;
  var A = /*#__PURE__*/function () {
    function A(e, t) {
      _classCallCheck(this, A);
      this.userNameOrEmailAddress = e, this.password = t;
    }
    return _createClass(A, null, [{
      key: "constructFromObject",
      value: function constructFromObject(e, t) {
        return e && (t = t || new A(), e.hasOwnProperty("userNameOrEmailAddress") && (t.userNameOrEmailAddress = r.convertToType(e.userNameOrEmailAddress, "String")), e.hasOwnProperty("password") && (t.password = r.convertToType(e.password, "String")), e.hasOwnProperty("rememberMe") && (t.rememberMe = r.convertToType(e.rememberMe, "Boolean"))), t;
      }
    }]);
  }();
  A.prototype.userNameOrEmailAddress = void 0, A.prototype.password = void 0, A.prototype.rememberMe = void 0;
  var D = /*#__PURE__*/function () {
    function D(e) {
      _classCallCheck(this, D);
      this.apiClient = e || r.GetInstance("abp-account", "AccountApi");
    }
    return _createClass(D, [{
      key: "registerWithHttpInfo",
      value: function registerWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          o = {},
          n = {},
          i = e.header || {},
          s = {},
          c = ["oauth2"],
          u = ["application/json", "text/json", "application/_*+json"],
          l = ["text/plain", "application/json", "text/json"],
          y = a;
        return this.apiClient.callApi("/api/account/register", "POST", o, n, i, s, t, c, u, l, y);
      }
    }, {
      key: "register",
      value: function register(e) {
        return this.registerWithHttpInfo(e);
      }
    }, {
      key: "resetPasswordWithHttpInfo",
      value: function resetPasswordWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          o = {},
          n = {},
          i = e.header || {},
          s = {},
          c = ["oauth2"],
          u = ["application/json", "text/json", "application/_*+json"],
          l = ["text/plain", "application/json", "text/json"],
          y = e.returnType || null;
        return this.apiClient.callApi("/api/account/reset-password", "POST", o, n, i, s, t, c, u, l, y);
      }
    }, {
      key: "resetPassword",
      value: function resetPassword(e) {
        return this.resetPasswordWithHttpInfo(e);
      }
    }, {
      key: "sendPasswordResetCodeWithHttpInfo",
      value: function sendPasswordResetCodeWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          o = {},
          n = {},
          i = e.header || {},
          s = {},
          c = ["oauth2"],
          u = ["application/json", "text/json", "application/_*+json"],
          l = ["text/plain", "application/json", "text/json"],
          y = e.returnType || null;
        return this.apiClient.callApi("/api/account/send-password-reset-code", "POST", o, n, i, s, t, c, u, l, y);
      }
    }, {
      key: "sendPasswordResetCode",
      value: function sendPasswordResetCode(e) {
        return this.sendPasswordResetCodeWithHttpInfo(e);
      }
    }]);
  }();
  E(D, "Methods", {
    register: {
      method: "POST",
      path: "/api/account/register"
    },
    resetPassword: {
      method: "POST",
      path: "/api/account/reset-password"
    },
    sendPasswordResetCode: {
      method: "POST",
      path: "/api/account/send-password-reset-code"
    }
  });
  var M = /*#__PURE__*/function () {
    function M(e) {
      _classCallCheck(this, M);
      this.apiClient = e || r.GetInstance("abp-account", "LoginApi");
    }
    return _createClass(M, [{
      key: "checkPasswordWithHttpInfo",
      value: function checkPasswordWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          o = {},
          n = {},
          i = e.header || {},
          s = {},
          c = ["oauth2"],
          u = ["application/json", "text/json", "application/_*+json"],
          l = ["text/plain", "application/json", "text/json"],
          y = g;
        return this.apiClient.callApi("/api/account/check-password", "POST", o, n, i, s, t, c, u, l, y);
      }
    }, {
      key: "checkPassword",
      value: function checkPassword(e) {
        return this.checkPasswordWithHttpInfo(e);
      }
    }, {
      key: "loginWithHttpInfo",
      value: function loginWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          o = {},
          n = {},
          i = e.header || {},
          s = {},
          c = ["oauth2"],
          u = ["application/json", "text/json", "application/_*+json"],
          l = ["text/plain", "application/json", "text/json"],
          y = g;
        return this.apiClient.callApi("/api/account/login", "POST", o, n, i, s, t, c, u, l, y);
      }
    }, {
      key: "login",
      value: function login(e) {
        return this.loginWithHttpInfo(e);
      }
    }, {
      key: "logoutWithHttpInfo",
      value: function logoutWithHttpInfo() {
        var e = null,
          t = {},
          o = {},
          n = {},
          i = {},
          s = ["oauth2"],
          c = [],
          u = ["text/plain", "application/json", "text/json"],
          l = null;
        return this.apiClient.callApi("/api/account/logout", "GET", t, o, n, i, e, s, c, u, l);
      }
    }, {
      key: "logout",
      value: function logout() {
        return this.logoutWithHttpInfo();
      }
    }]);
  }();
  E(M, "Methods", {
    checkPassword: {
      method: "POST",
      path: "/api/account/check-password"
    },
    login: {
      method: "POST",
      path: "/api/account/login"
    },
    logout: {
      method: "GET",
      path: "/api/account/logout"
    }
  });
  var W = /*#__PURE__*/function () {
    function W(e) {
      _classCallCheck(this, W);
      this.apiClient = e || r.GetInstance("abp-account", "ProfileApi");
    }
    return _createClass(W, [{
      key: "changePasswordWithHttpInfo",
      value: function changePasswordWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          o = {},
          n = {},
          i = e.header || {},
          s = {},
          c = ["oauth2"],
          u = ["application/json", "text/json", "application/_*+json"],
          l = ["text/plain", "application/json", "text/json"],
          y = e.returnType || null;
        return this.apiClient.callApi("/api/account/my-profile/change-password", "POST", o, n, i, s, t, c, u, l, y);
      }
    }, {
      key: "changePassword",
      value: function changePassword(e) {
        return this.changePasswordWithHttpInfo(e);
      }
    }, {
      key: "getWithHttpInfo",
      value: function getWithHttpInfo() {
        var e = null,
          t = {},
          o = {},
          n = {},
          i = {},
          s = ["oauth2"],
          c = [],
          u = ["text/plain", "application/json", "text/json"],
          l = d;
        return this.apiClient.callApi("/api/account/my-profile", "GET", t, o, n, i, e, s, c, u, l);
      }
    }, {
      key: "get",
      value: function get() {
        return this.getWithHttpInfo();
      }
    }, {
      key: "updateWithHttpInfo",
      value: function updateWithHttpInfo(e) {
        e = e || {};
        var t = e.body,
          o = {},
          n = {},
          i = e.header || {},
          s = {},
          c = ["oauth2"],
          u = ["application/json", "text/json", "application/_*+json"],
          l = ["text/plain", "application/json", "text/json"],
          y = d;
        return this.apiClient.callApi("/api/account/my-profile", "PUT", o, n, i, s, t, c, u, l, y);
      }
    }, {
      key: "update",
      value: function update(e) {
        return this.updateWithHttpInfo(e);
      }
    }]);
  }();
  E(W, "Methods", {
    changePassword: {
      method: "POST",
      path: "/api/account/my-profile/change-password"
    },
    get: {
      method: "GET",
      path: "/api/account/my-profile"
    },
    update: {
      method: "PUT",
      path: "/api/account/my-profile"
    }
  }), p.AbpAbpLoginResult = g, p.AbpChangePasswordInput = I, p.AbpIdentityUserDto = a, p.AbpLoginResultType = R, p.AbpProfileDto = d, p.AbpRegisterDto = w, p.AbpRemoteServiceErrorInfo = P, p.AbpRemoteServiceErrorResponse = B, p.AbpRemoteServiceValidationErrorInfo = v, p.AbpResetPasswordDto = S, p.AbpSendPasswordResetCodeDto = O, p.AbpUpdateProfileDto = T, p.AbpUserLoginInfo = A, p.AccountApi = D, p.ApiClient = r, p.LoginApi = M, p.ProfileApi = W, Object.defineProperty(p, Symbol.toStringTag, {
    value: "Module"
  });
});
/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__("b639").Buffer, __webpack_require__("62e4")(module)))

/***/ }),

/***/ "dbb4":
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var $ = __webpack_require__("23e7");
var DESCRIPTORS = __webpack_require__("83ab");
var ownKeys = __webpack_require__("56ef");
var toIndexedObject = __webpack_require__("fc6a");
var getOwnPropertyDescriptorModule = __webpack_require__("06cf");
var createProperty = __webpack_require__("8418");

// `Object.getOwnPropertyDescriptors` method
// https://tc39.es/ecma262/#sec-object.getownpropertydescriptors
$({ target: 'Object', stat: true, sham: !DESCRIPTORS }, {
  getOwnPropertyDescriptors: function getOwnPropertyDescriptors(object) {
    var O = toIndexedObject(object);
    var getOwnPropertyDescriptor = getOwnPropertyDescriptorModule.f;
    var keys = ownKeys(O);
    var result = {};
    var index = 0;
    var key, descriptor;
    while (keys.length > index) {
      descriptor = getOwnPropertyDescriptor(O, key = keys[index++]);
      if (descriptor !== undefined) createProperty(result, key, descriptor);
    }
    return result;
  }
});


/***/ }),

/***/ "e0c9":
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var ERROR_CODES = ['ECONNRESET', 'ETIMEDOUT', 'EADDRINFO', 'ESOCKETTIMEDOUT'];

/**
 * Determine if a request should be retried.
 * (Borrowed from segmentio/superagent-retry)
 *
 * @param {Error} err
 * @param {Response} [res]
 * @returns {Boolean}
 */
module.exports = function shouldRetry(err, res) {
  if (err && err.code && ~ERROR_CODES.indexOf(err.code)) return true;
  if (res && res.status && res.status >= 500) return true;
  // Superagent timeout
  if (err && 'timeout' in err && err.code == 'ECONNABORTED') return true;
  if (err && 'crossDomain' in err) return true;
  return false;
};

/***/ }),

/***/ "e439":
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var $ = __webpack_require__("23e7");
var fails = __webpack_require__("d039");
var toIndexedObject = __webpack_require__("fc6a");
var nativeGetOwnPropertyDescriptor = __webpack_require__("06cf").f;
var DESCRIPTORS = __webpack_require__("83ab");

var FORCED = !DESCRIPTORS || fails(function () { nativeGetOwnPropertyDescriptor(1); });

// `Object.getOwnPropertyDescriptor` method
// https://tc39.es/ecma262/#sec-object.getownpropertydescriptor
$({ target: 'Object', stat: true, forced: FORCED, sham: !DESCRIPTORS }, {
  getOwnPropertyDescriptor: function getOwnPropertyDescriptor(it, key) {
    return nativeGetOwnPropertyDescriptor(toIndexedObject(it), key);
  }
});


/***/ })

}]);